/*
 * @(#) BundleGroup.java 98/11/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.GUI;
 
import java.net.URL;
import java.util.*;
import java.net.URLConnection;
import java.awt.Font;

/**
 * Store all reousrce bundles
 * 
 * @author Jimmy Liang
 * @version 1.00 12/23/98
 */

public class BundleGroup extends Object {
	public static ResourceBundle property;
	public static Font defaultFont = new Font("Dialog",Font.PLAIN,10);
	public static Font bigFont = new Font("Dialog",Font.PLAIN,16);
	public static Font boldFont = new Font("Dialog",Font.BOLD,10);
	public static Font bigBoldFont = new Font("Dialog",Font.BOLD,16);
	public static Font reallyBigFont = new Font("Dialog",Font.PLAIN,22);
	public static Font reallyBigBoldFont = new Font("Dialog",Font.BOLD,22);

	public static BundleGroup current = new BundleGroup();
	private static boolean isApplet = false;
	private static URL serverURL = null;

	public static void setProperty()
	{
		try {
			//URL url = new URL("http://www.csis.hku.hk/~zyliang/Jessic.properties");
			URL url = current.getClass().getResource("Jessic.properties");
			System.out.println("contact server...");
			URLConnection connect = url.openConnection();
			System.out.println("Creating tcp connection to server...");
			property = new PropertyResourceBundle(connect.getInputStream());
			System.out.println("Tcp connection to information server created");	
		}catch(Exception mre) {
			System.out.println("Jessic.properties not found:"+mre.toString());
			System.exit(1);
		}
	}

	public static void setProperty(URL url )
	{
		try {
			System.out.println("contact server...");
			URLConnection connect = url.openConnection();
			System.out.println("Creating tcp connection to server...");
			property = new PropertyResourceBundle(connect.getInputStream());
			System.out.println("Tcp connection to information server created");	
			isApplet = true;
			serverURL = url;
		}catch(Exception mre) {
			System.out.println("Jessic.properties not found:"+mre.toString());
			System.exit(1);
		}
	}

	public static URL getResource(String key) {
		String name = getResourceString(key);
		if (!isApplet)
		{
			if (name!=null) {
				URL url = current.getClass().getResource(name);
				return url;
			}
		}
		else {
			if (name!=null) {
				String imageLocation = "http://"+serverURL.getHost()+"/"+name;
				System.out.println(imageLocation);
				try {
				return new URL(imageLocation);
				}catch(Exception e){};
			}
		}
		return null;
	}

	public static String getResourceString(String key) {
		String str;
		try {
		str = property.getString(key);
		}catch(Exception mre) {
			str = null;
		}
		return str;
	}
}
