/*
 * @(#) CServer.java 99/5/6
 */

package CLUSTERPROBE.Server;
 
import java.util.EventListener;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Calendar;
import java.net.Socket;
import java.io.*;
import CLUSTERPROBE.message.EventTransceiver;
import CLUSTERPROBE.message.ResourceRefreshEvent;
import CLUSTERPROBE.message.EventHandler;
import CLUSTERPROBE.message.JessicEvent;
import CLUSTERPROBE.message.ResourceRegistryEvent;
import CLUSTERPROBE.message.EventTransceiver;
import CLUSTERPROBE.message.ResourceTableData;
import CLUSTERPROBE.resources.Util;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.ResourceTable;

/**
 * This class acts as a server for client written by C.  
 *
 * @author Jimmy Liang
 * @version 1.00 5/6/99
 */

public class CServer extends ManageServer
{

public static Hashtable requestTable = new Hashtable();
public static Hashtable rsCount = new Hashtable();
public static EventHandler h;
boolean DebugFlag = true;

	public CServer(int port) {
		super(port);
		addLocalObservers();
	}
	
	public void addLocalObservers()
	{
		h = new EventHandler() 
		{
			public synchronized void handleEvent(JessicEvent evt) 
			{
				if (evt.getId()==JessicEvent.REFRESH)
				{
					System.out.println("in CServer:Get JessicEvent.REFRESH");
					try {
					ResourceRefreshEvent event = (ResourceRefreshEvent) evt;
					Enumeration en = requestTable.keys();
					while (en.hasMoreElements())
					{
						CTransceiver tran = (CTransceiver) en.nextElement();
						Vector vt = (Vector) requestTable.get(tran);

						for (int i=0;i<vt.size();i++)
						{
							Vector dt = event.getData((String)vt.elementAt(i));
							Resource rs = Util.getResource((String)vt.elementAt(i));
							if (dt!=null) 
								tran.send(rs,(String)event.getLocation(),dt,event.isFinalOne());
						}

					}
					}catch(Exception e) {e.printStackTrace();};
				}
			}
		};
	}
			

	public void processConnection(Socket s) {
		try {
			System.out.println("CServer:Establish a connection with a client,in CServer's processConnection");
			CTransceiver tran = new CTransceiver(s.getInputStream(),s.getOutputStream());
			requestTable.put(tran,new Vector());
		}catch(Exception e) {
			System.out.println("Connect Error:"+e.toString());
		}
		System.out.println("Will be out of CServer Thread.");
	};

}

class CTransceiver extends Thread
{

// Our connection o a remove agent
InputStream evIn = null;
OutputStream evOut = null;
final static short BEGIN = 111;
final static short NEXT = 221;
final static short END = 222;

	public CTransceiver(InputStream in, OutputStream out) {
		setStreams(in,out);
		start();
	}

	void setStreams(InputStream in, OutputStream out)
	{
		evIn = in;
		evOut = out;
	}

	public OutputStream getOutputStream()
	{
		return evOut;
	}

	public InputStream getInputStream()
	{
		return evIn;
	}

	public void disconnect() {
		try {
		if (evIn!=null) evIn.close();
		if (evOut!=null) evOut.close();
		}catch(Exception e) {};
	}
	
	public void run() {
		boolean DebugFlag = true;
		if(DebugFlag) System.out.println("In CServer Thread...");
		try {
			DataInputStream in = new DataInputStream(getInputStream());
			DataOutputStream out = new DataOutputStream(getOutputStream());

			while (true) {
					short type = in.readShort();
					short id = in.readShort();

					String rn = Resource.getNameFromID(id);
					if (rn!=null)
						handleEvent(type,rn);
			}
		}catch(Exception ex) {ex.printStackTrace();};
		if(DebugFlag) System.out.println("End of CServer Thread.");
	}

  
     void initOut(DataOutputStream out) throws Exception 
	{
		out.writeShort(BEGIN);	
	}	

	synchronized void handleEvent(short type, String rn)
	{
		boolean DebugFlag = true;
		try {
		Vector vt = (Vector) CServer.requestTable.get(this);

		switch (type)
		{
		case ResourceRegistryEvent.REGISTER:
//System.out.println("ADD OBSERVER FOR "+rn);
			if(DebugFlag) System.out.println("In CServer/CTransceiver : Get ResourceRegistryEvent.REGISTER");
			if (!vt.contains(rn))
				vt.addElement(rn);

			if (CServer.rsCount.contains(rn))
			{
				int count = ((Integer)CServer.rsCount.get(rn)).intValue();
				count++;
				CServer.rsCount.put(rn,new Integer(count));
			}
			else 
			{
				CServer.rsCount.put(rn,new Integer(1));
				Util.addLocalHandler(CServer.h,rn);
			}

			sendInitValue(rn);
			break;
		case ResourceRegistryEvent.UNREGISTER:
			if(DebugFlag) System.out.println("In CServer/CTransceiver : Get ResourceRegistryEvent.UNREGISTER");
			Enumeration en = vt.elements();
			while(en.hasMoreElements())
			{
				String obj = (String) en.nextElement();
				if (obj.equals(rn)||rn.equals("ALLRESOURCES"))
				{
//System.out.println("REMOVE OBSERVER FOR "+obj);
					vt.removeElement(obj);
					Util.removeRegister(obj);
					if (CServer.rsCount.contains(rn))
					{
						int count = ((Integer)CServer.rsCount.get(rn)).intValue();
						count--;
						if (count!=0)
							CServer.rsCount.put(rn,new Integer(count));
						else
						{
							CServer.rsCount.remove(rn);
							Util.removeLocalHandler(CServer.h,rn);
						}
					}
				}
			}
			break;
		case ResourceRegistryEvent.GETCURRENTVALUE:
			if(DebugFlag) System.out.println("In CServer/CTransceiver : Get ResourceRegistryEvent.GETCURRENTVALUE");
			sendCurrentValue(rn);
			break;
		case ResourceRegistryEvent.UPDATED:
			if(DebugFlag) System.out.println("In CServer/CTransceiver : Get ResourceRegistryEvent.UPDATED");
			updateValue(rn);
			break;
		}
						
		}catch(Exception ex) {
			System.out.println("Resource Registry Error:"+ex.toString());
		}
	} 

	public void sendInitValue(String rn)
	{
	try {
		// here to startup resource object	
		Resource rs;

		if (!Util.contains(rn))
		{
//System.out.println("instance class :"+rn);
			rs = (Resource) Util.instanceClass(rn);
//System.out.println("Start object :"+rn);
			rs.start();	
			Util.addResource(rs);
		}	
		else
		{
			rs = Util.getResource(rn);
			Util.addRegister(rn);
		}

		Vector v = rs.packRefreshedValue();

		Enumeration events = v.elements();
		while (events.hasMoreElements())
		{
			ResourceRefreshEvent evt = (ResourceRefreshEvent) events.nextElement();
			send(rs,(String)evt.getLocation(),evt.getData(rn),evt.isFinalOne());
		}
	}catch(Exception ex) {
		System.out.println("Getting Initiate value of resource "+rn+" ocurres error:"+ex.toString());
	};

	}

	public void sendCurrentValue(String rn)
	{
		
	try {
		// here to startup resource object	
		Resource rs;

		if (!Util.contains(rn))
		{
			rs = (Resource) Util.instanceClass(rn);
		}	
		else
		{
			rs = Util.getResource(rn);
		}

		Vector v = rs.packRefreshedValue();
		Enumeration events = v.elements();

		while (events.hasMoreElements())
		{
			ResourceRefreshEvent evt = (ResourceRefreshEvent) events.nextElement();
			send(rs,(String)evt.getLocation(),evt.getData(rn),evt.isFinalOne());
		}
	}catch(Exception ex) {
		System.out.println("Getting current value of resource "+rn+" ocurres error:"+ex.toString());
		ex.printStackTrace();
	};
	}	

	public void updateValue(String rn)
	{
		
		// here to startup resource object	
		Resource rs;

		try {
		if (!Util.contains(rn))
		{
			rs = (Resource) Util.instanceClass(rn);
		}	
		else
		{
			rs = Util.getResource(rn);
		}
		}catch(Exception e0){
			System.out.println("Error while get resource object:"+e0);
			return;
		}

		Vector v = rs.packRefreshedValue();
		if (v==null)
		{
			return;
		}
		Enumeration events = v.elements();

		try {
		// Send events to local observers
		Vector hds = Util.getHandlers(rn);
		if (hds!=null)
		{
			while (events.hasMoreElements())
			{
				JessicEvent eo = (JessicEvent) events.nextElement();
				Enumeration handlers = hds.elements();
				while (handlers.hasMoreElements())
				{
					EventHandler handler = (EventHandler) handlers.nextElement();
					handler.handleEvent(eo);
				}
			}
		}
		}catch(Exception e1) {
			System.out.println("Error while sending events to local observers:"+e1);
		};

		// Send events to remote observers
		try {
		Enumeration en = Util.registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver transceiver = (EventTransceiver) en.nextElement();
			Vector vt = (Vector) Util.registryTable.get(transceiver);
			Enumeration registers = vt.elements();
			while (registers.hasMoreElements())
			{
				ResourceRegistryEvent reg = (ResourceRegistryEvent) registers.nextElement();
				if (rn.equals(reg.getName()))
				{
					try {
					transceiver.sendEvents(v);
					break;
					}catch(IOException ex) {
						Util.registryTable.remove(transceiver);
						Util.removeRegister(reg.getName());
					}
				}
			}
		}
		}catch(Exception e2) {
			System.out.println("Error while sending events to remote observers"+e2);
		}

		rs.setRefreshedTime(Calendar.getInstance().getTime());
	}	
	
	public synchronized void send(Resource rs, String s, Vector vt, boolean f)
	{
		try {
			DataOutputStream out = new DataOutputStream(getOutputStream());

			// write the begin indicator
			initOut(out);
			out.writeShort(BEGIN);
			out.flush();

			//write resource id
			short id = Resource.getIDFromName(rs.getResourceName());
			out.writeShort(id);
			out.flush();

			//write the location 
			writeString(out,s);		
			out.flush();

			//write length of vector
			out.writeShort(vt.size());
			out.flush();
			
			for (int i=0;i<vt.size();i++)
			{
				int location = vt.size()-1-i;
				try{
				ResourceTableData data = (ResourceTableData) vt.elementAt(location);
				writeRecord(rs,out,data);
				}catch(Exception exp) {
						exp.printStackTrace();
				}	
			}

			if (f)
				out.writeShort(END);
			else
				out.writeShort(NEXT);
			out.flush();

		}catch(Exception ee){
			handleEvent((short)ResourceRegistryEvent.UNREGISTER,"ALLRESOURCES");
			System.out.println(ee);
		}
	}

	void writeString(DataOutputStream out, String s) throws Exception
	{
		short count = 0;
		if (s==null)
		{
			out.writeShort(count);
			return;
		}
		
		count = (short)s.trim().length();
		out.writeShort(count);
		out.writeBytes(s);
	}
	
	void writeRecord(Resource rs, DataOutputStream out, ResourceTableData data) throws Exception
	{

		ResourceTable rt = (ResourceTable) rs;
		Vector vt = data.getRecord();
		
		for (int i=0;i<vt.size();i++)
		{
			switch (rt.getType(i))
			{
			case Resource.SHORT:
				short sv = ((Integer)(vt.elementAt(i))).shortValue();
				out.writeShort(sv);
				out.flush();
				break;
			case Resource.LONG:
				int lv = ((Long)(vt.elementAt(i))).intValue();
				out.writeInt(lv);
				out.flush();
				break;
			case Resource.STRING:
				writeString(out,(String)(vt.elementAt(i)));
				out.flush();
				break;
			case Resource.BOOLEAN:
				boolean bv = ((Boolean)(vt.elementAt(i))).booleanValue();
				if (bv)
					out.writeShort(1);
				else
					out.writeShort(0);
				out.flush();
				break;
			case Resource.FLOAT:
				float fv = ((Float)(vt.elementAt(i))).floatValue();
				out.writeInt(Float.floatToIntBits(fv));
				out.flush();
				break;
			case Resource.DOUBLE:
				float fv0 = ((Double)(vt.elementAt(i))).floatValue();
				out.writeInt(Float.floatToIntBits(fv0));
				out.flush();
				break;
			default:
				break;
			}
		}
	}
}
