/*
 * @(#) ManageServer.java 99/1/6
 */

package CLUSTERPROBE.Server;
 
import java.util.EventListener;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.IOException;
import CLUSTERPROBE.message.EventTransceiver;
import CLUSTERPROBE.resources.*;

/**
 * This class run as a deamon on the management server which responsible to
 * establish and maintainconnection with client. And for each connect, a thread
 * will be started to receive , process request package from the client of the c * connection, and also forwards the corresponding events to client.
 */

public class ManageServer extends Thread 
{
	ServerSocket server = null;

	public ManageServer(int port) {
		try {
		System.out.println("Bound port: "+port);
		server = new ServerSocket(port);
		}catch(IOException e) {
			System.out.println("Error when run server deamon:"+e.toString());
			System.exit(-1);
		}
	}
	
	public void run() {
		Socket client = null;
		while (true) 
		{
			try {
				System.out.println(server.getLocalPort());
				client = server.accept();
				System.out.println("server accept");
			}catch(IOException e) {
				System.out.println("I/O exception occured when waiting for connecting: "+e.toString());
				System.exit(-1);
			}
			if (client==null) continue;
			processConnection(client);
		}
	}

	// do nothing when establish a connection
	public void processConnection(Socket s) {};

	public static void main(String[] args)
	{
	     System.setSecurityManager(new CLUSTERPROBE.resources.MySecurityManager());

		MonitorServer ms = new MonitorServer(7002);
		System.out.println("MonitorServer on 7002");
		ms.start();
		ResourceServer rs = new ResourceServer(7001);
		System.out.println("ResourceServer on 7001");
		rs.start();
		CServerII cs = new CServerII(7006);
		System.out.println("CServerII on 7006");
		cs.start();

// Start a resource
}

}
			
