/*
 * Get the cluster information with pull mechanism
*/
#include "local.h"

extern u_short getResource();
void readRecord(int,struct resource_info,struct cell*);

int push(char* server, u_short rid)
{
  int             orig_sock;  /* Original socket descriptor in client */
  struct sockaddr_in
                  serv_adr;   /* Internet address of server           */    
  struct hostent  *host;      /* The Host (server)                    */
  struct reg_packet reg;        /* register info                      */
  u_short type, indicator, count, len, id;	
  char c;
  int i;
  char buf[256];
  struct table *tb_ptr;    /* tables which store data values     */
  int tables_num = 0;       /* No. of tables                      */
  struct resource_info info;    /* resource information               */
  struct cell *cell_ptr, *last_ptr;        /* cell point                         */


  host = gethostbyname(server);            /* Get the host info      */
  if (host==(struct hostent *)NULL) {
    perror("gethostbyname:");
    return -2;
  } 

  memset(&serv_adr,0,sizeof(serv_adr));     /* Clear the structure    */
  serv_adr.sin_family = AF_INET;            /* Set address type       */
  memcpy(&serv_adr.sin_addr,host->h_addr,host->h_length);  /* Adr     */
  //serv_adr.sin_port = htons(PORT);          /* Use our fake port      */
  serv_adr.sin_port = htons(MON_PORT);          /* Use our fake port      */
  
  if ((orig_sock=socket(AF_INET,SOCK_STREAM,0))<0) {  /* SOCKET       */
    perror("generate error:");
    return -3;
  }
/* CONNECT                                                            */  
  if (connect(orig_sock,(struct sockaddr*)&serv_adr,sizeof(serv_adr))<0) {
    perror("connect error:");
    return -4;
  }

  //reg.type =  htons(GET_CURRENT_VALUE);
  reg.type =  htons(MONITOR_DATA);
  reg.id = htons(rid);
  //reg.id = htons(IPSTAT);
  //reg.id = htons(STATUS);
  write(orig_sock,&reg,sizeof(reg));
  
  while (1)
  {
    bzero(buf,sizeof(buf));
    read(orig_sock,&indicator,sizeof(indicator));
    indicator = htons(indicator);
    if (indicator != BEGIN)
      read(orig_sock,&c,sizeof(c));
    readRecord(orig_sock,info,cell_ptr); 
  }
  close(orig_sock);
}

void readRecord(int orig_sock, struct resource_info info, struct cell* cell_ptr)
{
  int i;
  u_short svalue;
  long int lvalue;
  float* fvalue;
  char buf[256];
  char* pbuf;
  struct cell *first, *prev; 
  int rcount,pos;
 
  first = cell_ptr;
  prev = cell_ptr;

  for (i=0;i<info.value_num;i++)
  {
     if (i!=0)
     {
       cell_ptr = malloc(sizeof(struct cell));
       cell_ptr->row = first->row;
       cell_ptr->column = i;
       prev->next_column = cell_ptr;
       prev = cell_ptr;
     }
     cell_ptr->value_type = info.value_type[i];

//fprintf(stderr, "the type is %d\n",info.value_type[i]);
     switch (info.value_type[i])
     {
       case SHORT:
         read(orig_sock,&svalue,sizeof(svalue));
         svalue = htons(svalue);
         cell_ptr->value = malloc(sizeof(u_short));
         memcpy(cell_ptr->value,&svalue,sizeof(u_short));
         //fprintf(stderr,"%d   ",svalue);
         break;
       case LONG:
         read(orig_sock,&lvalue,sizeof(lvalue));
         lvalue = htonl(lvalue);
         cell_ptr->value = malloc(sizeof(lvalue));
         memcpy(cell_ptr->value,&lvalue,sizeof(lvalue));
         //fprintf(stderr,"%ld   ",lvalue);
         break;
       case BOOLEAN:
         read(orig_sock,&svalue,sizeof(svalue));
         svalue = htons(svalue);
         cell_ptr->value = malloc(sizeof(u_short));
         memcpy(cell_ptr->value,&svalue,sizeof(u_short));

/*
         if (svalue==0)
           fprintf(stderr,"false   ");
         else
           fprintf(stderr,"true   "); 
*/
         break;
       case STRING:
	 rcount = 0;
	 pbuf = (char*) &svalue;
	 pos = sizeof(svalue);
	 while (1)
	 {
           rcount = read(orig_sock,pbuf,pos);
	   if (rcount == pos)
	     break;
	    pbuf = pbuf + rcount;
            pos = pos - rcount;
         }
         svalue = htons(svalue);

//fprintf(stderr,"svalue %d %d\n",svalue,rcount);
         if (svalue==0)
           ;//fprintf(stderr,"NULL   ");
         else
         {
           cell_ptr->value = malloc(svalue+1);
           bzero(buf,sizeof(buf));
           bzero(cell_ptr->value,svalue+1);
	   pbuf = buf;
	   pos = svalue;
           rcount = 0;
           while (1)
           {
             rcount = read(orig_sock,pbuf,pos);
 	     if (rcount==pos) 
	       break;
	     pbuf = pbuf + rcount;
             pos = pos - rcount;
           }
           memcpy(cell_ptr->value,buf,svalue+1);
           //fprintf(stderr,"%s  %d\n",buf,rcount);
         }
         break;
       case FLOAT:
       case DOUBLE:
	 pos = sizeof(lvalue);
	 pbuf = (char*)&lvalue;
	 rcount = 0;
	 while (1)
	 {
           rcount = read(orig_sock,pbuf,pos);
	   if (rcount == pos)
	     break;
	   pbuf = pbuf + rcount;
	   pos = pos - rcount;
	 }
         lvalue = htonl(lvalue);
         fvalue = (float*)&lvalue;
         cell_ptr->value = malloc(sizeof(float));
         memcpy(cell_ptr->value,fvalue,sizeof(float));
         //fprintf(stderr,"%f  %d\n",*fvalue,rcount);
         break;
       default:
         break;
     }
 }
 prev->next_column = first;

 //fprintf(stderr,"\n");
 }
           
void printTable(struct table* tb_ptr)
{
  struct cell* row_ptr, *cell_ptr;
  u_short i,j;

  row_ptr = tb_ptr->header;

fprintf(stderr,"row is %d, column is %d\n",tb_ptr->rows_num,tb_ptr->columns_num);

  if (tb_ptr->tableSource!=NULL)
  {
    fprintf(stderr,"%s\n",tb_ptr->tableSource);
    fprintf(stderr,"--------------\n");
  }

  for (i=0;i<tb_ptr->rows_num;i++)
  {
    if (i!=0)
      row_ptr = row_ptr->next_row;
    cell_ptr = row_ptr;

    for (j=0;j<tb_ptr->columns_num;j++)
    {
      if (j!=0)
       cell_ptr = cell_ptr->next_column; 
       printCell(cell_ptr);
    }
    fprintf(stderr,"\n");
  }    
 
  fprintf(stderr,"\n");
}

void printCell(struct cell* cell_ptr)
{
  u_short* svalue;

  switch(cell_ptr->value_type)
  {
    case SHORT:
      fprintf(stderr,"%d  ",*((u_short*)cell_ptr->value));
      break;
    case LONG:
      fprintf(stderr,"%ld  ",*((long int*)cell_ptr->value));
      break;
    case BOOLEAN:
      svalue = (u_short *) cell_ptr->value;
      if ((*svalue)!=0)
        fprintf(stderr,"False  ");
      else    
        fprintf(stderr,"True  ");
      break;
    case DOUBLE:
    case FLOAT:
      fprintf(stderr,"%f  ",*((float*)cell_ptr->value));
      break;
    case STRING:
      fprintf(stderr,"%s  ",(char*)cell_ptr->value);
      break;
    default:
      break;
  }
}

         

           
    
  
	    
