#include "local.h"

static char* node_desc[] = {"Device ID","Workstation Name","Workstation Alias","Primary Group","Memo","Device Type","Location"};
static int node_type[] = {SHORT,STRING,STRING,STRING,STRING,SHORT,STRING};

static char* group_desc[] = {"Group Name","Group Description","Server"};
static int group_type[] = {STRING,STRING,STRING};

static char* job_desc[] = {"User Name","Job Name","Job Number", "Job Priority", "Stat","Exec_Hosts","Submit Time"};
static int job_type[] = {STRING,STRING,SHORT,STRING,STRING,STRING,STRING};

static char* queue_desc[] = {"Queue Name", "Queue Type", "Quan","Load", "State"};
static int queue_type[] = {STRING,STRING,STRING,FLOAT,STRING};

static char* status_desc[] = {"WorkstationName","State","Description","Load1","Load2","Load3"};
static int status_type[] = {STRING,SHORT,STRING,FLOAT,FLOAT,FLOAT};

static char* systemlog_desc[] = {"Log ID","Priority","Date","Source","Daemon","Description"};
static int systemlog_type[] = {SHORT,STRING,STRING,STRING,STRING,STRING};

static char* deviceinfo_desc[] = {"Device Name","Type","Major No.l"};
static int deviceinfo_type[] = {STRING,STRING,SHORT};

static char* diskinfo_desc[] = {"Device Name", "Boot", "Begin","Start", "End","Blocks","Incrementable","Id","System"};
static int diskinfo_type[] = {STRING,BOOLEAN,LONG,LONG,LONG,LONG,BOOLEAN,SHORT,STRING};

static char* export_desc[] =  {"Exported fs","Opts"};
static int export_type[] = {STRING,STRING};

static char* fstable_desc[] = {"fs_spec","fs_file","fs_vfstype","fs_mntops","fs_freq","fs_passno"};
static int  fstable_type[] = {STRING,STRING,STRING,STRING,SHORT,SHORT};

static char* ioport_desc[] = {"IO Address","Device Name"};
static int ioport_type[] = {STRING,STRING};

static char* kernelsymbol_desc[]  = {"Address","Symbol","Defined by"};
static int kernelsymbol_type[] = {STRING,STRING,STRING};

static char* module_desc[] = {"Module Name","Pages","Used by"};
static int module_type[] = {STRING,SHORT,STRING};

static char* nicinfo_desc[]  = {"Interface Name", "Link enacap", "HW addr","Inet addr", "Bcast","Mask","State","MTU","Metric","Interrupt","Base addr"};
static int nicinfo_type[] = {STRING,STRING,STRING,STRING,STRING,STRING,STRING,SHORT,SHORT,SHORT,STRING};

static char* user_desc[] = {"Login Name","UID","GID","Description","Home dir","Init program"};
static int user_type[] = {STRING,SHORT,SHORT,STRING,STRING,STRING};

static char* version_desc[] = {"WorkstationName","OS Name","OS release","OS version","Machine Type"};
static int version_type[] = {STRING,STRING,STRING,STRING,STRING};

static char* cpuinfo_desc[] = {"processor","cpu","model","vendor_id","stepping","fdiv_bug","hlt_bug","fpu","cpuid","wp","bogomips"};
static int cpuinfo_type[] = {SHORT,STRING,STRING,STRING,STRING,BOOLEAN,BOOLEAN,BOOLEAN,BOOLEAN,BOOLEAN,FLOAT};

static char* cpustate_desc[] = {"CPU Name","User","System","Nice","Idle"};
static int cpustate_type[] = {STRING,LONG,LONG,LONG,LONG};

static char* cputemp_desc[] = {"CPU Name","CPU Temperature"};
static int cputemp_type[]  = {STRING,SHORT};

static char* fanspeed_desc[] =  {"Fan Name","Fan Speed"};
static int fanspeed_type[] = {STRING,SHORT};

static char* logininfo_desc[] = {"User", "TTY", "From","Login Time", "Idle","JCPU","PCPU","What"};
static int logininfo_type[] = {STRING,STRING,STRING,STRING,STRING,STRING,STRING,STRING};

static char* memstate_desc[] = {"Host Name","MemTotal","MemUsed","MemFree","MemShared","Buffers","Cached"};
static int memstate_type[] = {STRING,LONG,LONG,LONG,LONG,LONG,LONG};

static char* processinfo_desc[] =  {"PID", "User", "%CPU","%MEM", "Size","RSS","TTY","Stat","Start","Time","Command"};
static int processinfo_type[] = {LONG,STRING,FLOAT,FLOAT,LONG,LONG,STRING,STRING,STRING,STRING,STRING};

static char* arp_desc[] = {"IP Address","HW type","Flags","HW address","Mask","Iface"};
static int arp_type[] = {STRING,STRING,STRING,STRING,STRING,STRING};

static char* route_desc[] =  {"Destination", "Gateway", "Genmask","Flags", "Metric","Ref","Use","Iface"};
static int route_type[] = {STRING,STRING,STRING,STRING,SHORT,SHORT,SHORT,STRING};

static char* connect_desc[] =  {"Connection ID", "Protocol", "Recv_Q","Send_Q", "Local addr.","Foreign addr.","State"};
static int connect_type[] = {SHORT,STRING,SHORT,SHORT,STRING,STRING,STRING};

static char* ipstat_desc[] =  {"Host Name","Forwarding","DefaultTTL","InReceives","InHdrErrors","InAddrErrors","ForwDatagrams","InUnknownProtos","InDiscards","InDelivers","OutRequests","OutDiuscards","OutNoRoutes","ReasmTimeout","ReasmReqds","ReasmOKs","ReasmFails","FragOKs","FragFails","FragCreates"};
static int ipstat_type[] = {STRING,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG};

static char* icmpstat_desc[] = {"Host Name","InMsgs","InErrors","InDestUnreachs","InTimeExcds","InParmProbs","InScrQuenchs","InRedirects","INEchos","InEchoReps","InTimestamps","InTimestampReps","INAddrMasks","InAddrMaskReps","OutMsgs","OutErrors","OutDestUnreachs","OUtTimeExcds","OUtParmProbs","OUtSrcquenchs","OutRedirects","OutEchos","OutEchoReps","OutTimestamps","OutTimestampReps","OutAddrMasks","OutAddrMaskReps"};
static int icmpstat_type[] = {STRING,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG};

static char* tcpstat_desc[] =  {"Host Name","RtoAlgorithm","RtoMin","RtoMax","MaxConn","ActiveOpens","PassiveOpens","AttemptFails","EstabResets","CurrEstab","InSegs","OutSegs","RetransSegs"};
static int tcpstat_type[] = {STRING,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG,LONG};

static char* udpstat_desc[] =  {"Host Name","InDatagrams","NoPorts","InErrors","OutDatagrams"};
static int udpstat_type[] = {STRING,LONG,LONG,LONG,LONG};

/* Get Resource Information */
u_short getResource(struct resource_info* rinfo,  u_short id)
{
	switch(id)
	{
	case NODE:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "Cluster Nodes Lists";
		rinfo->value_num = 5;
		rinfo->key = 0;
		rinfo->value_desc = node_desc;
		rinfo->value_type = node_type;
		break;
	case GROUP:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "Cluster Group Lists";
		rinfo->value_num = 4;
		rinfo->key = 0;
		rinfo->value_desc = group_desc;
		rinfo->value_type = group_type;
		break;
	case JOB:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Job Statistics";
		rinfo->value_num = 7;
		rinfo->key = 2;
		rinfo->value_desc = job_desc;
		rinfo->value_type = job_type;
		break;
	case QUEUE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Queue Statistics";
		rinfo->value_num = 5;
		rinfo->key = 0;
		rinfo->value_desc = queue_desc;
		rinfo->value_type = queue_type;
		break;
	case STATUS:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "Cluster Status";
		rinfo->value_num = 6;
		rinfo->key = 0;
		rinfo->value_desc = status_desc;
		rinfo->value_type = status_type;
		break;
	case SYSTEMLOG:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "System Log";
		rinfo->value_num = 6;
		rinfo->key = 0;
		rinfo->value_desc = systemlog_desc;
		rinfo->value_type = systemlog_type;
                break;
	case DEVICEINFO:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Device Information";
		rinfo->value_num = 3;
		rinfo->key = 0;
		rinfo->value_desc = deviceinfo_desc;
		rinfo->value_type = deviceinfo_type;
 		break;
	case DISKINFO:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Disk Information";
		rinfo->value_num = 9;
		rinfo->key = 0;
		rinfo->value_desc = diskinfo_desc;
		rinfo->value_type = diskinfo_type;
		break;
	case EXPORT:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Exported Filesytem";
		rinfo->value_num = 2;
		rinfo->key = 0;
		rinfo->value_desc = export_desc;
		rinfo->value_type = export_type;
		break;
	case FSTABLE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "File System";
		rinfo->value_num = 6;
		rinfo->key = 0;
		rinfo->value_desc = fstable_desc;
		rinfo->value_type = fstable_type;
		break;
	case IOPORT:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "IO Ports";
		rinfo->value_num = 2;
		rinfo->key = 0;
		rinfo->value_desc = ioport_desc;
		rinfo->value_type = ioport_type;
		break;
	case KERNELSYMBOL:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Kernel Symbols";
		rinfo->value_num = 3;
		rinfo->key = 0;
		rinfo->value_desc = kernelsymbol_desc;
		rinfo->value_type = kernelsymbol_type;
		break;
	case MODULE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Modules";
		rinfo->value_num = 3;
		rinfo->key = 0;
		rinfo->value_desc = module_desc;
		rinfo->value_type = module_type;
		break;
	case NICINFO:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Network Configuration";
		rinfo->value_num = 11;
		rinfo->key = 0;
		rinfo->value_desc = nicinfo_desc;
		rinfo->value_type = nicinfo_type;
		break;
	case USER:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "User Information";
		rinfo->value_num = 6;
		rinfo->key = 0;
		rinfo->value_desc = user_desc;
		rinfo->value_type = user_type;
		break;
	case VERSION:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "Version";
		rinfo->value_num = 5;
		rinfo->key = 0;
		rinfo->value_desc = version_desc;
		rinfo->value_type = version_type;
		break;
	case CPUINFO:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "CPU Information";
		rinfo->value_num = 11;
		rinfo->key = 0;
		rinfo->value_desc = cpuinfo_desc;
		rinfo->value_type = cpuinfo_type;
		break;
	case CPUSTATE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "CPU Statistics";
		rinfo->value_num = 5;
		rinfo->key = 0;
		rinfo->value_desc = cpustate_desc;
		rinfo->value_type = cpustate_type;
		break;
	case CPUTEMP:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "CPU Temperature";
		rinfo->value_num = 2;
		rinfo->key = 0;
		rinfo->value_desc = cputemp_desc;
		rinfo->value_type = cputemp_type;
		break;
	case FANSPEED:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Fan Speed";
		rinfo->value_num = 2;
		rinfo->key = 0;
		rinfo->value_desc = fanspeed_desc;
		rinfo->value_type = fanspeed_type;
                break;
	case LOGININFO:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Login Information";
		rinfo->value_num = 8;
		rinfo->key = 1;
		rinfo->value_desc = logininfo_desc;
		rinfo->value_type = logininfo_type;
		break;
	case MEMSTATE:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "Memory Statistics";
		rinfo->value_num = 7;
		rinfo->key = 0;
		rinfo->value_desc = memstate_desc;
		rinfo->value_type = memstate_type;
		break;
	case PROCESSINFO:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Process";
		rinfo->value_num = 11;
		rinfo->key = 0;
		rinfo->value_desc = processinfo_desc;
		rinfo->value_type = processinfo_type;
		break;
	case ARP:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "ARP Table";
		rinfo->value_num = 6;
		rinfo->key = 0;
		rinfo->value_desc = arp_desc;
		rinfo->value_type = arp_type;
		break;
	case ROUTE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Route Table";
		rinfo->value_num = 8;
		rinfo->key = 0;
		rinfo->value_desc = route_desc;
		rinfo->value_type = route_type;
		break;
	case IPTABLE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "IP Table";
		rinfo->value_num = 7;
		rinfo->key = 0;
		rinfo->value_desc = connect_desc;
		rinfo->value_type = connect_type;
		break;
	case RAWTABLE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Raw Table";
		rinfo->value_num = 7;
		rinfo->key = 0;
		rinfo->value_desc = connect_desc;
		rinfo->value_type = connect_type;
		break;
	case TCPTABLE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "TCP Table";
		rinfo->value_num = 7;
		rinfo->key = 0;
		rinfo->value_desc = connect_desc;
		rinfo->value_type = connect_type;
		break;
	case UDPTABLE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "UDP Table";
		rinfo->value_num = 7;
		rinfo->key = 0;
		rinfo->value_desc = connect_desc;
		rinfo->value_type = connect_type;
		break;
	case UNIXTABLE:
		rinfo->id = id;
		rinfo->type = MULTIPLY;
		rinfo->resource_desc = "Unix Table";
		rinfo->value_num = 7;
		rinfo->key = 0;
		rinfo->value_desc = connect_desc;
		rinfo->value_type = connect_type;
		break;
	case IPSTAT:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "IP Statistics";
		rinfo->value_num = 20;
		rinfo->key = 0;
		rinfo->value_desc = ipstat_desc;
		rinfo->value_type = ipstat_type;
		break;
	case TCPSTAT:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "TCP Statistics";
		rinfo->value_num = 13;
		rinfo->key = 0;
		rinfo->value_desc = tcpstat_desc;
		rinfo->value_type = tcpstat_type;
		break;
	case UDPSTAT:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "UDP Statistics";
		rinfo->value_num = 5;
		rinfo->key = 0;
		rinfo->value_desc = udpstat_desc;
		rinfo->value_type = udpstat_type;
		break;
	case ICMPSTAT:
		rinfo->id = id;
		rinfo->type = SINGLE;
		rinfo->resource_desc = "ICMP Statistics";
		rinfo->value_num = 27;
		rinfo->key = 0;
		rinfo->value_desc = icmpstat_desc;
		rinfo->value_type = icmpstat_type;
		break;
	default:
		return 1;
	}
	return 0;
}



