#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define PORT 7004
#define MON_PORT 7006

#define BEGIN 111
#define NEXT 221 
#define END 222

#define REGISTER 0
#define UNREGISTER 1
#define GET_CURRENT_VALUE 2
#define UPDATE 3
#define MONITOR_EVENT 0
#define MONITOR_DATA 1
#define NOREPLY 2

#define NODE 1
#define GROUP 2
#define JOB 3
#define QUEUE 4
#define STATUS 5

#define SYSTEMLOG 20
#define DEVICEINFO 21
#define DISKINFO 22
#define EXPORT 23
#define FSTABLE 24
#define IOPORT 25
#define KERNELSYMBOL 26
#define MODULE 27
#define NICINFO 28
#define USER 29
#define VERSION 30 

#define CPUINFO 40
#define CPUSTATE 41
#define CPUTEMP 42
#define FANSPEED 43

#define LOGININFO 60
#define MEMSTATE 61
#define PROCESSINFO 62

#define ARP 80
#define ROUTE 81
#define IPTABLE 82
#define RAWTABLE 83
#define TCPTABLE 84
#define UDPTABLE 85
#define UNIXTABLE 86
#define IPSTAT 90
#define ICMPSTAT 91
#define TCPSTAT 92
#define UDPSTAT 93

#define SHORT 0
#define LONG 1
#define BOOLEAN 2
#define STRING 3
#define DOUBLE 4
#define FLOAT 5

#define SINGLE 0
#define MULTIPLY 1

struct reg_packet
{
  u_short type;
  u_short id;  
};

struct resource_info
{
  u_short id;
  u_short type;
  char* resource_desc;
  int value_num;
  int key;
  char** value_desc;
  int* value_type; 
};

struct cell
{
  u_short row;
  u_short column;
  u_short value_type;
  void* value;
  struct cell* next_row;
  struct cell* next_column;
};

struct table
{
  char tableName[256];
  char* tableSource; 
  u_short rows_num;
  u_short columns_num;
  struct cell* header;
  struct table* nextTable;
};

