/*
 * @(#) GetCurrentValueDemo.java 99/1/26
 */

package CLUSTERPROBE.demo;
 
import java.net.URL;
import java.util.*;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.ResourceTable;

/**
 * Demonstrate how to observe a resource information.
 */

public class GetCurrentValueDemo implements EventHandler
{
	boolean debugflag=false;
	Resource resource = null;
	public StringBuffer result = new StringBuffer();
	public boolean over = false;
	public boolean success = true;
	public Vector value = new Vector();
	public Vector hostTable = new Vector();
	public String errMessage = null;
	public boolean printResult = false;
	boolean DebugFlag = true;
	
	public GetCurrentValueDemo(String rn,String server, int port)
	{
		super();
		if(debugflag) System.out.println("resourceName:"+rn+"   Server:"+server+"   port:"+port);
		try {
			Class rsClass = Class.forName(rn);
			resource = (Resource) rsClass.newInstance();
		}catch(Exception exp)
		{
			System.out.println("Error while instance resource: "+exp);
			System.exit(-1);
		}

		try {
		if (EventTransceiver.current==null)
		{
			//EventTransceiver.current = new EventTransceiver(server,port);
			new EventTransceiver(server,port);	
			if(debugflag) System.out.println("new EventTransceiver");
		}
		EventTransceiver.current.addHandler(this,new ResourceRefreshEvent());
		if(debugflag) System.out.println("in GetCurrentValueDemon: after addHandler");
		EventTransceiver.current.sendEvent(new ResourceRegistryEvent(rn,ResourceRegistryEvent.GETCURRENTVALUE));
		if(debugflag) System.out.println("in GetCurrentValueDemon: after sendEvent");
		}catch(Exception e)
		{
			System.out.println("Connect to server error:"+e.toString());
		}
	};

	/**
	 * handler return value
	 */
	public void handleEvent(JessicEvent ev) {
	if (ev.getId()==JessicEvent.REFRESH)
	{
		if(DebugFlag) System.out.println("in GetCurrentValueDemo: Get JessicaEvent.REFRESH");
		StringBuffer str = new StringBuffer();
		try {
		ResourceRefreshEvent event = (ResourceRefreshEvent) ev;
		Vector dv = event.getData(resource.getResourceName());
		//sort
		dv = sortVector(dv);
		value.addElement(dv);

		Enumeration de = null;

		if (dv!=null)
			de = dv.elements();
		else
			de = (new Vector()).elements();

		String name;
		int state;
		String des;

		String source = (String) event.getLocation();
		if (source==null||source.length()==0)
		{
			if (printResult)
				System.out.println("");
			source="";
			//str.append("<br>");
		}
		else
		{
			if (printResult)
			{
				System.out.println(source);
				System.out.println("----------------------------");
			}
			if (!hostTable.contains(source))
				hostTable.addElement(source);
			//str.append("<h1>"+source+"</h1><br>");
			//str.append("-------------------------------<br>");
		}

		if (resource.isTable())
		{
			if (printResult)
				System.out.println(((ResourceTable)resource).entryToString());
			int cols = ((ResourceTable)resource).getEntryNames().length;
			if (source.length()!=0)
				str.append("<a name=\""+source+"\">");
			str.append("<table BORDER=2 COLS="+cols+" WIDTH=\"100%\" BGCOLOR=\"#CCFFFF\" cellspacing=4 cellpadding=2 align=center>\n");
			str.append("<tr><td></td></tr>\n");
			if (source.length()==0)
				str.append("<tr><td bgcolor=#000000 align=center colspan="+cols+" nowrap><font color=#ffffff size=5><i><b>"+resource.getDesc()+"</b></i></font></td></tr><tr><td></td></tr>\n");
			else	
				str.append("<tr><td bgcolor=#000000 align=center colspan="+cols+" nowrap><font color=#ffffff size=5><i><b>"+source+": "+resource.getDesc()+"</b></i></font></td></tr><tr><td></td></tr>\n");
			str.append(((ResourceTable)resource).entryToHTMLString()+"\n");

			while (de.hasMoreElements())
			{
				try {
				ResourceTableData  data = (ResourceTableData) de.nextElement();
				Vector vt = data.getRecord();

				if (printResult)
					System.out.println(((ResourceTable)resource).toString(vt));
				str.append(((ResourceTable)resource).toHTMLString(vt)+"\n");
				}catch(Exception e) {
				System.out.println(e.toString());
				str.append(e.toString()+"\n");
				};
			}
			str.append("</table>\n");
			if (source.length()!=0)
				str.append("</a>");
		}
		else {
			while ( de.hasMoreElements())
			{
				ResourceLeafData leaf = (ResourceLeafData) de.nextElement();
				if (printResult)
					System.out.println(resource.getResourceName()+":"+leaf.getValue());
				str.append(resource.getResourceName()+": "+leaf.getValue()+"\n");
			}
		}
		if (event.isFinalOne()) 
		{
			over = true;
		}
		}catch(Exception exp) {
			System.out.println("error while handling events: "+exp.toString());
			str.append("error while quering: "+exp.toString()+"\n");
			exp.printStackTrace();
			over = true;
		}
		str.append("\n\n\n");
		result.append(new String(str));
		if(DebugFlag) System.out.println("End of GetCurrentValueDemo:Refresh handler");
	}
	else if (ev.getId()==JessicEvent.ERROR)
	{
		if(DebugFlag) System.out.println("in GetCurrentValueDemo: Get JessicaEvent.ERROR");
		ErrorEvent err = (ErrorEvent) ev;
		System.out.println("Error:"+err.getErrMessage());
		result.append("Error:"+err.getErrMessage());
		success = false;
		errMessage = err.getErrMessage();
	}
		
	if (over)
	{
		//EventTransceiver.current.disconnect();
		EventTransceiver.current.removeHandler(this);
	}
	}

	Vector sortVector(Vector v)
	{
		if (v==null) return null;
		try {
		Vector newVector = new Vector();
		for (int i=0;i<v.size();i++)
		{
			ResourceTableData obj = (ResourceTableData) v.elementAt(i);
			Enumeration en = newVector.elements();
			int location = 0;
			while (en.hasMoreElements())
			{
				ResourceTableData pobj = (ResourceTableData)en.nextElement();
				if (pobj.getKey() instanceof String)
				{
					if (pobj.getKey().toString().compareTo(obj.getKey().toString())>0)
					{
						newVector.insertElementAt(obj,location);
						break;
					}
				}
				else
				{
					if (pobj.getKey().hashCode()>obj.getKey().hashCode())
					{
						newVector.insertElementAt(obj,location);
						break;
					}
				}
				location++;
			}
			if (location==newVector.size())
				newVector.addElement(obj);
		}
		return newVector;
		}catch(Exception e) {return v;};
	}	

	public static void main(String[] args)
	{
		String server = "c414b1.csis.hku.hk";
		int port = 7001;
		String rn = "CLUSTERPROBE.resources.Cluster_Workstation_StatusTable";

		if (args.length==3) {
			try {
			rn = args[0];
			server = args[1];
			port = Integer.parseInt(args[2]);
			}catch(Exception e) {
				System.out.println("Usage: java GetResourceDemo [resourceName] [server] [port]");
				System.exit(-1);
			}
		}

		if (args.length==1) 
			rn = args[0];
		
		GetCurrentValueDemo demo = new GetCurrentValueDemo(rn,server,port);
		demo.printResult = true;
	}
				
}
