/*
 * @(#) GetResourceDemo.java 99/1/20
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.demo;
 
import java.net.URL;
import java.util.*;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.resources.*;

/**
 * Demonstrate how to observe a resource information.
 * 
 * @author Jimmy Liang
 * @version 1.00 1/20/99
 */

public class GetResourceDemo implements ResourceRefreshOperator
{

	Resource resource = null;
	
	public GetResourceDemo(String rn, String server, int port)
	{
		super();
		try {
		resource = (Resource) Class.forName(rn).newInstance();
		if (EventTransceiver.current==null)
		{
			new EventTransceiver(server,port);	
		}
		new ResourceRefreshEventHandler();
		EventTransceiver.current.addHandler(ResourceRefreshEventHandler.current,new ResourceRefreshEvent());
		ResourceRefreshEventHandler.current.register(this);
		}catch(Exception e)
		{
			System.out.println("Connect to server error:"+e.toString());
		}
	};

	public String[] getInterestResources() {
		String[] isn = {resource.getResourceName()};
		return isn;
	}

	/**
	 * Do operation when refreshing data coming
	 *
	 */
	public void operate(Vector dv, Object location) {
		Enumeration de = dv.elements();
		String name;
		int state;
		String des;

		System.out.println("");
		
		if (resource.isTable())
		{
			while (de.hasMoreElements())
			{
			try {
				ResourceTableData  data = (ResourceTableData) de.nextElement();
				Vector vt = data.getRecord();
				System.out.println(((ResourceTable)resource).entryToString());
				System.out.println(((ResourceTable)resource).toString(vt));
			}catch(Exception e) {
				System.out.println(e.toString());
			};
			}
		}
		else {
			while (de.hasMoreElements())
			{
				ResourceLeafData leaf = (ResourceLeafData) de.nextElement();
				System.out.println(resource.getResourceName()+":"+leaf.getValue());
			}
		}
	}

	/**
	 * Operation when error message coming
	 *
	 */
	public void operateError(ErrorEvent e)
	{
		if (e==null) return;
		System.out.println(e.getName()+" alert:"+e.getErrMessage());
	}
	
	public void unregister()
	{
		ResourceRefreshEventHandler.current.unregister(this);
	}

	public static void main(String[] args)
	{
		String server = "c414b1.csis.hku.hk";
		int port = 7001;
		String rn = "CLUSTERPROBE.resources.Cluster_Workstation_StatusTable";

		if (args.length==3) {
			try {
			rn = args[0];
			server = args[1];
			port = Integer.parseInt(args[2]);
			}catch(Exception e) {
				System.out.println("Usage: java GetResourceDemo [resourceName] [server port]");
				System.exit(-1);
			}
		}

		if (args.length==1)
			rn = args[0];

		if (args.length==2)
		{
			try {
			server = args[0];
			port = Integer.parseInt(args[1]);
			}catch(Exception e) {
				System.out.println("Usage: java GetResourceDemo [resourceName] [server port]");
				System.exit(-1);
			}
		}
		
		GetResourceDemo demo = new GetResourceDemo(rn, server,port);
		try {
			Thread.sleep(20000);
			System.out.println("unregister!");
			demo.unregister();
			Thread.sleep(20000);
			System.out.println("register again");
			ResourceRefreshEventHandler.current.register(demo);
		}catch(Exception ex) {};

	}
				
}
