/*
 * @(#) MonitorApplet.java 99/3/5
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.graph;
 
import java.net.URL;
import java.util.*;
import java.applet.Applet;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.*;

/**
 * Applet: Monitor resources values.
 * 
 * @author Jimmy Liang
 * @version 1.00 5/5/99
 */

public class MonitorApplet extends Applet 
{

	public MonitorApplet(String resource, int[] entry, String[] index, String server, int port)
	{
		super();
		try {
		if (EventTransceiver.current==null)
		{
			new EventTransceiver(server,port);	
		}
		MonitorRegistryEvent mon = new MonitorRegistryEvent(MonitorRegistryEvent.MONITOR_DATA);
		mon.setLocation(resource,entry,index);
		mon.setCondition(new Condition());
		mon.setReaction(new React());
		String[] hosts = {"c414b1","wchip01","wchip02","wchip03","wchip04","wchip05","wchip17","wchip18","wchip19","wchip20","wchip21","wchip22"};
		mon.setTargets(hosts);
		EventHandler handler = new EventHandler() {
			public void handleEvent(JessicEvent e)
			{
				int id = e.getId();
				if (id==JessicEvent.MONITORDATA)
				{
					MonitorDataEvent evt = (MonitorDataEvent) e;
					System.out.println(evt.getData());
				} 
				else if (id==JessicEvent.ERROR)
				{
					ErrorEvent err = (ErrorEvent) e;
					System.out.println(err.getErrMessage());
				}
				System.out.println("");
			}
		};
		EventTransceiver.current.addHandler(handler,new MonitorDataEvent());
		EventTransceiver.current.addHandler(handler,new MonitorErrorEvent());
		EventTransceiver.current.sendEvent(mon);
		}catch(Exception e)
		{
			System.out.println("Connect to server error:"+e.toString());
		}
	};

	public static void main(String[] args)
	{
		String server = "c414b1.csis.hku.hk";
		int port = 7002;
		String resource = "CLUSTERPROBE.resources.Cluster_SystemLog";
		int entry[] = {2,3,4,5};
		String[] id = null;	

		MonitorApplet demo = new MonitorApplet(resource,entry,id,server,port);
	}
			
}
