/*
 * @(#) MonitorInfoDemo.java 99/3/11
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.demo;
 
import java.net.URL;
import java.util.*;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.*;

/**
 * Demonstrate how to got monitor informaiton
 * 
 * @author Jimmy Liang
 * @version 1.00 3/11/99
 */

public class MonitorInfoDemo extends Object
{

	public MonitorInfoDemo(String server, int port)
	{
		super();
		try {
		if (EventTransceiver.current==null)
		{
			new EventTransceiver(server,port);	
		}
		MonitorRegistryEvent mon = new MonitorRegistryEvent(MonitorRegistryEvent.QUERY);
		EventHandler handler = new EventHandler() {
			public void handleEvent(JessicEvent e)
			{
				int id = e.getId();
				if (id==JessicEvent.REGISTERINFO)
				{
					RegisterInfoEvent evt = (RegisterInfoEvent) e;
					Vector vt = evt.getInfo();
					System.out.println(vt.size());
					Enumeration en = vt.elements();
					while (en.hasMoreElements())
					{
						MonitorRegistryEvent et = (MonitorRegistryEvent) en.nextElement();
						String[] hosts = et.getTargets();
						if (hosts==null)
							System.out.println("targets is null.");
						else
						{
							System.out.print("targets are:");
							for (int i=0;i<hosts.length;i++)
								System.out.print(hosts[i]+" ");
							System.out.println("");
						}
						
						System.out.println(et.getResourceName());
						int[] entry=et.getEntry();
						if (entry==null)
							System.out.println("entry is null.");
						else
						{
							System.out.print("entries are:");
							for (int i=0;i<entry.length;i++)
								System.out.print(entry[i]+" ");
							System.out.println("");
						}

						Object[] ids = et.getIndex();
						if (ids==null)
							System.out.println("Index is null.");
						else
						{
							System.out.print("Index are:");
							for (int i=0;i<ids.length;i++)
								System.out.print(ids[i]+" ");
							System.out.println("");
						}

						int mInterval = et.getMonitorInterval();
						int rInterval = et.getReportInterval();
						System.out.println("The intervals are "+mInterval+" and "+rInterval);
						if (rInterval==2)
							rInterval--;
						else
							rInterval++;
						et.setInterval(mInterval,rInterval);
						et.setIndicator(MonitorRegistryEvent.UPDATE);
						try{
						EventTransceiver.current.sendEvent(et);
						}catch(Exception e0) {System.out.println(e0);
							System.exit(-1);
						}
						System.out.println("");
					}
				} 
				System.out.println("");
			}
		};
		EventTransceiver.current.addHandler(handler,new RegisterInfoEvent());
		while (true)
		{
System.out.println("query monitor information");
		EventTransceiver.current.sendEvent(mon);
		Thread.sleep(50000);
		}
		}catch(Exception e)
		{
			System.out.println("Connect to server error:"+e.toString());
		}
	};

	public static void main(String[] args)
	{
		String server = "c414b1.csis.hku.hk";
		int port = 7002;
		String resource = "CLUSTERPROBE.resources.Cluster_Workstation_StatusTable";
		int entry[] = {1,3};
		String[] id = null;	

		MonitorDemo demo = new MonitorDemo(resource,entry,id,server,port);
		try {
			Thread.sleep(5000);
		}catch(Exception ex){};
		MonitorInfoDemo info = new MonitorInfoDemo(server,port);
	}
			
}
