/*
 * @(#) UpdateNotify.java 99/1/26
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.demo;
 
import java.net.URL;
import java.util.*;

import CLUSTERPROBE.message.*;

/**
 * Demonstrate how to nofity server some resources updated.
 * 
 * @author Jimmy Liang
 * @version 1.00 1/26/99
 */

public class UpdateNotify extends Object
{

	public UpdateNotify(String resource, String server, int port)
	{
		super();
		try {
		if (EventTransceiver.current==null)
		{
			new EventTransceiver(server,port);	
		}
		EventTransceiver.current.sendEvent(new ResourceRegistryEvent(resource,ResourceRegistryEvent.UPDATED));
		}catch(Exception e)
		{
			System.out.println("Connect to server error:"+e.toString());
		}
	};

	public static void main(String[] args)
	{
		String server = "c414b1.csis.hku.hk";
		int port = 7001;
		String resource = "CLUSTERPROBE.resources.Cluster_NodeLists";

		if (args.length==3) {
			try {
			resource = args[0];
			server = args[1];
			port = Integer.parseInt(args[2]);
			}catch(Exception e) {
				System.out.println("Usage: java UpdateNotify [resource] [server] [port]");
				System.exit(-1);
			}
		}
		else if (args.length==1) {
			resource = args[0];
		}
		else if (args.length>0)
		{
				System.out.println("Usage: java UpdateNotify [resource] [server] [port]");
		}

		UpdateNotify demo = new UpdateNotify(resource,server,port);
		System.out.println("notify completed");
		System.exit(0);
	}
			
}
