package graph;

import java.awt.*;
import java.util.*;
import java.awt.event.*;

/*************************************************************************
**
**    Class AxisScrollbar
**                                              Version 1.0   April 1999
**
**************************************************************************
**    Copyright (C) 1999 Jimmy Liang
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************
**
**    This is a scrollbar attached with a axis.
**
*************************************************************************/

public class AxisScrollbar extends Scrollbar {

	Axis    axis;
	Graph2D graph;
	int page;

	public AxisScrollbar()
	{
		super();
		AdjustmentListener listener = new AdjustmentListener() {
			public void adjustmentValueChanged(AdjustmentEvent evt)
			{
				axis.minimum = evt.getValue();
				axis.maximum = axis.minimum + page;
				graph.repaint();
			}
		};
		addAdjustmentListener(listener);
	}

	public void addAxis(Axis axis, Graph2D g, int page)
	{
		this.axis = axis;
		graph = g;
		this.page = page;
		int position = axis.getAxisPos();
		if (position==Axis.LEFT||position==Axis.RIGHT)
			setOrientation(Scrollbar.VERTICAL);	
		else
			setOrientation(Scrollbar.HORIZONTAL);
		setBlockIncrement(page);
		setUnitIncrement(1);
		setVisibleAmount(page);
		setValue(0);
	}

	public void refresh()
	{
		if (axis.getDataMax()>page)
			setMaximum((int)axis.getDataMax());
		else
			setMaximum(page);
		setMinimum((int)axis.getDataMin());

		setValue((int)axis.minimum);
System.out.println(axis.minimum+" "+axis.maximum+" "+getValue());
		graph.repaint();
	}
}

