package graph;

import java.awt.*;
import java.util.*;
import java.lang.*;
import java.awt.image.*;

/*
**************************************************************************
**
**    Class  ColorIdentify
**
**************************************************************************
**    Copyright (C) 1996 Leigh Brookshaw
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************
**
**    This class is designed to be a legend.
**
*************************************************************************/

/**
 * This class is designed to be a lengend.
 *
 * Version: 1.00 
 * @author  Jimmy Liang
 */

public class Legend extends Panel
{
	Hashtable ht = new Hashtable();
	
	public Legend()
	{
		super();
	}

	public Legend(Hashtable ht)
	{
		super();
		this.ht = ht;
		refresh();
	}

	public Hashtable getLegends()
	{
		return ht;
	}

	public String getDesc(Color c)
	{
		Enumeration e = ht.keys();
		while (e.hasMoreElements())
		{
			Color color = (Color) e.nextElement();
			if (color.equals(c))
				return (String) ht.get(color);
		}
		return null;
	}

	public void addElement(Color c, String desc)
	{
		ht.put(c,desc);
		refresh();
	}

	public void removeElement(Color c)
	{
		ht.remove(c);
		refresh();
	}

	public void refresh()
	{
		removeAll();
		int sz = ht.size();
		setLayout(new GridLayout(1,sz));
		Enumeration en = ht.keys();
		while (en.hasMoreElements())
		{
			Color color = (Color) en.nextElement();
			add(new LegendItem(color,(String)ht.get(color)));
		}
		validate();
		repaint();
	}

}

		
class LegendItem extends Canvas
{
	Color c = null;
	String desc = null;

	public LegendItem(Color c, String desc)
	{
		super();
		this.c = c;
		this.desc = desc;
/*
		FontMetrics fm = getFontMetrics(getFont());
		setSize(20+fm.stringWidth(desc)+2,20);
*/
		setSize(15+desc.length()*7+2,15);
	}		

	public void paint(Graphics g)
	{
		Dimension d = getSize();
		g.setColor(c);
		g.fill3DRect(2,d.height/4,d.height/2,d.height/2,true);
		g.setColor(Color.black);
		g.drawString(desc,2+d.height/2+2,d.height/4*3);
	}
}
