package graph;

import java.awt.*;
import java.applet.*;
import java.net.URL;
import java.util.*;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.*;
import CLUSTERPROBE.resources.*;
//import CLUSTERPROBE.GUI.BundleGroup;

/*************************************************************************
**
**    Applet MonitorApplet
**                                              Version 1.0   May 1999
**
**************************************************************************
**    Copyright (C) 1999 Jimmy Liang
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************
**
**    This is a simple applet that just collect the values of monitored
**    resources.
**
*************************************************************************/

public class MonitorApplet extends Applet {

      Thread runner = null;

      String resource = "CLUSTERPROBE.resources.Cluster_Workstation_Network_ContTable_IP";
      ResourceTable rs;
      long[] initTime; 
      Vector messages = new Vector();
      Hashtable newArrival = new Hashtable();	
      int[] entry = {1,2,3};
      String[] index = null;
      String server = "c414b1";
      String[] hosts = {"c414a1","c414b1"};
	 int mslot = 2;
	 int rslot = 1;
      int port = 7002;
	 EventHandler handler;

      boolean ready = false;
	 boolean isApplet = true;

	 MonitorRegistryEvent mon = null;
	 EventTransceiver tran ;

	 public MonitorApplet() {};

/*
**    Initialize the applet. The Parameters passed are the title of the plot
**    the marker file to use and the update period in milliseconds
*/
      public void init() {

/*
**      Get the passed parameters
*/
	//setCursor(new Cursor(Cursor.WAIT_CURSOR));

	if (isApplet)
	{

	URL url = null;
	try {
	//url = new URL(getDocumentBase(),"Jessic.properties");
	url = getCodeBase();
	}catch(Exception e)
	{
		System.out.println(e);
		return;
	}
	//BundleGroup.setProperty(url);
	//server = BundleGroup.property.getString("monitorServer");
	server = url.getHost();
/*
	try {
		port = Integer.parseInt(BundleGroup.property.getString("monitorPort"));
	}catch(Exception exp) {
		showStatus(exp.toString());
		System.out.println(exp);
		return;
	};
*/
	port = 7002;

	resource = getParameter("RESOURCE");
	entry = getIntArray(getParameter("ENTRY"));
	hosts = getStringArray(getParameter("HOSTS"));
	index = getStringArray(getParameter("INDEX"));

	try {
	String sss = getParameter("interval");
	StringTokenizer tokenizer = new StringTokenizer(sss,"|");
	mslot = Integer.parseInt(tokenizer.nextToken());
	rslot = Integer.parseInt(tokenizer.nextToken());
	}catch(Exception eee){System.out.println(eee);};

	}// end isApplet

	try {
	rs = (ResourceTable) Util.getResource(resource);
	}catch(Exception ee)
	{
		showStatus(ee.toString());
		System.out.println(ee);
		return;
	}

	if (hosts==null||hosts.length==0) return;
	
	int hnum = hosts.length;	

	initTime = new long[hnum];
	for (int i=0;i<hnum;i++)
		initTime[i] = 0;

	
	try {
	//if (EventTransceiver.current == null)
	tran = new EventTransceiver(server,port);
	mon = new MonitorRegistryEvent(MonitorRegistryEvent.MONITOR_DATA);
	mon.setLocation(resource,entry,index);
	mon.setCondition(new Condition());
	mon.setReaction(new React());
	mon.setTargets(hosts);
	mon.setInterval(mslot,rslot);

	handler = new EventHandler() {
		public void handleEvent(JessicEvent e)
		{
			int id = e.getId();
			if (id==JessicEvent.MONITORDATA)
			{
				MonitorDataEvent evt = (MonitorDataEvent) e;
				if (!MonitorUtil.isEquals(mon,evt))
					return;
				Vector vt = (Vector) evt.getData();	
				String sn = evt.getSourceName();
				append(sn,vt,evt.getMonitorTime());
			}	
			else if (id==JessicEvent.ERROR)
			{
				MonitorErrorEvent err;
				try{
				err = (MonitorErrorEvent) e;
				}catch(Exception ee){return;}
				if (!MonitorUtil.isEquals(mon,err))
					return;
				String sn = err.getSourceName();
				appendError(sn,err.getErrMessage());
			}
		}
	};

	//EventTransceiver.current.addHandler(handler,new MonitorDataEvent());
	//EventTransceiver.current.addHandler(handler,new MonitorErrorEvent());
	//EventTransceiver.current.sendEvent(mon);
	tran.addHandler(handler,new MonitorDataEvent());
	tran.addHandler(handler,new MonitorErrorEvent());
	tran.sendEvent(mon);
	}catch(Exception e)
	{
		System.out.println(e);
		showStatus(e.toString());
	}
	//setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

	ready = true;
      }

      public boolean isReady()
      {
	return ready;
      }

      public void start() {};


      public void append(String sn, Vector vt, long mt) {

		int location = 0;
		for (;location<hosts.length;location++)
			if (sn.indexOf(hosts[location])!=-1)
				break;
		if (location==hosts.length) return;
		if (initTime[location]==0)
			initTime[location] = mt;

		synchronized (newArrival)
		{
			addArrival(sn,vt);
		}
	}

	public void appendError(String sn, String errMessage)
	{
		int location = 0;
		for (;location<hosts.length;location++)
			if (sn.indexOf(hosts[location])!=-1)
				break;
		if (location==hosts.length) return;

		synchronized (messages)
		{
		messages.addElement(sn+":"+errMessage);
		}
	}

	void addArrival(String rn, Vector vt)
	{
		Vector vv = new Vector();
		if (newArrival.containsKey(rn))
		{
			vv = (Vector) newArrival.get(rn);
			for (int i=0;i<vv.size();i++)
			{
				if (((Vector)(vv.elementAt(i))).elementAt(0).equals(vt.elementAt(0)))
				{
					vv = new Vector();
					newArrival.put(rn,vv);
					break;
				}
			}
		}
		else
			newArrival.put(rn,vv);
		vv.addElement(vt);
	}
			
	public String getErrMessage()
	{
		if (messages.size()==0)
			return null;
		String errMessage = (String) messages.elementAt(0);
		messages.removeElementAt(0);
		return errMessage;
	}

	public String getArrival()
	{
		if (newArrival.size()==0)
			return "";

		try{
synchronized (newArrival)
		{
		Enumeration en = newArrival.keys();

		while (en.hasMoreElements())
		{
			String key = (String) en.nextElement();
			Vector vt = (Vector) newArrival.get(key);	
			if (vt.size()!=0)
			{
				Vector arrival = (Vector) vt.elementAt(0);
				Enumeration en1 = arrival.elements();
				String data = key;
				while(en1.hasMoreElements())
					data = data+"|"+en1.nextElement();
				vt.removeElementAt(0);
				if (data!=null)
					return data;
				else
					return "";
			}
		}
		}
}catch(Exception ee) {
	System.out.println(ee);
	ee.printStackTrace();
}
		return "";
	}

	public int[] getIntArray(String s)
	{
		if (s==null) return null;
		StringTokenizer st = new StringTokenizer(s,"|");
		int[] ia = new int[st.countTokens()];
		for (int i=0;i<ia.length;i++)
		{
			try {
			ia[i] = Integer.parseInt(st.nextToken());
			}catch(Exception e)
			{
				return null;
			}
		}
		return ia;
	}

	public String[] getStringArray(String s)
	{
		if (s==null) return null;
		StringTokenizer st = new StringTokenizer(s,"|");
		String[] sa = new String[st.countTokens()];
		for (int i=0;i<sa.length;i++)
			sa[i] = st.nextToken();
		return sa;
	}
		
	public static void main(String[] args)
	{
		MonitorApplet mon = new MonitorApplet();
		mon.isApplet = false;
		mon.init();
		try {
		Thread.sleep(10000);

		for (int i=0;i<45;i++)
		System.out.println(mon.getArrival());
		Thread.sleep(60000);
		for (int i=0;i<50;i++)
		System.out.println(mon.getArrival());
		}catch(Exception ee){};
	}
		
	public void stop() {
		cease();
	};

	public void cease() {
		try {
		if (mon == null) return;
		mon.setIndicator(MonitorRegistryEvent.UNREGISTER);
		//EventTransceiver.current.sendEvent(mon);
		tran.sendEvent(mon);
		destroy();
		//EventTransceiver.current.removeHandler(handler);
		}catch(Exception e){};
	}

}


