package graph;

import java.awt.*;
import java.applet.*;
import java.net.URL;
import java.util.*;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.*;
import CLUSTERPROBE.resources.*;
//import CLUSTERPROBE.GUI.BundleGroup;

/*************************************************************************
**
**    Applet MonitorPieChart
**                                              Version 1.0   August 1996
**
**************************************************************************
**    Copyright (C) 1996 Leigh Brookshaw
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************/

public class MonitorPieChart extends Applet {

      Pie[] pie;

      int col = 4;

/*
**    In milliseconds how often do we want to add a new data point.
*/
      int period      = 500;
/*
**    Maximum number of points to display before scrolling the data
*/
      int maximum        = 25;
      URL markersURL;

      String resource = "CLUSTERPROBE.resources.Cluster_Workstation_StatusTable";
      ResourceTable rs;
      long[] initTime; 
      int[] entry = {3,4};
      String[] index = null;
      String server = "c414b1";
      String[] hosts = {"c414b1","c414b2","c414a1","c414a2"};
      int port = 7002;
      boolean isApplet = true;
	 MonitorRegistryEvent mon = null;
	 int mslot = 2;
	 int rslot = 1;

	 EventHandler handler;
	 EventTransceiver tran;

      public MonitorPieChart(String resource, int[] entry, String[] index, String server, int port)
      {
		this.resource = resource;
		this.entry = entry;
		this.index = index;
		this.server = server;
		this.port = port;
		isApplet = false;
	}

	public MonitorPieChart() {};

/*
**    Initialize the applet. The Parameters passed are the title of the plot
**    the marker file to use and the update period in milliseconds
*/
      public void init() {

/*
**      Get the passed parameters
*/
        String st       = "c414a1 load";
        period   = 500;


	if (isApplet)
	{
		setCursor(new Cursor(Cursor.WAIT_CURSOR));

		URL url = null;
		try {
		//url = new URL(getDocumentBase(),"Jessic.properties");
		url = getCodeBase();
		}catch(Exception e)
		{
			System.out.println(e);
			return;
		}
/*
		BundleGroup.setProperty(url);
		server = BundleGroup.property.getString("monitorServer");
		try {
		port = Integer.parseInt(BundleGroup.property.getString("monitorPort"));
		}catch(Exception exp) {
				if (isApplet)
					showStatus(exp.toString());
				System.out.println(exp);
				return;
		};
*/
		server = url.getHost();
		port = 7002;

		resource = getParameter("RESOURCE");
		entry = getIntArray(getParameter("ENTRY"));
		hosts = getStringArray(getParameter("HOSTS"));
		index = getStringArray(getParameter("INDEX"));
		
		try {
		String sss = getParameter("interval");
		StringTokenizer stn = new StringTokenizer(sss,"|");
		mslot = Integer.parseInt(stn.nextToken());
		rslot = Integer.parseInt(stn.nextToken());
		}catch(Exception e0) {};
	}

	try {
	rs = (ResourceTable) Util.getResource(resource);
	}catch(Exception ee)
	{
		if (isApplet)
			showStatus(ee.toString());
		System.out.println(ee);
		return;
	}

/*
**      Create the Graph instance and modify the default behaviour
*/

	if (rs.getTableType()==ResourceTable.SIGLETABLE)
	{
		if (hosts==null||hosts.length==0) return;
	
		int hnum = hosts.length;	


		pie = new Pie[hnum];

		int row = hnum/col;
		if ((hnum%col)!=0) row++;
		setLayout(new GridLayout(row,col));
	
		for (int i=0;i<hnum;i++)
		{
        		pie[i] = new Pie(hosts[i]+" "+rs.getDesc(), "",null);

			add(pie[i]);
		}
	}

	if (isApplet)
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	
	init_chart();
   }

   public void init_chart()
   {
	try {
	//if (EventTransceiver.current==null)
		//new EventTransceiver(server,port);
	tran = new EventTransceiver(server,port);
	mon = new MonitorRegistryEvent(MonitorRegistryEvent.MONITOR_DATA);
	mon.setLocation(resource,entry,index);
	mon.setCondition(new Condition());
	mon.setReaction(new React());
	mon.setTargets(hosts);
	mon.setInterval(mslot,rslot);

	handler = new EventHandler() {
		public void handleEvent(JessicEvent e)
		{
			int id = e.getId();
			if (id==JessicEvent.MONITORDATA)
			{
				MonitorDataEvent evt = (MonitorDataEvent) e;
				if (!MonitorUtil.isEquals(mon,evt))
					return;
				Vector vt = (Vector) evt.getData();	

				String sn = evt.getSourceName();
				append(sn,vt,evt.getMonitorTime());
			}	
			else if (id==JessicEvent.ERROR)
			{
				MonitorErrorEvent err;
				try {
				err = (MonitorErrorEvent) e;
				}catch(Exception ee) {return;}
				if (!MonitorUtil.isEquals(mon,err))
					return;
				String sn = err.getSourceName();
				for (int i=0;i<hosts.length;i++)
					if(sn.indexOf(hosts[i])!=-1)	
					{
						pie[i].chartSubTitle=err.getErrMessage();
						break;
					}
			}
		}
	};

	//EventTransceiver.current.addHandler(handler,new MonitorDataEvent());
	//EventTransceiver.current.addHandler(handler,new MonitorErrorEvent());
	//EventTransceiver.current.sendEvent(mon);
	tran.addHandler(handler,new MonitorDataEvent());
	tran.addHandler(handler,new MonitorErrorEvent());
	tran.sendEvent(mon);
	}catch(Exception e)
	{
		System.out.println(e);
		if (isApplet)
			showStatus(e.toString());
	}

      }

      public void start() {};

      public void stop() {
	 	try {
			if (mon==null) return;
			mon.setIndicator(MonitorRegistryEvent.UNREGISTER);
			//EventTransceiver.current.sendEvent(mon);
			//EventTransceiver.current.removeHandler(handler);
			tran.sendEvent(mon);
			destroy();
		}catch(Exception e){};
      }

        public void append(String sn, Vector vt, long mt) {
	
	if (rs.getTableType()==ResourceTable.SIGLETABLE)
	{
	     	int location = 0;
		for (;location<hosts.length;location++)
			if (sn.indexOf(hosts[location])!=-1)
				break;
		if (location==hosts.length) return;
		
		String[] data = new String[entry.length];
		String[] entryNames = rs.getEntryNames();

		for (int i=0;i<entry.length;i++)
			data[i] = vt.elementAt(i+1)+","+entryNames[entry[i]];
	      	pie[location].refresh(data);
	}
	else
	{
		boolean existed = false;
		int location  = -1;

		if (pie!=null)
		{
			for (location=0;location<pie.length;location++)
				if (pie[location].chartTitle.indexOf(sn+" "+vt.elementAt(0).toString())==0)
				{
					existed = true;
					break;
				}				

			if (!existed)
			{
				location = -1;
				for (int i=0;i<pie.length;i++)
					if (pie[i].chartTitle.indexOf(sn)==0)
						location = i;	
			}
		}

		String[] data = new String[entry.length];
		String[] entryNames = rs.getEntryNames();

		for (int i=0;i<entry.length;i++)
			data[i] = vt.elementAt(i+1)+","+entryNames[entry[i]];

		if (existed)
		{
	      		pie[location].refresh(data);
			return;
		}
			
		int count = 0;
		if (pie!=null) count = pie.length;

		Pie[] tempPie = new Pie[count+1];
		location++;
		for (int i=0;i<location;i++)
			tempPie[i] = pie[i];
		tempPie[location] = new Pie(sn+" "+vt.elementAt(0).toString(),"",data);
		for (int i=location;i<count;i++)
			tempPie[i+1] = pie[i]; 

		this.removeAll();
		pie = tempPie;

		int row = pie.length/col;
		if ((pie.length%col)!=0) row++;
		this.setLayout(new GridLayout(row,col));

		for (int i=0;i<pie.length;i++)
			this.add(pie[i]);

		this.validate();
		this.repaint();

/*
		for (int i=0;i<pie.length;i++)
			pie[i].init();
*/
	}

	}

	public int[] getIntArray(String s)
	{
		if (s==null) return null;
		StringTokenizer st = new StringTokenizer(s,"|");
		int[] ia = new int[st.countTokens()];
		for (int i=0;i<ia.length;i++)
		{
			try {
			ia[i] = Integer.parseInt(st.nextToken());
			}catch(Exception e)
			{
				return null;
			}
		}
		return ia;
	}

	public String[] getStringArray(String s)
	{
		if (s==null) return null;
		StringTokenizer st = new StringTokenizer(s,"|");
		String[] sa = new String[st.countTokens()];
		for (int i=0;i<sa.length;i++)
			sa[i] = st.nextToken();
		return sa;
	}
		
	public static void main(String[] args)
	{
		Frame frame = new Frame();
		String server = "c414b1.csis.hku.hk";
		int port = 7002;
		String resource = "CLUSTERPROBE.resources.Cluster_Workstation_CPUState";
		int entry[] = {1,2,3,4};
		String[] id = null;

		MonitorPieChart example = new MonitorPieChart(resource,entry,id,server,port);
		frame.setSize(450,300);
		frame.add(example);
		example.init();
		frame.show();
		example.start();
	}
		
}


