package graph;

import java.awt.*;
import java.applet.*;
import java.net.URL;
import java.util.*;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.*;
import CLUSTERPROBE.resources.*;
import CLUSTERPROBE.GUI.BundleGroup;

/*************************************************************************
**
**    Applet example2a
**                                              Version 1.0   August 1996
**
**************************************************************************
**    Copyright (C) 1996 Leigh Brookshaw
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**************************************************************************
**
**    This is a simple applet that creates a Scroll Chart using the 
**    Graph2D class library and double buffering
**
*************************************************************************/

public class example2a extends Applet {

      Graph2D[] graph;
      Label[] title;
      Label[] message;
      AxisScrollbar[] as ;
      DataSet[] data; 

      Axis[] yaxis_right;
      Axis[] xaxis_bottom;

      Image    osi = null;
      Graphics osg = null;
      int iwidth  = 0;
      int iheight = 0;
      static Color[] colorGroup = {Color.red,Color.white,Color.yellow,Color.gray,Color.blue,Color.green,Color.pink}; 

      Thread runner = null;
      Random random = new Random();
      int count = 0;
      int col = 2;

	 MonitorRegistryEvent mon;
	 EventHandler handler;


/*
**    In milliseconds how often do we want to add a new data point.
*/
      int period      = 500;
/*
**    Maximum number of points to display before scrolling the data
*/
      int maximum        = 25;
      URL markersURL;

      String resource = "CLUSTERPROBE.resources.Cluster_Workstation_StatusTable";
      ResourceTable rs;
      long[] initTime; 
      int[] entry = {3,4};
      String[] index = null;
      String server = "c414a1";
      String[] hosts = {"c414a1"};
      int port = 7002;
      boolean isApplet = true;

      public example2a(String resource, int[] entry, String[] index, String server, int port)
      {
		this.resource = resource;
		this.entry = entry;
		this.index = index;
		this.server = server;
		this.port = port;
		isApplet = false;
	}

	public example2a() {};

/*
**    Initialize the applet. The Parameters passed are the title of the plot
**    the marker file to use and the update period in milliseconds
*/
      public void init() {

/*
**      Get the passed parameters
*/
        String st       = "c414a1 load";
        String mfile    = "file:///tmp/marker.txt";
        period   = 500;

	if (isApplet)
	{
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		st = getParameter("TITLE");
		mfile = getParameter("MARKER");
		URL url = getDocumentBase();
		//String propertyLocation = "http://"+url.getHost()+"/Jessic.properties";
		String propertyLocation = "file:///tmp/Jessic.properties";
		try {
		url = new URL(propertyLocation);
		}catch(Exception e)
		{
			System.out.println(e);
			return;
		}
		BundleGroup.setProperty(url);
		server = BundleGroup.property.getString("monitorServer");
		try {
		port = Integer.parseInt(BundleGroup.property.getString("monitorPort"));
		}catch(Exception exp) {
				if (isApplet)
					showStatus(exp.toString());
				System.out.println(exp);
				return;
		};

		resource = getParameter("RESOURCE");
		entry = getIntArray(getParameter("ENTRY"));
		hosts = getStringArray(getParameter("HOSTS"));
		index = getStringArray(getParameter("INDEX"));
		try {
		col = Integer.parseInt(getParameter("COL").trim());
		}catch(Exception e0) {};
	}

	try {
	rs = (ResourceTable) Util.getResource(resource);
	}catch(Exception ee)
	{
		if (isApplet)
			showStatus(ee.toString());
		System.out.println(ee);
		return;
	}

	if (hosts==null||hosts.length==0) return;
	
	int hnum = hosts.length;	

/*
**      Create the Graph instance and modify the default behaviour
*/
	graph = new Graph2D[hnum];
	title = new Label[hnum];
	message = new Label[hnum];
	as = new AxisScrollbar[hnum];
	initTime = new long[hnum];

	int row = hnum/col;
	if ((hnum%col)!=0) row++;
	setLayout(new GridLayout(row,col));
System.out.println(row+" "+col);
	
	for (int i=0;i<hnum;i++)
	{
        	graph[i] = new Graph2D();
        	graph[i].zerocolor = new Color(0,255,0);
        	graph[i].borderTop    = 15;
        	graph[i].borderBottom = 5;
		graph[i].borderLeft   = 10;
        	graph[i].setDataBackground(Color.black);

		/*
		**      Create the Title
		*/
        	title[i] = new Label(hosts[i]+" "+st, Label.CENTER);
        	title[i].setFont(new Font("TimesRoman",Font.PLAIN,20));

        	message[i] = new Label("pls. wait...", Label.CENTER);
        	message[i].setFont(new Font("TimesRoman",Font.PLAIN,10));
	
		Panel pl = new Panel();
		pl.setLayout(new BorderLayout());
		pl.add("Center",graph[i]);
		as[i] = new AxisScrollbar();
		pl.add("South",as[i]);

		Panel contentPane = new Panel();
        	contentPane.setLayout( new BorderLayout() );
        	contentPane.add("North",  title[i]);
        	contentPane.add("Center", pl);
		contentPane.add("South",  message[i]);

		add(contentPane);
		
		initTime[i] = 0;
	}

/*
**      Load a file containing Marker definitions
*/
        try {
           markersURL = new URL(mfile);
	   for (int i=0;i<hnum;i++)
           	graph[i].setMarkers(new Markers(markersURL));
        } catch(Exception e) {
           System.out.println("Failed to create Marker URL!"+e);
        }
 

/*
**      Modify the default Data behaviour
*/
	data = new DataSet[hnum*entry.length];
	for (int i=0;i<hnum;i++)
		for (int j=0;j<entry.length;j++)
		{
			data[i*entry.length+j] = new DataSet();
        		data[i*entry.length+j].linecolor   = colorGroup[j];
        		data[i*entry.length+j].marker      = j+1;
        		data[i*entry.length+j].markercolor = colorGroup[j];
			data[i*entry.length+j].legend(10+j*70,10,rs.getEntryNames()[entry[j]]);
		}

/*
**      Setup the Axis. Attach it to the Graph2D instance, and attach the data
**      to it.
*/
	yaxis_right = new Axis[hnum];
	xaxis_bottom = new Axis[hnum];

	for (int i=0;i<hnum;i++)
	{
        	yaxis_right[i] = graph[i].createAxis(Axis.RIGHT);
		xaxis_bottom[i] = graph[i].createAxis(Axis.BOTTOM);
		for (int j=0;j<entry.length;j++)
		{
        		yaxis_right[i].attachDataSet(data[i*entry.length+j]);
			graph[i].attachDataSet(data[i*entry.length+j]);
			xaxis_bottom[i].attachDataSet(data[i*entry.length+j]);
		}
        	yaxis_right[i].setLabelFont(new Font("Helvetica",Font.PLAIN,20));
		xaxis_bottom[i].setLabelFont(new Font("Helvetica",Font.PLAIN,20));
		as[i].addAxis(xaxis_bottom[i],graph[i],250);
	}

	if (isApplet)
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
   }

   public void start()
   {
	try {
	if (EventTransceiver.current==null)
	{
		new EventTransceiver(server,port);
	}
	mon = new MonitorRegistryEvent(MonitorRegistryEvent.MONITOR_DATA);
	mon.setLocation(resource,entry,index);
	mon.setCondition(new Condition());
	mon.setReaction(new React());
	mon.setTargets(hosts);
	handler = new EventHandler() {
		public void handleEvent(JessicEvent e)
		{
			int id = e.getId();
			if (id==JessicEvent.MONITORDATA)
			{
				MonitorDataEvent evt = (MonitorDataEvent) e;
				Vector vt = (Vector) evt.getData();	

				String sn = evt.getSourceName();
				append(sn,vt,evt.getMonitorTime());
			}	
			else if (id==JessicEvent.ERROR)
			{
				ErrorEvent err = (ErrorEvent) e;
				String sn = err.getSourceName();
				for (int i=0;i<hosts.length;i++)
					if(sn.indexOf(hosts[i])!=-1)	
					{
						message[i].setText(err.getErrMessage());
						break;
					}
			}
		}
	};

	EventTransceiver.current.addHandler(handler,new MonitorDataEvent());
	EventTransceiver.current.addHandler(handler,new MonitorErrorEvent());
	EventTransceiver.current.sendEvent(mon);
	}catch(Exception e)
	{
		System.out.println(e);
		if (isApplet)
			showStatus(e.toString());
	}

      }


      public void stop() {
	 	try{
			if (mon==null) return;
			mon.setIndicator(MonitorRegistryEvent.UNREGISTER);
			EventTransceiver.current.sendEvent(mon);
			EventTransceiver.current.removeHandler(handler);
		}catch(Exception e){};
      }




        public void append(String sn, Vector vt, long mt) {
	      double datae[][] = new double[entry.length][2];

	     	int location = 0;
		for (;location<hosts.length;location++)
			if (sn.indexOf(hosts[location])!=-1)
				break;
		if (location==hosts.length) return;
		
		if (initTime[location]==0)
			initTime[location] = mt;

	        double time = (double) (mt-initTime[location])/1000;
	  	message[location].setText("The last data arrived at "+new Date(mt).toString());
		for (int i=0;i<entry.length;i++)
		{
			datae[i][1] = ((Float)(vt.elementAt(i+1))).doubleValue();
			if (datae[i][1]==0.0)
				datae[i][1] = 0.01;
              		datae[i][0] = time;
		}

              	try {
		    for (int i=0;i<entry.length;i++)
                    	data[location*entry.length+i].append(datae[i],1);
	      	}
              	catch (Exception e) {
                    System.out.println("Error appending Data!");
		    message[location].setText("Error appending Data!");
              	}

              	double ym = yaxis_right[location].getDataMax();
		if (ym<1) ym = 1.0;
              	yaxis_right[location].maximum = ym/6*7;
              	yaxis_right[location].minimum = 0.0;
			
	      	double now = xaxis_bottom[location].getDataMax();
	      	if (now<=250.0)
	      	{
	      		xaxis_bottom[location].maximum = 250.0;
			xaxis_bottom[location].minimum = 0.0;
	      	}
	      	else
	      	{
	   		xaxis_bottom[location].maximum  = now;
			xaxis_bottom[location].minimum  = now - 250.0;
	      	}
              
	      	as[location].refresh();     

	}

	public int[] getIntArray(String s)
	{
		if (s==null) return null;
		StringTokenizer st = new StringTokenizer(s,"|");
		int[] ia = new int[st.countTokens()];
		for (int i=0;i<ia.length;i++)
		{
			try {
			ia[i] = Integer.parseInt(st.nextToken());
			}catch(Exception e)
			{
				return null;
			}
		}
		return ia;
	}

	public String[] getStringArray(String s)
	{
		if (s==null) return null;
		StringTokenizer st = new StringTokenizer(s,"|");
		String[] sa = new String[st.countTokens()];
		for (int i=0;i<sa.length;i++)
			sa[i] = st.nextToken();
		return sa;
	}
		
	public static void main(String[] args)
	{
		Frame frame = new Frame();
		String server = "c414a1.csis.hku.hk";
		int port = 7002;
		String resource = "CLUSTERPROBE.resources.Cluster_Workstation_StatusTable";
		int entry[] = {1,3,4};
		String[] id = null;

		example2a example = new example2a(resource,entry,id,server,port);
		frame.setSize(450,300);
		frame.add(example);
		example.init();
		frame.show();
		example.start();
	}
		
}


