/*
 * @(#)Log.java 99/4/16
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.log;

import java.io.*;
 
/**
 * Define the Log utilities.
 *
 * @author Jimmy Liang
 * @version 1.00 4/16/99
 */

public class Log
{
	public static String LOGFILE = "/tmp/JCMT.log";
	public static String ERRFILE = "/tmp/JCMT.err";

	public synchronized static void log(String logfile, String logStr)
	{
		long pos;
		String str,str2;
		RandomAccessFile out = null;

		try {
			out = new RandomAccessFile(logfile,"rw");
			pos = out.length();
			out.seek(pos);
			out.writeBytes(logStr);
		}catch(FileNotFoundException fnfe)
		{
			System.err.println("File not found: "+logfile+" "+fnfe.toString());
		}catch(IOException ioe)
		{
			System.err.println(ioe.getMessage());
		}finally {
			try {
				if (out!=null) out.close();
			}catch(IOException e) {};
		}

		return;
	}

}
		

