#include <stdio.h>
#include <unistd.h>
#include <getopt.h>
#include <stdlib.h>
#include <stdarg.h>

void usage();

int main(argc,argv)
int argc;
char** argv;
{
  int c, exitValue;
  char* opts;
  char* export;
  FILE *f;
  char *buffer;
  char* s;

  while (1)
  {
    c = getopt(argc,argv,"ho:e:");
    if (c == -1)
      break;

    switch(c)
    {
    case 'h':
      usage();
      return 1;
    case 'o':
      opts = optarg;
      break;
    case 'e':
      export = optarg;
      break;
    default:
      fprintf(stderr,"?? getopt returned charatcter code 0%o ??\n",c);
      return 2;
    }
  }

  if (optind < argc)
  {
    usage();
    return 1;
  }

  if (export == NULL)
  {
    fprintf(stderr,"You must specify the export directory!\n");
    usage();
    return 2;
  }

  f = fopen("/etc/exports","a+");

  if (f==NULL)
  {
    perror("Open file /etc/exports error:");
    return 3;
  }  

  if ((buffer=malloc(256))==NULL)
  {
    fprintf(stderr,"Allocate memory fail!\n");
    return 4;
  }

  while (1)
  {
    s = fgets(buffer,256,f);
    if (s == NULL) break;
  }  

  if (opts == NULL)
    fprintf(f,"%s\n",export);
  else
    fprintf(f,"%s\t%s\n",export,opts);
  
  fclose(f);
  
  exitValue = system("/etc/rc.d/init.d/nfs stop");
  if (exitValue!=0)
  {
    fprintf(stderr,"Stop nfs daemon fail!\n");
    return 5;
  }

  exitValue = system("/etc/rc.d/init.d/nfs start\n");
  if (exitValue!=0)
  {
    fprintf(stderr,"Start nfs daemon fail!\n");
    return 6;
  }

  return 0;
}


void usage()
{
  fprintf(stderr,"AddExport Usage: AddExport -e export-dir [-h] [-o options]\n");
}

   

	
	
	
	
