#include <stdio.h>
#include <getopt.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

void usage();

int main(argc,argv)
int argc;
char** argv;
{
  int c, exitValue;
  char* spec,*mp;
  char* type = "nfs";
  char* opts = "defaults";
  FILE *f;
  char *buffer;
  char* s;

  while (1)
  {
    c = getopt(argc,argv,"hs:m:t:o:");
    if (c == -1)
      break;

    switch(c)
    {
    case 'h':
      usage();
      return 1;
    case 'o':
      opts = optarg;
      break;
    case 'm':
      mp = optarg;
      break;
    case 's':
      spec = optarg;
      break;
    default:
      fprintf(stderr,"?? getopt returned charatcter code 0%o ??\n",c);
      return 2;
    }
  }

  if (optind < argc)
  {
    usage();
    return 1;
  }

  if (spec == NULL)
  {
    fprintf(stderr,"You must specify the device or remote filesystem to be mounted!\n");
    usage();
    return 2;
  }

  if (mp == NULL)
  {
    fprintf(stderr,"You must specify the mount point.\n");
    usage();
    return 2;
  }

  if ((buffer=malloc(512))==NULL)
  {
    fprintf(stderr,"Allocate memory fail!\n");
    return 4;
  }

  f = fopen(mp,"r");
  if (f==NULL)
  {
	mkdir(mp,755);	
  }
  else
  	fclose(f);

  sprintf(buffer,"/bin/mount -t %s %s %s",type,spec,mp);
  exitValue = system(buffer);

  if (exitValue!=0)
  {
	fprintf(stderr,"Mount fail!\n");
	return 5;
  }

  if (strcmp(opts,"defaults")!=0)
	return 0;

  f = fopen("/etc/fstab","a+");

  if (f==NULL)
  {
    perror("Open file /etc/fstab error:");
    return 3;
  }  

  while (1)
  {
    s = fgets(buffer,256,f);
    if (s == NULL) break;
  }  

  fprintf(f,"%s\t%s\t%s\t%s\t0 0\n",spec,mp,type,opts);
  
  fclose(f);
  
  return 0;
}


void usage()
{
  fprintf(stderr,"addnfsclient Usage: addnfsclient -s specify-device -m mount point [-t type] [-h] [-o options]\n");
}

   

	
	
	
	
