/*
 * @(#) ManipulateUtil.java 99/23/1
 */

package CLUSTERPROBE.manipulate;
 
import java.util.*;
import java.io.Serializable;
import java.rmi.*;
import java.rmi.server.RMIClassLoader;
import java.io.IOException;
import java.io.DataInputStream;
import java.net.InetAddress;

import CLUSTERPROBE.rmi.NodeRMIInterface;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.Util;

/**
 * define some utilities when manipulating resources.
 */

public class ManipulateUtil extends Object
{
	public static Hashtable registryTable = new Hashtable();
	public static Hashtable sessionTable = new Hashtable();
	public static EventHandler manEv = null;

	public static boolean isEquals(ManipulateEvent e1, ManipulateEvent e2)
	{	
		if (!(e1.getName().equals(e2.getName())))
			return false;
		if (e1.getTime()!=e2.getTime())
			return false;
		return true;
	}

	public static EventTransceiver getTransceiver(ManipulateResultEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				ManipulateEvent reg = (ManipulateEvent) en0.nextElement();
				if (!(reg.getName().equals(evt.getName())))
					continue;
				if (reg.getTime()!=evt.getRegisterTime())
					continue;
				return tran;
			}
		}
		return null;
	}
				
				
	public static ManipulateEvent getRegistryEvent(ManipulateResultEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				ManipulateEvent reg = (ManipulateEvent) en0.nextElement();
				if (!(reg.getName().equals(evt.getName())))
					continue;
				if (reg.getTime()!=evt.getRegisterTime())
					continue;
				return reg;
			}
		}
		return null;
	}
				
	public static EventTransceiver getTransceiver(ManipulateErrorEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				ManipulateEvent reg = (ManipulateEvent) en0.nextElement();
				if (!(reg.getName().equals(evt.getName())))
					continue;
				if (reg.getTime()!=evt.getRegisterTime())
					continue;
				return tran;
			}
		}
		return null;
	}
	
	public static ManipulateEvent getRegistryEvent(ManipulateErrorEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				ManipulateEvent reg = (ManipulateEvent) en0.nextElement();
				if (!(reg.getName().equals(evt.getName())))
					continue;
				if (reg.getTime()!=evt.getRegisterTime())
					continue;
				return reg;
			}
		}
		return null;
	}
				
	public static void handle(ManipulateResultEvent evt)
	{
		ManipulateSession session = getSession(evt);
		if (session!=null)
			session.handleEvent(evt);
	}

	public static void handle(ManipulateErrorEvent evt)
	{
		ManipulateSession session = getSession(evt);
		if (session!=null)
			session.handleEvent(evt);
	}

	public static ManipulateSession getSession(ManipulateResultEvent evt)
	{
		Enumeration en = sessionTable.keys();
		while (en.hasMoreElements())
		{
			ManipulateEvent reg = (ManipulateEvent) en.nextElement();
			if (!(reg.getName().equals(evt.getName())))
					continue;
			if (reg.getTime()!=evt.getRegisterTime())
					continue;
			return (ManipulateSession) sessionTable.get(reg);
		}
		return null;
	}

	public static ManipulateSession getSession(ManipulateEvent evt)
	{
		Enumeration en = sessionTable.keys();
		while (en.hasMoreElements())
		{
			ManipulateEvent reg = (ManipulateEvent) en.nextElement();
			if (!(reg.getName().equals(evt.getName())))
					continue;
			if (reg.getTime()!=evt.getTime())
					continue;
			return (ManipulateSession) sessionTable.get(reg);
		}
		return null;
	}

	public static ManipulateSession getSession(ManipulateErrorEvent evt)
	{
		Enumeration en = sessionTable.keys();
		while (en.hasMoreElements())
		{
			ManipulateEvent reg = (ManipulateEvent) en.nextElement();
			if (!(reg.getName().equals(evt.getName())))
					continue;
			if (reg.getTime()!=evt.getRegisterTime())
					continue;
			return (ManipulateSession) sessionTable.get(reg);
		}
		return null;
	}

	public static void register(ManipulateEvent evt)
	{
		if (ManipulateSession.manEv==null)
			ManipulateSession.manEv = manEv;
		transGroup(evt);

		Enumeration en = sessionTable.keys();
		while (en.hasMoreElements())
		{
			ManipulateEvent reg = (ManipulateEvent) en.nextElement();
			ManipulateSession s = (ManipulateSession) sessionTable.get(reg);
			if (!s.isAlive())
				sessionTable.remove(reg);
		}

		ManipulateSession session = new ManipulateSession(evt);
		sessionTable.put(evt,session);
	}

	public static void changeStatus(ManipulateEvent evt) {
		ManipulateSession session = getSession(evt);
		int indicator = evt.getIndicator();
		if (session==null || (!session.isAlive())) 
		{
			if (indicator==ManipulateEvent.CANCEL)
				return;
			long errTime = Calendar.getInstance().getTime().getTime();
			ManipulateErrorEvent errEvent = new ManipulateErrorEvent(evt.getName(),ManipulateErrorEvent.REGISTER,evt.getTime(),errTime,"No such session!");
			manEv.handleEvent(errEvent);
			return;
		}

		switch(indicator)
		{
		case ManipulateEvent.CANCEL:
			session.stop();
			break;
		case ManipulateEvent.RESUME:
			session.resume();
			break;
		case ManipulateEvent.SUSPEND:
			session.suspend();
			break;
		}
	}

	public static void transGroup(ManipulateEvent evt)
	{
		try{
		Hashtable orders = evt.getOrders();
		if (orders==null) return;
		Enumeration en = orders.elements();
		while (en.hasMoreElements())
		{
			Vector vt = (Vector) en.nextElement();
			Enumeration en1 = vt.elements();
			while (en1.hasMoreElements())
			{
				String s = (String) en1.nextElement();
				if (Resource.groupToHost.containsKey(s))
				{
					Vector gv = (Vector) Resource.groupToHost.get(s);
					vt.removeElement(s);
					Manipulation man = evt.getManipulation(s);
					evt.removeTarget(s);
					for (int i=0;i<gv.size();i++)
					{
						vt.addElement(gv.elementAt(i));
						evt.addTarget((String)gv.elementAt(i),man);
					}
				}
			}
		}
		}catch(Exception e){};
	}

}

class ManipulateSession extends Object
{
	public static EventHandler manEv = null;
	static final int ACTIVE = 0;
	static final int SUSPEND = 1;
	static final int STOP = 2;
	int status = ACTIVE;
	ManipulateEvent evt = null;
	int stage = 0;
	Vector operatingHosts = new Vector();

	public ManipulateSession(ManipulateEvent evt)
	{
		this.evt = evt;
		stage = evt.getMaxPriority() - 1;
		doNext();
	}
	
	public boolean isAlive()
	{
		if (status!=STOP) return true;
		return false;
	}

	public void doNext() {
		if (status==STOP) return;

		if (stage==evt.getMinPriority())
		{
			status=STOP;
			return;
		} 	

		if (status == SUSPEND)
			return;

		stage++;
		operatingHosts = evt.getOrder(stage);
		if (operatingHosts==null) doNext();

		for (int i=0;i<operatingHosts.size();i++)
		{
			String s = (String) operatingHosts.elementAt(i);
			Manipulation p = (Manipulation) evt.getManipulation(s); 
			if (p==null) continue;
			if (ManipulateSessionThread.manEv==null)
				ManipulateSessionThread.manEv = manEv;
			ManipulateSessionThread t = new ManipulateSessionThread(evt,s,p);
			System.out.println("...........................Start a ManipulateSessionThread ");
			t.start();
		}
	}

	public void handleEvent(JessicEvent e)
	{
		if (status==STOP) return;
		try {
		if (e.getId()==JessicEvent.MANIPULATERESULT)
		{
			ManipulateResultEvent event = (ManipulateResultEvent) e;
			if (!event.isSuccess())
				if (!evt.isForce())
					status = STOP;
			if (!removeHost(operatingHosts,event.getOperateSource()))
				return;
		}
		else if(e instanceof ManipulateErrorEvent)
		{
			ManipulateErrorEvent event = (ManipulateErrorEvent) e;
			if (event.getType()==ManipulateErrorEvent.RESPONSE)
				if (!evt.isForce())
					status = STOP;
			if (!removeHost(operatingHosts,event.getErrorSource()))
				return;
		}

		if (operatingHosts.size()==0 && status==ACTIVE)
		{
			doNext();
		}
		}catch(Exception exp) {};
	}

	public boolean removeHost(Vector vt, String st)
	{
		if (vt==null) return false;
		if (st==null) return false;
		int i = 0;
		for (i=0;i<vt.size();i++)
		{
			String key = (String) vt.elementAt(i);
			if (st.indexOf(key)!=-1)
				break;
		}
		if (i==vt.size())
			return false;
		else
			vt.removeElementAt(i);
		return true;
	}
						
	public void stop() 
	{
		status = STOP;
	}

	public void suspend() 
	{
		if (status==ACTIVE)
			status = SUSPEND;
	}

	public void resume()
	{
		if (status==SUSPEND)
		{
			status = ACTIVE;
			if (operatingHosts==null||operatingHosts.size()==0)
				doNext();
		}
	}

}

class ManipulateSessionThread extends Thread
{
	//static Hashtable rmiInterfaces = new Hashtable();		
	public static EventHandler manEv = null;
	ManipulateEvent evt = null;
	String host = null;
	Manipulation m = null;
	
	public ManipulateSessionThread(ManipulateEvent evt, String host, Manipulation m)
	{
		this.evt = evt;
		this.host = host;
		this.m = m;
	}

	public void run()
	{
		boolean DebugFlag = true;
		if(DebugFlag) System.out.println("In ManipulateSessionThread Thread...");
		try {
		NodeRMIInterface r = Util.getRMIInterface(host);
		r.manipulate(evt,m);
		}catch(Exception e){
			Util.removeRMIInterface(host);
			long errTime = Calendar.getInstance().getTime().getTime();
			ManipulateErrorEvent errEvent = new ManipulateErrorEvent(evt.getName(),ManipulateErrorEvent.REGISTER,evt.getTime(),errTime,host+" Manipulation fail:"+e.toString());
			manEv.handleEvent(errEvent);
		}
		if(DebugFlag) System.out.println("End of ManipulateSessionThread.");
	}
				
}
