/*
 * @(#) ErrorEvent.java 99/1/09
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.net.InetAddress;
/**
 * The event type define by this class involves the error message.
 *
 * @author Jimmy Liang
 * @version 1.00 2/9/99
 */

public class ErrorEvent extends JessicEvent
{
	String resourceName = null;
	String errMessage = null;
	String sourceName;

	public ErrorEvent() {
		super("");
		setId(JessicEvent.ERROR);
		sourceName = getHostName();
	}

	public ErrorEvent(String rn) {
		super("");
		setId(JessicEvent.ERROR);
		resourceName = rn;
		sourceName = getHostName();
	}

	public ErrorEvent(String rn, String em)
	{
		super("");
		setId(JessicEvent.ERROR);
		resourceName = rn;
		errMessage = em;
		sourceName = getHostName();
	}

	public String getHostName()
	{
		try {
		String name = InetAddress.getLocalHost().getHostName();
		return name;
		}
		catch(Exception e) {};
		return "";
	}

	public void setName(String rn) {
		resourceName = rn;
	}


	public String getName() {
		return resourceName;
	}

	public String getErrMessage()
	{
		return errMessage;
	}

	public void setErrorMessage(String em)
	{
		errMessage = em;
	}

	public void setSourceName(String s)
	{
		sourceName = s;
	}

	public String getSourceName()
	{
		return resourceName;
	}

}
