/*
 * @(#) ManipulateErrorEvent.java 99/23/03
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
/**
 * The event type define by this class involves the error message when 
 * operating nodes.
 *
 * @author Jimmy Liang
 * @version 1.00 3/23/99
 */

public class ManipulateErrorEvent extends ErrorEvent
{

	public final static int REGISTER = 0;
	public final static int RESPONSE = 3;

	int type = 0;
	long time = 0;	
	long errTime = 0;
	String errorSource = null;

	public ManipulateErrorEvent() {
		super();
	}

	public ManipulateErrorEvent(String name, int type, long time,long errTime, String errMessage) {
		super(name,errMessage);
		this.type = type;
		this.time = time;
		this.errTime = errTime;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int getType() {
		return type;
	}

	public void setErrorSource(String s)
	{
		errorSource = s;
	}

	public String getErrorSource()
	{
		return errorSource;
	}

	public long getRegisterTime() {
		return time;
	}

	public long getErrorTime() {
		return errTime;
	}

	public void setErrTime(long t)
	{
		errTime = t;
	}

}
