/*
 * @(#) ManipulateResultEvent.java 99/3/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Calendar;
import CLUSTERPROBE.manipulate.*;

/**
 * The event type defined by this class stands for the operation result sent 
 * back to client.
 *
 * @author Jimmy Liang
 * @version 1.00 3/23/99
 */

public class ManipulateResultEvent extends JessicEvent
{
	String source =  null;
	String operationName = null;
	long sendOperateTime = 0;
	long operateTime = 0;
	boolean end = true;

	Object result = null;
	boolean success = false;

	public ManipulateResultEvent()
	{
		super("");
		setId(JessicEvent.MANIPULATERESULT);
	}

	public ManipulateResultEvent(String source, String on, long t0, long t1,Object r, boolean s)
	{
		super("");
		this.source = source;
		operationName = on;
		sendOperateTime = t0;
		operateTime = t1;
		result = r;
		success = s;
		setId(JessicEvent.MANIPULATERESULT);		
	}

	public boolean isEnd()
	{
		return end;
	}
	
	public void setEnd(boolean b)
	{
		end = b;
	}

	public void setOperateSource(String s)
	{
		source =s ;
	}

	public String getOperateSource()
	{
		return source;
	}

	public void setResult(Object r)
	{
		result = r;
	}

	public Object getResult()
	{
		return result;
	}

	public String toString()
	{
		return result.toString();
	}

	public String getName()
	{
		return operationName;
	}

	public void setName(String n)
	{
		operationName = n;
	}

	public long getRegisterTime()
	{
		return sendOperateTime;
	}

	public long getOperateTime()
	{
		return operateTime;
	}

	public void setOperateTime(long t)
	{
		operateTime = t;
	}

	public boolean isSuccess()
	{
		return success;
	}

	public void setSucess(boolean s)
	{
		success = s;
	}

}
