/*
 * @(#) MonitorDataEvent.java 99/3/03
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Calendar;
/**
 * The event type define by this class prensents the report data from the
 * monitoring resources.
 *
 * @author Jimmy Liang
 * @version 1.00 3/3/99
 */

public class MonitorDataEvent extends JessicEvent
{

	public final static int DATA = 0;
	public final static int ABNORMAL = 1;
	public final static int REARM = 2;

	String resourceName = null;
	int type = 0;
	long time = -1;	
	String sourceName = null;
	long monTime = -1;

	Object data = null;

	public MonitorDataEvent() {
		super("");
		setId(JessicEvent.MONITORDATA);
		monTime = Calendar.getInstance().getTime().getTime();
	}

	public MonitorDataEvent(String source, String rn, int type, long time, Object data)
	{
		super("");
		setId(JessicEvent.MONITORDATA);
		sourceName = source;
		this.type = type;
		this.time = time;
		this.resourceName = rn;
		this.data = data;
		monTime = Calendar.getInstance().getTime().getTime();
	}

	public long getMonitorTime()
	{
		return monTime;
	}

	public void setMonitorTime(long t)
	{
		monTime = t;
	}

	public void setSource(String source)
	{
		sourceName = source;
	}

	public String getSourceName()
	{
		return sourceName;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int getType() {
		return type;
	}

	public long getRegisterTime() {
		return time;
	}

	public void setResourceName(String rn) {
		resourceName = rn;
	}

	public String getResourceName() {
		return resourceName;
	}

	public void setData(Object obj) {
		data = obj;
	}

	public Object getData() {
		return data;
	}
}
