/*
 * @(#) MonitorErrorEvent.java 99/3/03
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
/**
 * The event type define by this class involves the error message when 
 * monitoring resources.
 *
 * @author Jimmy Liang
 * @version 1.00 3/3/99
 */

public class MonitorErrorEvent extends ErrorEvent
{

	public final static int REGISTER = 0;
	public final static int UNREGISTER = 1;
	public final static int UPDATE = 2;
	public final static int GETDATA = 3;

	int type = 0;
	long time = -1;	

	public MonitorErrorEvent() {
		super();
	}

	public MonitorErrorEvent(String rn, int type, long time, String errMessage) {
		super(rn,errMessage);
		this.type = type;
		this.time = time;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int getType() {
		return type;
	}

	public long getRegisterTime() {
		return time;
	}

}
