/*
 * @(#) ResourceRefreshEventHandler.java 98/12/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Vector;
import java.util.Enumeration;
import java.util.Hashtable;

/**
 * This class implements class EventHandler, responsible for handle coming
 * ResourceRefreshEvent and outgoing ResourceRegisterEvent.
 *
 * @author Jimmy Liang
 * @version 1.00 12/23/98
 */

public class ResourceRefreshEventHandler implements EventHandler {	
	Vector observers = new Vector();
	public static ResourceRefreshEventHandler current;
	Hashtable registerResources = new Hashtable();

	public ResourceRefreshEventHandler()
	{
		current = this;
	}

	public void handleEvent(JessicEvent e)
	{
		if (e==null) return ;
		System.out.println("in ResourceEventHandler");
		if (e.getId()==JessicEvent.REFRESH)
		{
			System.out.println("get JessicEvent.REFRESH");
			try {
			ResourceRefreshEvent event = (ResourceRefreshEvent) e;

			Enumeration ob = observers.elements();
			// Found the Observers of the coming event's data
			while (ob.hasMoreElements())
			{
				ResourceRefreshOperator op = (ResourceRefreshOperator) ob.nextElement();
				String[] interestResources = op.getInterestResources();
				if (interestResources!=null)
				{
					for (int i=0;i<interestResources.length;i++)
					{
						if (event.contains(interestResources[i]))
							op.operate(event.getData(interestResources[i]),event.getLocation());
					}
				}
			}
			}catch(Exception ex) {};
		}
		else if (e.getId()==JessicEvent.ERROR)
		{
			System.out.println("get JessicEvent.ERROR");
			try {
			ErrorEvent event = (ErrorEvent) e;
			String rn = event.getName();
			if (rn==null) return;
			
			Enumeration ob = observers.elements();
			// Found the Observers of the coming event's data
			while (ob.hasMoreElements())
			{
				ResourceRefreshOperator op = (ResourceRefreshOperator) ob.nextElement();
				String[] interestResources = op.getInterestResources();
				if (interestResources!=null)
				{
					for (int i=0;i<interestResources.length;i++)
					{
						if (rn.equals(interestResources[i]))
							op.operateError(event);
					}
				}
			}
			}catch(Exception ex) {};
		}
	}

	public void register(ResourceRefreshOperator  op)
	{
		if (!observers.contains(op))
		{
			observers.addElement(op);
			// send register event to server if new resources are interested. 
			String[] res = op.getInterestResources();
			try {	
			if (res!=null && res.length>0)
			{
				for (int i=0;i<res.length;i++)
				{
					if (!registerResources.containsKey(res[i]))
					{
						registerResources.put(res[i],new Integer(1));
						EventTransceiver.current.sendEvent(new ResourceRegistryEvent(res[i]));
					}
					else
					{
						Integer count = (Integer) registerResources.get(res[i]);
						count = new Integer(count.intValue()+1);
						registerResources.put(res[i],count);
					}
				}
			}			
			}catch(Exception e) {
				System.out.println("Register Error:"+e.toString());
			}
		}
	}

	public void unregister(ResourceRefreshOperator op)
	{
		if(observers.contains(op)) 
		{
			observers.removeElement(op);
			String[] res = op.getInterestResources();
			try {	
			if (res!=null && res.length>0)
			{
				for (int i=0;i<res.length;i++)
				{
					if (registerResources.containsKey(res[i]))
					{
						Integer count = (Integer) registerResources.get(res[i]);
						int num = count.intValue() - 1;
						if (num<=0)
						{
							registerResources.remove(res[i]);
							EventTransceiver.current.sendEvent(new ResourceRegistryEvent(res[i],ResourceRegistryEvent.UNREGISTER));
						}
						else
							registerResources.put(res[i],new Integer(num));
					}
				}	
			}
			}catch(Exception e) {
				System.out.println("Register Error:"+e.toString());
			}
		}
	}

}
