/*
 * @(#) ResourceRegistryEvent.java 99/1/09
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.message;
 
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;

/**
 * The event type define by this class stands for observing the resource
 * changing. 
 *
 * @author Jimmy Liang
 * @version 1.00 1/9/99
 */

public class ResourceRegistryEvent extends JessicEvent
{
	String resourceName = null;
	public final static int REGISTER = 0;
	public final static int UNREGISTER = 1;
	public final static int GETCURRENTVALUE = 2;
	public final static int UPDATED = 3;
	int type = REGISTER;
	
	public ResourceRegistryEvent() {
		super("");
		setId(JessicEvent.REGISTRY);
	}

	public ResourceRegistryEvent(String rn) {
		super("");
		setId(JessicEvent.REGISTRY);
		resourceName = rn;
	}

	public ResourceRegistryEvent(String rn, int type)
	{
		super("");
		setId(JessicEvent.REGISTRY);
		resourceName = rn;
		this.type = type;
	}

	public void setName(String rn) {
		resourceName = rn;
	}

	public String getName() {
		return resourceName;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int getType()
	{
		return type;
	}

}
