/* * @(#) MonitorThread.java 99/3/02 */

package CLUSTERPROBE.monitor;
 
import java.util.*;
import java.io.*;
import java.net.Socket;
import java.rmi.server.RemoteServer;
import java.net.InetAddress;
import CLUSTERPROBE.resources.*;
import CLUSTERPROBE.message.*;

/**
 * Define the thread monitor specify resources value.
 */

public class MonitorThread extends Thread
{
	Resource rs = null;
	Vector v = new Vector();
	Hashtable startP = new Hashtable();
	Hashtable outStreams = new Hashtable();
	Object prevData = null;
	MonitorDataEvent prevEvent = null;
	long count = 0;
	static InputStream evIn = null;
	static OutputStream evOut = null;
	public static EventHandler monEv = null;
	String server = "c414b1";
	int port = 7002;

	public MonitorThread(String rn) 
	{
		if (evOut == null || evIn == null)
			initSocket();
		try {
		rs = (Resource) Util.instanceClass(rn);
		}catch(Exception ep) {};
	}

	public void initSocket()
	{
		try {
		server = RemoteServer.getClientHost();
		Socket serverSocket = new Socket(server,port);
		evIn = serverSocket.getInputStream();
		evOut = serverSocket.getOutputStream();
		}catch(Exception exp) {};
	}

	public void addElement(MonitorRegistryEvent evt) {
		v.addElement(evt);
		startP.put(evt,new Long(count));
		try {
			ObjectOutputStream out = new ObjectOutputStream(evOut);
			out.writeObject("yes");
			out.flush();
		}catch(Exception e) {
			initSocket();
		}
		outStreams.put(evt,evOut);
		//send current data
		if (prevEvent != null)
		{
			try {
			ObjectOutputStream out = new ObjectOutputStream(evOut);
			out.writeObject(prevEvent);
			}catch(Exception exp){};
		}
	}

	public void addElement(MonitorRegistryEvent evt, OutputStream os) {
		v.addElement(evt);
		startP.put(evt,new Long(count));
		outStreams.put(evt,os);

		//send current data
		if (prevEvent != null)
		{
			try {
			ObjectOutputStream out = new ObjectOutputStream(os);
			out.writeObject(prevEvent);
			}catch(Exception exp){};
		}
	}

	public void removeElement(MonitorRegistryEvent evt) 
	{
		Enumeration en = v.elements();
		while (en.hasMoreElements())
		{
			MonitorRegistryEvent e0 = (MonitorRegistryEvent) en.nextElement();
			if (!(e0.getResourceName().equals(evt.getResourceName())))
				continue;
			if (!(e0.getRegisterTime()==evt.getRegisterTime()))
				continue;
			v.removeElement(e0);
			startP.remove(e0);
			outStreams.remove(e0);
			break;
		}
		if (size()==0) stop();
	}

	public void updateElement(MonitorRegistryEvent evt) 
	{
		Enumeration en = v.elements();
		while (en.hasMoreElements())
		{
			MonitorRegistryEvent e0 = (MonitorRegistryEvent) en.nextElement();
			if (!(e0.getResourceName().equals(evt.getResourceName())))
				continue;
			if (!(e0.getRegisterTime()==evt.getRegisterTime()))
				continue;
			v.removeElement(e0);
			v.addElement(evt);
			long tt = count;
			if (startP.containsKey(e0))
				tt = ((Long)startP.get(e0)).intValue();	
			startP.remove(e0);
			startP.put(evt,new Long(tt));
			OutputStream cOut = (OutputStream) outStreams.get(e0);
			outStreams.put(evt,cOut);
			break;
		}
	}
			
	public void run() {
		if (rs==null) return;
		boolean DebugFlag = true;
		if(DebugFlag) System.out.println("In monitor/MonitorThread Thread...");
		while (true)
		{
			if (!realDoIt())
			{
				count++;
				try {
				Thread.sleep(rs.getMinTime());
				}catch(Exception ex){};
				continue;
			}
			if (!rs.isTable())
			{
				// do something when the values format is not table
			}
			else 
			{
				prevData = new Hashtable();
				ResourceTable rt = (ResourceTable) rs;
				MonitorDataEvent event = null;
		
				if (rt.getTableType()==ResourceTable.SIGLETABLE)
				{
					if (rt.isValueFromServer()) 
						sendData(rt.getTable());
							
					else
					{
						try {
						sendData(rt.getVector());
						}catch(Exception e0) {
							sendError(e0);
						}
					}
				}
				else {
					if (rt.isValueFromServer())
						sendData(rt.getTable());	
					else
					{
						try {
						sendData(rt.getHashtable());
						}catch(Exception e1) {
							sendError(e1);
						}
					}
				}
					
			}
			count++;
			try {Thread.sleep(rs.getMinTime());}catch(Exception exp){};
		}
		if(DebugFlag) System.out.println("End of monitor/MonitorThread Thread.");
	}

	public int size()
	{
		return v.size();
	}
 
	public void sendData(Hashtable h) 
	{
		Enumeration en = v.elements();

		while (en.hasMoreElements())
		{
			MonitorRegistryEvent evt = (MonitorRegistryEvent) en.nextElement();

			if (!realDoIt(evt))
				continue;
			int indicator = evt.getIndicator();
			Object[] index = evt.getIndex();
			int[] entries = evt.getEntry();
			ResourceTable rt = (ResourceTable) rs;

			if (rt.getTableType()==ResourceTable.MULTITABLE&&rt.isValueFromServer()==true)
			{
				Enumeration en0 = h.keys();
				while (en0.hasMoreElements())
				{
					Object k = en0.nextElement();
					Hashtable htable = (Hashtable)h.get(k);
					Enumeration emn = htable.keys();
					while (emn.hasMoreElements())
					{
						Object ht_key = emn.nextElement();
						Vector rcd = (Vector) htable.get(ht_key);
						if (!isInterest(index,rcd))
							continue;

						Vector dt = new Vector();
						dt.addElement(getKey(rcd));
						if (entries==null) 
							for (int i=0;i<rcd.size();i++)	
								dt.addElement(rcd.elementAt(i));
						else
							for (int i=0;i<entries.length;i++)
								dt.addElement(getValue(entries[i],rcd));
						sendData(getHostName(),evt,dt);
					}
				}
			}
			else 
			{
				Enumeration en1 = h.keys();
				while (en1.hasMoreElements())
				{
					Object k = en1.nextElement();
					Vector record = (Vector) h.get(k);
					if (!isInterest(index,record)) 
						continue;
					
					Vector data = new Vector();
					data.addElement(getKey(record));
					if (entries==null) 
						for (int i=0;i<record.size();i++)	
							data.addElement(record.elementAt(i));
					else
						for (int i=0;i<entries.length;i++)
							data.addElement(getValue(entries[i],record));
					sendData(getHostName(),evt,data);
				}
			}
		}
	}
		
	public void sendData(Vector d) 
	{
		Enumeration en = v.elements();

		while (en.hasMoreElements())
		{
			MonitorRegistryEvent evt = (MonitorRegistryEvent) en.nextElement();
			int indicator = evt.getIndicator();

			if (!realDoIt(evt))
				continue;

			Vector data = new Vector();
			int[] entries = evt.getEntry();
			data.addElement(getKey(d));
			if (entries==null) 
				for (int i=0;i<d.size();i++)	
					data.addElement(d.elementAt(i));
			else
				for (int i=0;i<entries.length;i++)
					data.addElement(getValue(entries[i],d));
			sendData(getHostName(),evt,data);
		}
	}
		
	public void sendData(String source,MonitorRegistryEvent evt, Vector data)
	{
		try {

		int indicator = evt.getIndicator();
		Vector prevVector = null;
		if (prevData!=null) {
			ResourceTable rt = (ResourceTable) rs;
			if (rt.getTableType()==ResourceTable.MULTITABLE)
			{
				Object key = data.elementAt(0);
				prevVector = (Vector) ((Hashtable)prevData).get(key);
			}
		}

		((Hashtable)prevData).remove(data.elementAt(0));
		((Hashtable)prevData).put(data.elementAt(0),data);	
			
		switch(evt.getCondition().checkStatus(data,prevVector))
		{
		case Condition.EVENT:
			MonitorDataEvent event = new MonitorDataEvent(source,evt.getResourceName(),MonitorDataEvent.ABNORMAL,evt.getRegisterTime(),data);
			if (indicator==MonitorRegistryEvent.MONITOR_EVENT||indicator==MonitorRegistryEvent.MONITOR_DATA)
			{
				if (rs.isValueFromServer())
					monEv.handleEvent(event);
				else 
				{
					try {
						prevEvent = event;
						OutputStream cOut = getOutStream(evt);
						if (cOut!=null)
						{
							ObjectOutputStream out = new ObjectOutputStream(cOut);
							out.writeObject(event);
						}
					}catch(Exception ex) {
						removeElement(evt);
					};
				}
			}
			React react = evt.getReaction();
			if (react!=null) 
				react.reaction_node(event);
			break;
		case Condition.REARM:
			MonitorDataEvent event1 = new MonitorDataEvent(source,evt.getResourceName(),MonitorDataEvent.REARM,evt.getRegisterTime(),data);
			if (indicator==MonitorRegistryEvent.MONITOR_EVENT||indicator==MonitorRegistryEvent.MONITOR_DATA)
			{
				if (rs.isValueFromServer())
					monEv.handleEvent(event1);
				else
				{
					try {
						prevEvent = event1;
						OutputStream cOut = getOutStream(evt);
						if (cOut!=null)
						{
							ObjectOutputStream out = new ObjectOutputStream(cOut);
							out.writeObject(event1);
						}
					}catch(Exception exp) {
						removeElement(evt);
					};
				}
			}
			React react1 = evt.getReaction();
			if (react1!=null)
				react1.rearm_node(event1);
			break;
		case Condition.DATA:
			MonitorDataEvent event2 = new MonitorDataEvent(source,evt.getResourceName(),MonitorDataEvent.DATA,evt.getRegisterTime(),data);
			if (indicator==MonitorRegistryEvent.MONITOR_DATA&&realReportIt(evt))
			{
				if (rs.isValueFromServer())
					monEv.handleEvent(event2);
				else
				{
				try {
					prevEvent = event2;
					OutputStream cOut = getOutStream(evt);
					if (cOut!=null)
					{
						ObjectOutputStream out = new ObjectOutputStream(cOut);
						out.writeObject(event2);
					}
				}catch(Exception exp) {
						removeElement(evt);
				};
				}
			}
			break;
		}
		}catch(Exception ex) {stop();}
	}

	public void sendError(Exception e)
	{
		try {
	
		Enumeration en = v.elements();
		while (en.hasMoreElements())
		{
			MonitorRegistryEvent evt = (MonitorRegistryEvent) en.nextElement();
			
			if (!realDoIt(evt))
				continue;
			MonitorErrorEvent err = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.GETDATA,evt.getRegisterTime(),getHostName()+" errors:"+e.toString());
			
			if (rs.isValueFromServer())
				monEv.handleEvent(err);
			else
			{
				try {		
					prevEvent = null;
					OutputStream cOut = getOutStream(evt);
					if (cOut!=null)
					{
						ObjectOutputStream out = new ObjectOutputStream(cOut);
						out.writeObject(err);
					}
				}catch(Exception exp) {
					removeElement(evt);
				}
			}
		}
		}catch(Exception ex) {stop();}
	}

	public Object getValue(int id, Vector vt)
	{
		if (vt.size()<(id+1)) return null;
		return vt.elementAt(id);
	}			
	
	public Object getKey(Vector vt)
	{
		if (rs==null) return null;
		ResourceTable rt = (ResourceTable) rs;
		return rt.getValue(rt.getId(rt.getKeyName()),vt);	
	}

	public String getHostName()
	{
		try {
		String name = InetAddress.getLocalHost().getHostName();
		return name;
		}catch(Exception ex) {
		};
		return "";
	}

	public boolean realDoIt() 
	{
		Enumeration en = v.elements();
		while (en.hasMoreElements())
		{
			MonitorRegistryEvent evt = (MonitorRegistryEvent) en.nextElement();
			if (realDoIt(evt))
				return true;
		}
		return false;
	}
	
	public boolean realDoIt(MonitorRegistryEvent evt)
	{
		long start = count;
		if (startP.containsKey(evt))
		{
			Long iv = (Long) startP.get(evt);
			start = iv.longValue();
		}
		int interval = evt.getMonitorInterval();
		return (((count-start)%interval)==0);
	}
				
	public boolean realReportIt(MonitorRegistryEvent evt)
	{
		long start = count;
		if (startP.containsKey(evt))
		{
			Long iv = (Long) startP.get(evt);
			start = iv.longValue();
		}

		int interval = evt.getMonitorInterval()*evt.getReportInterval();
		return (((count-start)%interval)==0);
	}
		
	public boolean isInterest(Object[] index,Vector r)
	{
		if (index==null) return true;
		for (int i=0;i<index.length;i++)
			if (index[i].equals(getKey(r)))
				return true;
		return false;
	}	
	
	public OutputStream getOutStream(MonitorRegistryEvent evt)
	{
		return (OutputStream) outStreams.get(evt);
/*
		Enumeration en = v.elements();
		while (en.hasMoreElements())
		{
			MonitorRegistryEvent e0 = (MonitorRegistryEvent) en.nextElement();
			if (!(e0.getResourceName().equals(evt.getResourceName())))
				continue;
			if (!(e0.getRegisterTime()==evt.getRegisterTime()))
				continue;
			return (OutputStream) outStreams.get(e0);
		}
		return null;
*/
	}

}
