/*
 * @(#) MonitorUtil.java 99/3/1
 *
 * Copyright 1997, 1998, 1999 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.monitor;
 
import java.util.*;
import java.io.Serializable;
import java.rmi.*;
import java.rmi.server.RMIClassLoader;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.OutputStream;
import java.net.InetAddress;

import CLUSTERPROBE.message.EventHandler;
import CLUSTERPROBE.rmi.NodeRMIInterface;
import CLUSTERPROBE.message.MonitorRegistryEvent;
import CLUSTERPROBE.message.MonitorErrorEvent;
import CLUSTERPROBE.message.EventTransceiver;
import CLUSTERPROBE.message.MonitorDataEvent;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.Util;

/**
 * define some utilities when monitoring resource values
 *
 * @author Jimmy Liang
 * @version 1.00 3/1/99
 */

public class MonitorUtil extends Object
{
	public static Hashtable registryTable = new Hashtable();
	//public static Hashtable rmiInterfaces = new Hashtable();
	public static Hashtable resourceTable = new Hashtable();
	public static Hashtable monTable = new Hashtable();
	public static Vector localRegistry = new Vector();

	public static boolean isEquals(MonitorRegistryEvent e1, MonitorRegistryEvent e2)
	{	
		if (!(e1.getResourceName().equals(e2.getResourceName())))
			return false;
		if (!(e1.getRegisterTime()==e2.getRegisterTime()))
			return false;
		return true;
	}

	public static boolean isEquals(MonitorRegistryEvent e1, MonitorErrorEvent e2)
	{	
		if (!(e1.getResourceName().equals(e2.getName())))
			return false;
		if (!(e1.getRegisterTime()==e2.getRegisterTime()))
			return false;
		return true;
	}

	public static boolean isEquals(MonitorRegistryEvent e1, MonitorDataEvent e2)
	{
		if (!(e1.getResourceName().equals(e2.getResourceName())))
			return false;
		if (!(e1.getRegisterTime()==e2.getRegisterTime()))
			return false;
		return true;
	}

	public static EventTransceiver getTransceiver(MonitorRegistryEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				MonitorRegistryEvent reg = (MonitorRegistryEvent) en0.nextElement();
				if (!(reg.getResourceName().equals(evt.getResourceName())))
					continue;
				if (!(reg.getRegisterTime()==evt.getRegisterTime()))
					continue;
				return tran;
			}
		}
		return null;
	}
				
	public static EventTransceiver getTransceiver(MonitorDataEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				MonitorRegistryEvent reg = (MonitorRegistryEvent) en0.nextElement();
				if (!(reg.getResourceName().equals(evt.getResourceName())))
					continue;
				if (!(reg.getRegisterTime()==evt.getRegisterTime()))
					continue;
				return tran;
			}
		}
		return null;
	}
				
	public static MonitorRegistryEvent getRegistryEvent(MonitorDataEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				MonitorRegistryEvent reg = (MonitorRegistryEvent) en0.nextElement();
				if (!(reg.getResourceName().equals(evt.getResourceName())))
					continue;
				if (!(reg.getRegisterTime()==evt.getRegisterTime()))
					continue;
				return reg;
			}
		}
		return null;
	}
				
	public static EventTransceiver getTransceiver(MonitorErrorEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				MonitorRegistryEvent reg = (MonitorRegistryEvent) registryTable.get(tran);
				if (!(reg.getResourceName().equals(evt.getName())))
					continue;
				if (!(reg.getRegisterTime()==evt.getRegisterTime()))
					continue;
				return tran;
			}
		}
		return null;
	}
	
	public static MonitorRegistryEvent getRegistryEvent(MonitorErrorEvent evt)
	{
		Enumeration en = registryTable.keys();
		while (en.hasMoreElements())
		{
			EventTransceiver tran = (EventTransceiver) en.nextElement();
			Vector ev = (Vector) registryTable.get(tran);
			Enumeration en0 = ev.elements();
			while (en0.hasMoreElements())
			{
				MonitorRegistryEvent reg = (MonitorRegistryEvent) en0.nextElement();
				if (!(reg.getResourceName().equals(evt.getName())))
					continue;
				if (!(reg.getRegisterTime()==evt.getRegisterTime()))
					continue;
				return reg;
			}
		}
		return null;
	}
				
	public static boolean register(MonitorRegistryEvent evt, OutputStream evOut)
	{
		Resource rs = null;
		EventTransceiver tran = MonitorUtil.getTransceiver(evt);

		if (resourceTable.containsKey(evt.getResourceName()))
			rs = (Resource) resourceTable.get(evt.getResourceName());
		else
		{
			try{
			rs = (Resource) Util.instanceClass(evt.getResourceName());	
			if (rs!=null)
				resourceTable.put(evt.getResourceName(),rs);
			}catch(Exception ee) {};
		}

		if (rs==null) {
			MonitorErrorEvent e = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.REGISTER,evt.getRegisterTime(),evt.getResourceName()+":No such class");
			try {
				tran.sendEvent(e);
			}catch(IOException ex) 
			{
				registryTable.remove(EventTransceiver.current);
			};
			return false;
		}

		if (rs.isValueFromServer()) {
			if (monTable.containsKey(evt.getResourceName()))
			{
				MonitorThread t = (MonitorThread) monTable.get(evt.getResourceName());
				if (!t.isAlive())
				{
					monTable.remove(evt.getResourceName());
					t = new MonitorThread(evt.getResourceName());
					monTable.put(evt.getResourceName(),t);
					t.addElement(evt,evOut);
					System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
					t.start();
				}
				else
					t.addElement(evt,evOut);
			}
			else {
				MonitorThread t0 = new MonitorThread(evt.getResourceName());
				monTable.put(evt.getResourceName(),t0);
				t0.addElement(evt,evOut);
				System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
				t0.start();
			}
			return true;
		}
			
		String[] hosts = evt.getTargets();
		hosts = transGroup(hosts);
		if (hosts == null) 
		{
			MonitorErrorEvent err = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.REGISTER,evt.getRegisterTime(),evt.getResourceName()+":You must specify hosts!");
			try {
				tran.sendEvent(err);
			}catch(IOException ex) 
			{
				registryTable.remove(EventTransceiver.current);
			};
			return false;
		}

		Vector validHosts = new Vector();
		for (int i=0;i<hosts.length;i++)
		{
			if (hosts[i]==null) continue;
			try {
			NodeRMIInterface r = Util.getRMIInterface(hosts[i]);
			r.monitor_Register(evt);	
			validHosts.addElement(hosts[i]);
			}catch(Exception cp) {
				Util.removeRMIInterface(hosts[i]);
				MonitorErrorEvent e = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.REGISTER,evt.getRegisterTime(),cp.toString());
				try {
					if (tran!=null)
					{
						tran.sendEvent(e);
					}
				}catch(IOException ex) 
				{
					registryTable.remove(EventTransceiver.current);
				};
			}
		}
		if (validHosts.size()==0)
			return false;
			
		if (validHosts.size()<hosts.length)
		{
			hosts = new String[validHosts.size()];
			for (int i=0;i<validHosts.size();i++)
				hosts[i] = (String) validHosts.elementAt(i);
			evt.setTargets(hosts);
		}
		return true;
	}

	public static boolean unregister(MonitorRegistryEvent evt) {
		Resource rs = null;
		EventTransceiver tran = getTransceiver(evt);

		if (resourceTable.containsKey(evt.getResourceName()))
			rs = (Resource) resourceTable.get(evt.getResourceName());
		else
		{
			try {
			rs = (Resource) Util.instanceClass(evt.getResourceName());	
			if (rs!=null)
				resourceTable.put(evt.getResourceName(),rs);
			}catch(Exception ee) {};
		}

		if (rs==null) {
			MonitorErrorEvent e = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.UNREGISTER,evt.getRegisterTime(),evt.getResourceName()+":No such class");
			try {
				tran.sendEvent(e);
			}catch(IOException ex) 
			{
				registryTable.remove(EventTransceiver.current);
			};
			return false;
		}

		if (rs.isValueFromServer())
		{
			if (monTable.containsKey(evt.getResourceName()))
			{
				MonitorThread t = (MonitorThread) monTable.get(evt.getResourceName());
				if (!t.isAlive())
					monTable.remove(evt.getResourceName());
				else
				{
					t.removeElement(evt);
					if (t.size()==0)
						monTable.remove(evt.getResourceName());
				}
			}
			return true;
		}

		String[] hosts = evt.getTargets();
		hosts = transGroup(hosts);
		if (hosts==null) return true;
		for (int i=0;i<hosts.length;i++)
		{
			if (hosts[i]==null) continue;
			try {
			NodeRMIInterface r = Util.getRMIInterface(hosts[i]);
			r.monitor_Unregister(evt);	
			}catch(Exception cp) {
				Util.removeRMIInterface(hosts[i]);
				MonitorErrorEvent e = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.UNREGISTER,evt.getRegisterTime(),cp.toString());
				try {
					tran.sendEvent(e);
				}catch(IOException ex) 
				{
					registryTable.remove(EventTransceiver.current);
				};
			}
		}
		return true;
	}
		
	public static boolean update(MonitorRegistryEvent evt, MonitorRegistryEvent obj)
	{
		Resource rs = null;
		EventTransceiver tran = getTransceiver(evt);
		if (resourceTable.containsKey(evt.getResourceName()))
			rs = (Resource) resourceTable.get(evt.getResourceName());
		else
		{
			try {
			rs = (Resource) Util.instanceClass(evt.getResourceName());	
			}catch(Exception ee) {};
		}

		if (rs==null) {
			MonitorErrorEvent e = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.UPDATE,evt.getRegisterTime(),evt.getResourceName()+":No such class");
			try {
				tran.sendEvent(e);
			}catch(IOException ex) 
			{
				registryTable.remove(EventTransceiver.current);
			};
			return false;
		}

		if (rs.isValueFromServer()) {
			if (monTable.containsKey(evt.getResourceName()))
			{
				MonitorThread t = (MonitorThread) monTable.get(evt.getResourceName());
				if (!t.isAlive())
				{
					monTable.remove(evt.getResourceName());
					t = new MonitorThread(evt.getResourceName());
					monTable.put(evt.getResourceName(),t);
					t.addElement(evt);
					System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
					t.start();
				}
				else
					t.updateElement(evt);
			}
			else {
				MonitorThread t0 = new MonitorThread(evt.getResourceName());
				monTable.put(evt.getResourceName(),t0);
				t0.addElement(evt);
				System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
				t0.start();
			}
			return true;
		}

		String[] hosts1 = evt.getTargets();
		hosts1 = transGroup(hosts1);
		String[] hosts2 = obj.getTargets();
		hosts2 = transGroup(hosts2);

		String[] effectHosts = null;
		if (hosts1==null) 
			effectHosts = hosts2;
		else
			effectHosts = hosts1;
		
		if (effectHosts==null) return true;

		Vector validHosts = new Vector();
		for (int i=0;i<effectHosts.length;i++)
		{
			if (effectHosts[i]==null) continue;
			try {
			NodeRMIInterface r = Util.getRMIInterface(effectHosts[i]);
			r.monitor_Update(evt);	
			validHosts.addElement(effectHosts[i]);
			}catch(Exception cp) {
				Util.removeRMIInterface(effectHosts[i]);
				MonitorErrorEvent e = new MonitorErrorEvent(evt.getResourceName(),MonitorErrorEvent.UPDATE,evt.getRegisterTime(),cp.toString());
				try {
					tran.sendEvent(e);
				}catch(IOException ex) 
				{
					registryTable.remove(EventTransceiver.current);
				}
			}
		}

		if (validHosts.size()==0)
			return false;
			
		if (validHosts.size()<effectHosts.length)
		{
			effectHosts = new String[validHosts.size()];
			for (int i=0;i<validHosts.size();i++)
				effectHosts[i] = (String) validHosts.elementAt(i);
			evt.setTargets(effectHosts);
		}
		return true;
	}

	public static String[] transGroup(String[] h)
	{
		if (h==null||h.length==0) return h;
		Vector vt = new Vector();
		for (int i=0;i<h.length;i++)
		{
			if (Resource.groupToHost.containsKey(h[i]))
			{
				Vector gv = (Vector) Resource.groupToHost.get(h[i]);
				for (int j=0;j<gv.size();j++)
					vt.addElement(gv.elementAt(j));
			}
			else
				vt.addElement(h[i]);
		}
		String[] newHost = new String[vt.size()];
		for (int i=0;i<vt.size();i++)
			newHost[i] = (String) vt.elementAt(i);
		return newHost;
	}
}
