/*
 * @(#) ScriptCondition.java 99/3/15
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.monitor;
 
import java.util.Hashtable;
import java.util.Vector;
/**
 * Define the conditions used by scripts.
 *
 * @author Jimmy Liang
 * @version 1.00 3/15/99
 */

public class ScriptCondition extends Condition
{
	public static final int MATH = 0;
	public static final int STRING = 1;
	String eventScript = null;
	String rearmScript = null;
	boolean isRearm = true;
	int type = MATH;

	public ScriptCondition(String eventScript, String rearmScript)
	{
		this.eventScript = eventScript;
		this.rearmScript = rearmScript;
	}

	public ScriptCondition(String eventScript, String rearmScript, int type)
	{
		this.eventScript = eventScript;
		this.rearmScript = rearmScript;
		this.type = type;
	}

	public int getType()
	{
		return type;
	}

	public void setType(int type)
	{
		this.type = type;
	}

	public int checkStatus(Object nowValue, Object prevValue)
	{
		if (eventScript == null) 
			return DATA;

		if (type==MATH)
		{
			if (!isRearm && (isRearm=compute(nowValue,prevValue,rearmScript)))
				return REARM;

			if (compute(nowValue,prevValue,eventScript))
				if (isRearm)
				{
					isRearm = false;
					return EVENT;
				}
		}
		return DATA;
	}

	public boolean compute(Object nowValue, Object prevValue, String script)
	{
		if (script==null) return true;
		Hashtable ht = new Hashtable();
		try {
		if (nowValue!=null)
		{
			Vector vt = (Vector) nowValue;
			for (int i=0;i<vt.size();i++)
			{
				if (i==0) continue;
				String rep = "%"+i;
				ht.put(rep,vt.elementAt(i));
			}
		}
		if (prevValue!=null)
		{
			Vector vt = (Vector) prevValue;
			for (int i=0;i<vt.size();i++)
			{
				if (i==0) continue;
				String rep = "!"+i;
				ht.put(rep,vt.elementAt(i));
			}
		}
		}catch(Exception e) {
			System.out.println(e);
			return true;
		}

		return compute(ht,script);
	}
	
	public boolean compute(Hashtable ht, String script)
	{
		int index = -1;
System.out.println(script);
		index = script.indexOf("&&");
		try {
		if (index!=-1)
		{
			String s1 = script.substring(0,index);
			String s2 = script.substring(index+2,script.length());
			return (compute(ht,s1)&&compute(ht,s2));
		}	

		index = script.indexOf("||");
		if (index!=-1)
		{
			String s1 = script.substring(0,index);
			String s2 = script.substring(index+2,script.length());
			return compute(ht,s1)||compute(ht,s2);
		}	

		int locate = 0;
		index = script.indexOf(">");
		if (index==-1)
		{
			index = script.indexOf("<");
			locate++;
		}
		if (index==-1)
		{
			index = script.indexOf("!=");
			locate++;
		}
		if (index==-1)
		{
			index = script.indexOf("==");
			locate++;
		}
		if (index==-1)
			return true;

		String s1 = script.substring(0,index);
		String s2 = null;
		if (locate<2)
			s2 = script.substring(index+1,script.length());
		else
			s2 = script.substring(index+2,script.length());

		TermTranslate term1 = new TermTranslate(s1);
		TermTranslate term2 = new TermTranslate(s2);
		term1.setAgv(ht);
		term2.setAgv(ht);
		s1 = term1.compute();
		s2 = term2.compute();
		if (s1==null||s2==null) return true;
	
		index = s1.indexOf(".");
		if (index==-1)
		{
			int i1 = Integer.parseInt(s1);
			index = s2.indexOf(".");
			if (index==-1)
			{
				int i2 = Integer.parseInt(s2);
				if (locate==0)
					return (i1>i2);
				if (locate==1)
					return (i1<i2);
				if (locate==2)
					return (i1!=i2);
				if (locate==3)
					return (i1==i2);
				return true;
			}
			else {
				float f2 = Float.valueOf(s2).floatValue();
				if (locate==0)
					return (i1>f2);
				if (locate==1)
					return (i1<f2);
				if (locate==2)
					return (i1!=f2);
				if (locate==3)
					return (i1==f2);
				return true;
			}
		}
		else 
		{
			float f1 = Float.valueOf(s1).floatValue();
			index = s2.indexOf(".");
			if (index==-1)
			{
				int i2 = Integer.parseInt(s2);
				if (locate==0)
					return (f1>i2);
				if (locate==1)
					return (f1<i2);
				if (locate==2)
					return (f1!=i2);
				if (locate==3)
					return (f1==i2);
				return true;
			}
			else {
				float f2 = Float.valueOf(s2).floatValue();
				if (locate==0)
					return (f1>f2);
				if (locate==1)
					return (f1<f2);
				if (locate==2)
					return (f1!=f2);
				if (locate==3)
					return (f1==f2);
				return true;
			}
		}
		}catch(Exception e) {
			System.out.println(e);
			return true;
		}
	}

	public static void main(String[] args)
	{
		String es = "(22+23)+4>(33-22)&&(77+5)*2!=88";
		String rs = "(22+33)>50";
		ScriptCondition sc = new ScriptCondition(es,rs);
		System.out.println(sc.checkStatus(null,null));	
		System.out.println(sc.checkStatus(null,null));	
		System.out.println(sc.checkStatus(null,null));	
		System.out.println(sc.checkStatus(null,null));	
	}
		
				
}
