/*
 * @(#) ScriptReact.java 99/3/11
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.monitor;
 
import CLUSTERPROBE.resources.Util;

/**
 * Define the reactions which execute a specify script file as trigering.
 *
 * @author Jimmy Liang
 * @version 1.00 3/11/99
 */

public class  ScriptReact extends React
{
	String script1 = null;
	String script2 = null;
	String script3 = null;
	String script4 = null;

	int timeout1 = 5000;
	int timeout2 = 5000;
	int timeout3 = 5000;
	int timeout4 = 5000;

	public final static int REACT_NODE  = 1;
	public final static int REACT_GLOBAL = 2;
	public final static int REARM_NODE = 3;
	public final static int REARM_GLOBAL = 4;

	public ScriptReact(String s1, String s2, String s3, String s4)
	{
		script1 = s1;
		script2 = s2;
		script3 = s3;
		script4 = s4;
	}

	public void setScript(int id,String s)
	{
		switch(id)
		{
		case REACT_NODE:
			script1 = s;
			break;
		case REACT_GLOBAL:
			script2 = s;
			break;
		case REARM_NODE:
			script3 = s;
			break;
		case REARM_GLOBAL:
			script4 = s;
			break;
		}
	} 

	public void setTimeout(int id, int t)
	{
		switch(id)
		{
		case REACT_NODE:
			timeout1 = t;
			break;
		case REACT_GLOBAL:
			timeout2 = t;
			break;
		case REARM_NODE:
			timeout3 = t;
			break;
		case REARM_GLOBAL:
			timeout4 = t;
			break;
		}
	}

	public String getScript(int id)
	{
		switch(id)
		{
		case REACT_NODE:
			return script1;
		case REACT_GLOBAL:
			return script2;
		case REARM_NODE:
			return script3;
		case REARM_GLOBAL:
			return script4;
		}
		return null;
	}

	public int getTimeout(int id)
	{
		switch(id)
		{
		case REACT_NODE:
			return timeout1;
		case REACT_GLOBAL:
			return timeout2;
		case REARM_NODE:
			return timeout3;
		case REARM_GLOBAL:
			return timeout4;
		}
		return 0;
	}

	public boolean reaction_node(CLUSTERPROBE.message.JessicEvent event)
	{
		return runScript(script1,timeout1);
	}

	public boolean reaction_global(CLUSTERPROBE.message.JessicEvent event)
	{
		return runScript(script2,timeout2);
	}
	

	public boolean rearm_node(CLUSTERPROBE.message.JessicEvent event)
	{
		return runScript(script3,timeout3);
	}

	public boolean rearm_global(CLUSTERPROBE.message.JessicEvent event)
	{
		return runScript(script4,timeout4);
	}

	public boolean runScript(String s, int t)
	{
		if (s==null) return true;
		try {
		Process p = Runtime.getRuntime().exec(s);
		int count = 0;
		while (true)
		{
			try {
			int exitValue = p.exitValue();
			if (exitValue!=0)
			{
				setErrMessage(Util.getProcessErrMsg(p));
				return false;
			}
			else
			{
				setResultMessage(Util.getProcessMsg(p));	
				return true;
			}
			}catch(Exception ev) {
				if (t<=(count*2000))
				{
					p.destroy();
					setErrMessage("Executing command "+s+" is timeout."); 
					return false;
				}
				count++;
				try{
				Thread.sleep(2000);
				}catch(Exception e){};
			}
		}
		}catch(Exception exp) {
			setErrMessage("Executing command "+s+" ocurres error:"+exp);
			return false;
		}
	}
		
}
