/*
 * @(#) TermTranslate.java 99/3/19
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.monitor;
 
import java.util.*;

/**
 * The class can translate a input string to computation term and got the result.
 *
 * @author Jimmy Liang
 * @version 1.00 3/19/99
 */

public class TermTranslate  extends Object 
{
// The arguments with their reprensitive string
Hashtable agv = new Hashtable();
// The translated string
String str = null;

	public TermTranslate(String term)
	{
		str = term;
	}

	//set argument
	public void setAgv(String rep, Object val)
	{
		if (agv.contains(rep))
			agv.remove(rep);
		agv.put(rep,val);
	}
	public void setAgv(Hashtable ht)
	{
		agv = ht;
	}
	
	//remove argument
	public void removeAgv(String rep)
	{
		agv.remove(rep);
	}

	//clear the arguments
	public void clear()
	{
		agv.clear();
	}

	//get argument
	public Object getAgv(String rep)
	{
		return agv.get(rep);
	}
	public Hashtable getAgv()
	{
		return agv;
	}

	//check the input string whether it is legal to translate
	String errMessage = null;
	public boolean check() {
		return check(str);
	}

	public boolean check(String ss)
	{
		if (ss==null) 
		{
			errMessage = " The input string is null!";
			System.out.println(errMessage);
			return false;
		}

		int count0 = 0;
		int count1 = 0;
		for (int i=0;i<ss.length();i++)
		{
			if (ss.charAt(i)==')')
				count0++;
			else if (ss.charAt(i)=='(')
				count1++;
		}

		if (count0!=count1)
		{
			errMessage = " The number of charaters `(` and number of character `)` are not equal each other!";
			System.out.println(errMessage);
			return false;
		}
		
		return true;
	}

	// do the computation term
	public String compute()
	{
		if (str==null) compute(str);

		Enumeration en = agv.keys();
		while (en.hasMoreElements())
		{
			String rep = (String) en.nextElement();
			Object obj = agv.get(rep);
			int index = 0;
			while ((index=str.indexOf(rep))!=-1)
			{
				str = str.substring(0,index)+obj.toString()+str.substring(index+rep.length(),str.length());
			}	
		}
		System.out.println("begin to compute : "+str);
		String result = compute(str);
		if (result!=null)
			result=result.replace('@','-');
		return result;
	}

	public String compute(String ss)
	{
		if (!check(ss)) return null;

try {
		StringBuffer strb = new StringBuffer();
		int signal = 0;
		int start = 0;

		for (int i=0;i<ss.length();i++)
		{
			if (signal==0&&ss.charAt(i)!=')'&&ss.charAt(i)!='(')
			{
				strb.append(ss.charAt(i));
				continue;
			}

			if (ss.charAt(i)=='(')
			{
				if (signal==0)
					start = i+1;
				signal++;
				continue;
			}


			if (ss.charAt(i)==')')
			{
				signal--;
				if(signal==0)
				{
					String substring = ss.substring(start,i);
					Object obj = compute(substring);
					if (obj==null) 
						return null;
					strb.append(obj.toString());
				}
			}
		}

		String term = strb.toString();
		for (int i=0;i<Method.MINPRIORITY;i++)
		{
			Vector v = new Vector();
			Enumeration en = Method.methods.elements();
			while (en.hasMoreElements())
			{
				Method md = (Method) en.nextElement();
				if (md.getPriority()==i)
					v.addElement(md);
			}	

			if (v.size()==0) continue;

			while (true)
			{
				int locate = 300;
				int mdIndex = -1;
				for(int j=0;j<v.size();j++)
				{
					Method md = (Method) v.elementAt(j);
					int index = term.indexOf(md.getMark());
					if (index!=-1&&index<locate)
					{
						locate = index;
						mdIndex = j;
					}
				}
				if (locate>256) break;	
				Method md = (Method) v.elementAt(mdIndex);
				String mark = md.getMark();

				if (md.size()==1)
				{	
					int end = getEnd(term.substring(locate+mark.length(),term.length()),true);
					if (end==-1)
					{
						end = getEnd(term.substring(0,locate),false);
						if (end==-1)
						{
							errMessage = "Wrong format for "+md.getMark()+" !";
							System.out.println(errMessage);
							return null;
						}
						end = locate - end - 1;
						Object obj = md.does(term.substring(end,locate),errMessage);
						if (obj==null) return null;
						term = term.substring(0,end)+obj.toString()+term.substring(locate+mark.length(),term.length());
						
					}
					else 
					{
						end = locate + end + mark.length();
						Object obj = md.does(term.substring(locate+mark.length(),end+1),errMessage);
						if (obj==null) return null;
						term = term.substring(0,locate)+obj.toString()+term.substring(end+1,term.length());
					}
				}

				else if (md.size()==2)
				{	
					int end1 = getEnd(term.substring(locate+mark.length(),term.length()),true);
					int end2 = getEnd(term.substring(0,locate),false);
					if (mark.equals("-")&&end2==-1)
					{
						term = term.substring(0,locate)+"@"+term.substring(locate+1,term.length());
						continue;
					}
						
					if (end1==-1||end2==-1)
					{
						errMessage = "Wrong format for "+md.getMark()+" !";
						System.out.println(errMessage);
						return null;
					}
					Object obj = md.does(term.substring(locate-end2-1,locate),term.substring(locate+mark.length(),locate+mark.length()+end1+1),errMessage);
					if (obj==null) return null;
					term = term.substring(0,locate-end2-1)+obj.toString()+term.substring(locate+mark.length()+end1+1,term.length());
				}
			}
		}
				
		return term;
}catch(Exception e) {
		errMessage = e.toString();
		return null;
}
	}

	public int getEnd(String s, boolean b)
	{
		if (s==null||s.length()==0) return -1;
		int i= 0;
		if (b)
		{
			for ( i=0;i<s.length();i++)
			{
				if (i==0&&s.startsWith("@"))
					continue;
				if (((s.charAt(i)<'0')||(s.charAt(i)>'9'))&&(s.charAt(i)!='.'))
					return i-1;
			}
		}
		else
		{
			for ( i=0;i<s.length();i++)
			{
				if (i==0&&s.startsWith("@"))
					continue;
				if (((s.charAt(s.length()-i-1)<'0')||(s.charAt(s.length()-i-1)>'9'))&&(s.charAt(s.length()-i-1)!='.'))
					return i-1;
			}
		}
		return i-1;
	}
			
	public static void main(String[] args)
	{
		String t = "(4+(7-2))*5-4+(5-7)";
		if (args.length>0)
			t  = args[0];
		TermTranslate term = new TermTranslate(t);
		term.setAgv("%1","22.2");
		term.setAgv("%2","11.1");
		String result = term.compute();
		if (result==null)
			System.out.println(term.errMessage);
		else
			System.out.println(result);
	}
}
	
class Method extends Object
{
	// The Math methods the class currently support
	public static Vector methods ;
	public static int MINPRIORITY = 5; 
	String mark = null;
	int priority;
	int size;

	static {
		methods = new Vector();
		methods.addElement(new Method("*",2,3));
		methods.addElement(new Method("/",2,3));
		methods.addElement(new Method("+",2,4));
		methods.addElement(new Method("-",2,4));
	};

	public Method(String mark, int size, int priority)
	{
		this.mark = mark;
		this.priority = priority;
		this.size = size;
	}
		
	public void setMark(String m)
	{
		mark = m;
	}

	public String getMark()
	{
		return mark;
	}

	public void setSize(int s)
	{
		size = s;
	}

	public int size()
	{
		return size;
	}

	public void setPriority(int p)
	{
		priority = p;
	}				

	public int getPriority()
	{
		return priority;
	}

	public Object does(String t, String err)
	{
		return null;
	}

	public Object does(String t0,String t1, String err)
	{
		t0 = t0.trim();
		t1 = t1.trim();

		int index = t0.indexOf(".");
		if (t0.startsWith("@"))
			t0 = t0.replace('@','-');
		if (t1.startsWith("@"))
			t1 = t1.replace('@','-');

		try {
		String mark = getMark();
		String result = null;
		if (index!=-1) {
			float f0 = Float.valueOf(t0).floatValue();
			index = t1.indexOf(".");
			if (index==-1)
			{
				int i1 = Integer.parseInt(t1);
				if (mark.equals("*"))
					result = (new Float(f0*i1)).toString();
				if (mark.equals("/"))
					result = (new Float(f0/i1)).toString();
				if (mark.equals("+"))
					result = (new Float(f0+i1)).toString();
				if (mark.equals("-"))
					result =  (new Float(f0-i1)).toString();
			}
			else
			{
				float f1 = Float.valueOf(t1).floatValue();
				if (mark.equals("*"))
					result = (new Float(f0*f1)).toString();
				if (mark.equals("/"))
					result = (new Float(f0/f1)).toString();
				if (mark.equals("+"))
					result = (new Float(f0+f1)).toString();
				if (mark.equals("-"))
					result = (new Float(f0-f1)).toString();
			}
		}
		else {
			int i0 = Integer.parseInt(t0);
			index = t1.indexOf(".");
			if (index==-1)
			{
				int i1 = Integer.parseInt(t1);
				if (mark.equals("*"))
					result = (new Integer(i0*i1)).toString();
				if (mark.equals("/"))
					result = (new Integer(i0/i1)).toString();
				if (mark.equals("-"))
					result = (new Integer(i0-i1)).toString();
				if (mark.equals("+"))
					result = (new Integer(i0+i1)).toString();
			}
			else
			{
				float f1 = Float.valueOf(t1).floatValue();
				if (mark.equals("*"))
					result = (new Float(i0*f1)).toString();
				if (mark.equals("/"))
					result = (new Float(i0/f1)).toString();
				if (mark.equals("+"))
					result = (new Float(i0+f1)).toString();
				if (mark.equals("-"))
					result = (new Float(i0-f1)).toString();
			}
			if (result!=null)
			{
				if (result.startsWith("-"))
					result = result.replace('-','@');
			}
		}
		return result;
		}catch(Exception e)
		{
			System.out.println(e);
			err = e.toString();
		}
		return null;
	}

}
			

					
		
			
