/*
 * @(#) Cluster_GroupDetail.java 01/2/24
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;
import java.io.File;

/**
 * Define the resource format of Cluster-GroupDetail
 * by WangLin
 */

public class Cluster_GroupDetail extends ResourceTable
{
	String[] entryNames = {"Workstation Name","Workstation Aliase","Primary Group","Memo","Device Type","Location"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.SHORT,Resource.STRING};
	int[] entryMaxLen = {21,21,16,30,5,25};
	public static int WORKSTATION = 0;
	public static int HUB = 1;
	public static int SWITCH = 2;

	public Cluster_GroupDetail()
	{
		setUpdateTime(3*60*60*1000);
		setMinTime(60*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		BufferedReader d = null;
		
		try{
			File file = new File("/etc/node_resolv");
			if( !file.exists()) return null;
		}catch(Exception e) {
			System.out.println("Error while reading node_resolv file:"+e.toString());
			addErrorEvent("Error while reading node_resolv file:"+e.toString());
			return null;
		}
		
		try {
			 FileInputStream in = new FileInputStream("/etc/node_resolv");
			 d = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e) {
			System.out.println("Error while reading node_resolv file:"+e.toString());
			addErrorEvent("Error while reading node_resolv file:"+e.toString());
			return null;
		}
		if (d==null) return null;

		String line = null;
		
		try{
		while ((line=d.readLine())!=null)
		{
			try {
			line = line.trim();
			if (line.startsWith("#")) continue;
			StringTokenizer st = new StringTokenizer(line);
			int count = st.countTokens();
			if (count<3) continue;
			
			String name = st.nextToken();
			String alais = st.nextToken();
			String group = st.nextToken();
			String memo = "";
			boolean starts = false;
			for (int ii=4;ii<count;ii++)
			{
				String tmpString = st.nextToken();
				if (!starts)
				{
					if (tmpString.startsWith("\""))
					{
						starts = true;
						if (tmpString.endsWith("\""))
						{
							memo = tmpString.substring(1,tmpString.length()-1);
							break;
						}
						tmpString=tmpString.substring(1,tmpString.length());
					}
					else
					{
						memo = memo + " "+tmpString;
						break;
					}
				}
				else
				{
					if (tmpString.endsWith("\""))
					{
						tmpString = tmpString.substring(0,tmpString.length()-1);
						memo =  memo+" "+ tmpString;
						break;
					}
				}
				memo = memo+" "+tmpString;
			}
			int type = WORKSTATION;
			String location = "";
			if (st.hasMoreTokens())
				type = Integer.parseInt(st.nextToken());
			if (st.hasMoreTokens())
				location = st.nextToken();
			

			Vector v = new Vector();
			v.addElement(name);
			v.addElement(alais);
			v.addElement(group);
			v.addElement(memo);
			v.addElement(new Integer(type));
			v.addElement(location);
			ht.put(name,v);
			}catch(Exception ex){
				addErrorEvent("Error while parsing node_resolv file:"+ex.toString());
			};
		}
		}catch(Exception exc){
			System.out.println(exc);
			addErrorEvent("Error while parsing node_resolv file:"+exc.toString());
		}
		try {
			d.close();
		}catch(Exception ee){};
		return ht;
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_CPUInfo rs = new Cluster_Workstation_CPUInfo();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		Enumeration en = ht.keys();
		while (en.hasMoreElements())
		{
			Object obj = en.nextElement();
			Vector vt = (Vector) ht.get(obj);
			System.out.println("size:"+vt.size());
			for (int i=0;i<vt.size();i++)
			{
				Object oo = vt.elementAt(i);
				System.out.println(i+":"+oo);
			}
		}
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "Group Detail";
	}	
}
