/*
 * @(#) Cluster_GroupLists.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of cluster group lists.
 *
 * @author Jimmy Liang
 * @version 1.00 4/23/99
 */

public class Cluster_GroupLists extends ResourceTable
{
	String[] entryNames = {"Group Name","Group Description","Server"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING};
		
	int[] entryMaxLen = {21,21,16};

	public Cluster_GroupLists() 
	{
		setUpdateTime(3*60*60*1000);
		setMinTime(60*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return true;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.SIGLETABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getTable()
	{
		Hashtable ht = new Hashtable();
		BufferedReader d = null;

		try {
			FileInputStream in = new FileInputStream("/etc/queue.conf");
			d = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e) {
			System.out.println("Error while reading queue.conf file:"+e.toString());
			addErrorEvent("Error while reading group.conf file:"+e.toString());
			return null;
		}
		if (d==null) return null;

		String line = null;
	
		try {
		while ((line=d.readLine())!=null)
		{
			try {
			line = line.trim();
			if (line.startsWith("#")) continue;
			StringTokenizer st = new StringTokenizer(line);
			if (st.countTokens()!=3) continue;
			
			String name = st.nextToken();
			String description = st.nextToken();
			String server = st.nextToken();

			Vector v = new Vector();
			v.addElement(name);
			v.addElement(description);
			v.addElement(server);
			ht.put(name,v);
			}catch(Exception ex){
				addErrorEvent("Error while parsing queue.conf file:"+ex.toString());
			};
		}
		}catch(Exception exc){
			System.out.println(exc);
			addErrorEvent("Error while parsing queue.conf file:"+exc.toString());
		}
		try {
			d.close();
		}catch(Exception ee){};
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_GroupLists rs = new Cluster_GroupLists();
		Hashtable ht = rs.getTable();
		System.out.println(ht.size());
		System.out.println(ht);
	}

	public String getDesc()
	{
		return "Cluster Group List";
	}
}
