//Author: WangLin
//Last modified: 01/7/27

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of HA Node pair lists.
 */

public class Cluster_HANodepairList extends ResourceTable
{
	String[] entryNames = {"HA Nodepair name","Node1","Node2"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING};
		
	int[] entryMaxLen = {21,21,21};

	public Cluster_HANodepairList() 
	{
		setUpdateTime(3*60*60*1000);
		setMinTime(60*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return true;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.SIGLETABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getTable()
	{
		Hashtable ht = new Hashtable();
		BufferedReader d = null;

		try {
			FileInputStream in = new FileInputStream("/etc/HAnodepair");
			d = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e) {
			System.out.println("Error while reading queue.conf file:"+e.toString());
			addErrorEvent("Error while reading group.conf file:"+e.toString());
			return null;
		}
		if (d==null) return null;

		String line = null;
	
		try {
		while ((line=d.readLine())!=null)
		{
			try {
			line = line.trim();
			if (line.startsWith("#")) continue;
			StringTokenizer st = new StringTokenizer(line);
			if (st.countTokens()!=3) continue;
			
			String HAappname = st.nextToken();
			String PriNode = st.nextToken();
			String SecNode = st.nextToken();
			//String Status = st.nextToken();
			
			Vector v = new Vector();
			v.addElement(HAappname);
			v.addElement(PriNode);
			v.addElement(SecNode);
			//v.addElement(Status);
			ht.put(HAappname,v);
			}catch(Exception ex){
				addErrorEvent("Error while parsing queue.conf file:"+ex.toString());
			};
		}
		}catch(Exception exc){
			System.out.println(exc);
			addErrorEvent("Error while parsing queue.conf file:"+exc.toString());
		}
		try {
			in.close();
			d.close();
		}catch(Exception ee){};
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_HANodepairList rs = new Cluster_HANodepairList();
		Hashtable ht = rs.getTable();
		System.out.println(ht.size());
		System.out.println(ht);
	}

	public String getDesc()
	{
		return "Cluster HA Node Pairs List";
	}
}
