//Author: WangLin
//Last modified: 06/08/01

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.*;

/**
 * Define the resource format of HA application lists.
 */

public class Cluster_HAappLists extends ResourceTable
{
	String[] entryNames = {"HA App Name","HA Node Pair","Primary Node","Secondary Node"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING};
		
	String Appname="";
	String Nodepair="";
	String Prinode="";
	String Secnode="";
	String Oper="";
	String filename="HAapps.conf";
	
	
	int[] entryMaxLen = {21,21,16};

	public void setAppname(String ref)
	{
		Appname=ref;
	}
	public void setNodepair(String ref)
	{
		Nodepair=ref;
	}
	public void setPrinode(String ref)
	{
		Prinode=ref;
	}
	public void setSecnode(String ref)
	{
		Secnode=ref;
	}
	public String getAppname()
	{
		return Appname;
	}
	public void setOper(String ref)
	{
		Oper=ref;
	}
	public String getOper()
	{
		return Oper;
	}
	public String getNodepair()
	{
		return Nodepair;
	}
	public String getPrinode()
	{
		return Prinode;
	}
	public String getSecnode()
	{
		return Secnode;
	}
	public Cluster_HAappLists() 
	{
		setUpdateTime(3*60*60*1000);
		setMinTime(60*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return true;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.SIGLETABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}
	public void cpfile(String fromfile,String tofile)
	{
		try{
				File inputFile = new File(fromfile);
				File outputFile = new File(tofile);

				FileReader in = new FileReader(inputFile);
				FileWriter out = new FileWriter(outputFile);
				int c;

				while ((c = in.read()) != -1)
					out.write(c);

				in.close();
				out.close();
    		}catch(IOException e){
			System.out.println("Exception:"+e);
			}
	}
	public void writeToFile()
	{
		boolean debugflag=true;
		String dir="/etc/HAscript/tmp/";
		String file=dir+filename;
		//copy /etc/HAapps.conf to /etc/HAscript/tmp/
		//delete
		//if(getHAop().equals("delete"))
		try{
			if(debugflag) System.out.println("delete HA application:"+getAppname());
			RandomAccessFile in=new RandomAccessFile("/etc/"+filename,"r");
			FileWriter out=new FileWriter(file);				
			
			String line="";
			while((line=in.readLine())!=null)
			{
				if(debugflag) System.out.println("Line:"+line);
				StringTokenizer st1=new StringTokenizer(line," ");
				String word=null;
				if(st1.hasMoreTokens())
				{
					word=st1.nextToken();
					//System.out.println("word:"+word);
					if(!word.equals(getAppname()))
					{
						if(debugflag) System.out.println(word+" != "+getAppname());
						for(int i=0;i<line.length();i++)
							out.write(line.charAt(i));
						out.write('\n');
					}else
					{
						String np=st1.nextToken();
						String pn=st1.nextToken();
						String sn=st1.nextToken();
						if((!pn.equals(getPrinode()))||(!sn.equals(getSecnode())))
						{
							for(int i=0;i<line.length();i++)
								out.write(line.charAt(i));
							out.write('\n');
						}
					}
				}
			}
							
			in.close();
			out.close();
			if(debugflag) System.out.println("end of Delete HA application:"+getAppname());
   		}catch(IOException e){
			System.out.println("Exception:"+e);
		}
	
		if(getOper().equals("add"))
		{
			//add
			try{
				System.out.println("Add HA App");
				String fl="/etc/"+filename;
				File inputFile = new File(file);
				File outputFile = new File(fl);

				FileReader in = new FileReader(inputFile);
				FileWriter out = new FileWriter(outputFile);
				int c;

				while ((c = in.read()) != -1)
					out.write(c);

				String tmp="\n"+getAppname()+" "+getNodepair()+" "+getPrinode()+" "+getSecnode();
				for(int i=0;i<tmp.length();i++)
					out.write(tmp.charAt(i));
				in.close();
				out.close();
			}catch(IOException e){
				System.out.println("Exception:"+e);
			}	
		} else if(getOper().equals("delete"))
			//copy back
			cpfile("/etc/HAscript/tmp/HAapps.conf","/etc/HAapps.conf");
		else 
			System.out.println("Wrong Operation.");
	}
	public Hashtable getTable()
	{
		Hashtable ht = new Hashtable();
		BufferedReader d = null;

		try {
			FileInputStream in = new FileInputStream("/etc/HAapps.conf");
			d = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e) {
			System.out.println("Error while reading queue.conf file:"+e.toString());
			addErrorEvent("Error while reading group.conf file:"+e.toString());
			return null;
		}
		if (d==null) return null;

		String line = null;
	
		try {
		while ((line=d.readLine())!=null)
		{
			try {
			line = line.trim();
			if (line.startsWith("#")) continue;
			StringTokenizer st = new StringTokenizer(line);
			if (st.countTokens()!=4) continue;
			
			String HAappname = st.nextToken();
			String HAnodepair = st.nextToken();
			String PriNode = st.nextToken();
			String SecNode = st.nextToken();
			//String Status = st.nextToken();
			
			Vector v = new Vector();
			v.addElement(HAappname);
			v.addElement(HAnodepair);
			v.addElement(PriNode);
			v.addElement(SecNode);
			//v.addElement(Status);
			ht.put(HAappname,v);
			}catch(Exception ex){
				addErrorEvent("Error while parsing queue.conf file:"+ex.toString());
			};
		}
		}catch(Exception exc){
			System.out.println(exc);
			addErrorEvent("Error while parsing queue.conf file:"+exc.toString());
		}
		try {
			d.close();
		}catch(Exception ee){};
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_HAappLists rs = new Cluster_HAappLists();
		Hashtable ht = rs.getTable();
		System.out.println(ht.size());
		System.out.println(ht);
	}

	public String getDesc()
	{
		return "Cluster HA Application List";
	}
}
