// Author: WangLin 
// Last modified : 01/9/18

//package JESSIC.resources;
package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class Cluster_HAnode_StatusTable extends ResourceTable
{
	String[] entryNames = {"WorkstationName","State","Description","Load1","Load2","Load3"};
	int[] entryTypes = {Resource.STRING,Resource.SHORT,Resource.STRING,Resource.FLOAT,Resource.FLOAT,Resource.FLOAT};
	int[] entryMaxLen = {16,8,25,6,6,6};
		
	public final static int READY=1;
	public final static int WARNING=2;
	public final static int HANOTREADY=3;
	public final static int OVERLOAD=4;
	public final static int PACKETLOSING=5;
	public final static int ERROR=100;
	public final static int MALFORMEDURL=101;
	public final static int UNKNOWNHOST=102;
	public final static int CONNECTFAIL=103;
	public final static int RMINOTREADY=104;

	static String[] desc = {"Ready","Ready","Overload","Ready", "Swap_Closing_Full","Ready","Unreach","Ready", "Ready","Unreach","Ready","Ready", "Ready","Package_Losing","Ready","Ready"};

        static int[] st = {1,1,3,1, 3,1,2,1, 1,2,1,1, 1,3,1,1};
	
	static int count = 0;
	static int loop = 0;
	static int tempCount = 0;

	static int UPDATETIME=10000;
	static float loadLimited = (float)1.0;
	static int swapLimited = 500; 
	static int packetsReceived = 0;
	static int inDiscarded=0;
	static int packetsSent = 0;
	static int outDroped=0;
	static double losingLimited = 0.20;
	static boolean firstTime = true;

	Float[] loads = new Float[3];
	Integer state = new Integer(READY);
	String description = "READY";

	public Cluster_HAnode_StatusTable() {
		setUpdateTime(UPDATETIME);
		setMinTime(5000);
	}

	public Vector getVector() throws java.rmi.ServerRuntimeException
	{
		refresh();

                Vector v = new Vector();
                v.addElement(Util.getHostName());

		v.addElement(state);
		v.addElement(description);
		count++;
                return v;
        }

	public void refresh()
	{
		if (firstTime) firstTime = false;

		state = new Integer(READY);
		description = "READY";

		//refresh information
		getprocess("heartbeat");
		System.out.println("after: ps -e | grep heartbeat");
		/*if (description.equals("READY"))
		{	getprocess("mon");
			System.out.println("after: ps -e | grep mon");
		}*/
	}
	public void getprocess(String proname) 
	{
		try {
		String proname1 = "ps -e";
		Process p = Util.runCommand(proname1);
		String errMessage = Util.getProcessErrMsg(p);
		if (errMessage!=null) {
			System.out.println("process run error:"+errMessage);
			return;
		}

		DataInputStream in = new DataInputStream(p.getInputStream());	
		BufferedReader d = new BufferedReader(new InputStreamReader(in));

		String line = null;
		line=d.readLine();
		//System.out.println("line is:"+line);
		if(line==null)
		{
			System.out.println("not result line.");
			state = new Integer(HANOTREADY);	
			description = "HANOTREADY";
			p.destroy();
			return;
		}
		do
		{
			StringTokenizer st1=new StringTokenizer(line," ");
			String proc=null;
			while(st1.hasMoreTokens())
				proc=st1.nextToken();
			if (proc.equals(proname)) 
			{
				state = new Integer(READY);	
				description = "READY";
				break;
			}
		}while((line=d.readLine())!=null);
		
		if (line==null) 
		{
			state = new Integer(HANOTREADY);	
			description = "HANOTREADY";
			p.destroy();
			return;
		}
		
		p.destroy();
		} catch(Exception e) {
			System.out.println("caused error while call system process:"+e.toString());
		}
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.SIGLETABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Vector getVectorExceptionProcess(String host, Exception e)
	{
		Vector v = new Vector();
		
		v.addElement(host);

		if (e instanceof java.net.MalformedURLException)
		{
			v.addElement(new Integer(MALFORMEDURL));
			v.addElement("Malformed URL");
		}

		if (e instanceof java.rmi.UnknownHostException)
		{
			v.addElement(new Integer(UNKNOWNHOST));
			v.addElement("Unkown host");
		}

		if (e instanceof java.rmi.ConnectIOException)
		{
			v.addElement(new Integer(CONNECTFAIL));
			v.addElement("Unreachable");
		}
		else {
			v.addElement(new Integer(RMINOTREADY));
			v.addElement("RMI not ready");
		}
		v.addElement(new Float(10.0));
		v.addElement(new Float(10.0));
		v.addElement(new Float(10.0));
		return v;
	}
	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}
	
	public static void main(String[] args) {
		Cluster_HAnode_StatusTable rs = new Cluster_HAnode_StatusTable();
		rs.refresh();
		System.out.println(rs.state+": "+rs.description);
		try {
			Thread.sleep(5000);
		}catch(Exception e){};
		rs.refresh();
		System.out.println(rs.state+": "+rs.description);
	}

	public String getDesc()
	{
		return "Load Status";
	}
}
