/*
 * @(#) Cluster_JQS_JobStat.java 99/2/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 * Define the current Job lists.
 *
 * @author Jimmy Liang
 * @version 1.00 2/9/99
 */

public class Cluster_JQS_JobStat extends ResourceTable
{
	String[] entryNames = {"User Name","Job Name","Job Number", "Job Priority", "Stat","Exec_Hosts","Submit Time"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.SHORT,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING};
		
	int[] entryMaxLen = {15,20,6,6,12,20,25};

	public Cluster_JQS_JobStat() 
	{
		setUpdateTime(20*1000);
		setMinTime(10*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[2];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Vector getRange()
	{
		return Resource.qservers;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();

		try {
			Process p = Util.runCommand("/usr/local/DQS/bin/qstat32 -f");
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}
			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;
			boolean pending=false;
			boolean rjob = false;
			String chost = null;

			while ((line = d.readLine())!=null)
			{
				try {
				if (line.indexOf("Pending Jobs")!=-1) 
				{
					pending = true;
					continue;
				}

				StringTokenizer st = new StringTokenizer(line);
				int count = st.countTokens();
				if ((!pending)&&count==6)
				{
					chost = st.nextToken();
					continue;
				}
				if (count<7&&pending)
					continue;
		
				if (count<8&&!pending)
					continue;
			
				String uname = st.nextToken();
				String jname = st.nextToken();
				int jid = Integer.parseInt(st.nextToken());
				String priority = st.nextToken();
				String state = null;

				if (pending)
					state = st.nextToken();
				else
				{
					st.nextToken();
					state = st.nextToken();
				}
					
				StringBuffer strb = new StringBuffer();
				int tt = 0;
				while (true)
				{
					try{
					if (tt>2) break;	
					String ss = st.nextToken();
					strb.append(ss+" ");
					tt++;
					}catch(Exception ee){
						break;
					}
				}
				String time = new String(strb);


				if (pending)
				{
					Vector v = new Vector();
					v.addElement(uname);
					v.addElement(jname);
					v.addElement(new Integer(jid));
					v.addElement(priority);
					v.addElement(state);
					v.addElement("");
					v.addElement(time);
					ht.put(new Integer(jid),v);
				}
				else
				{
					if (ht.containsKey(new Integer(jid)))
					{
						Vector v = (Vector) ht.get(new Integer(jid));
						String vs = (String) v.elementAt(5);
						v.removeElementAt(5);
						vs = vs + ";" + chost;
						v.insertElementAt(vs,5);
					}
					else
					{
						Vector v = new Vector();
						v.addElement(uname);
						v.addElement(jname);
						v.addElement(new Integer(jid));
						v.addElement(priority);
						v.addElement(state);
						v.addElement(chost);
						v.addElement(time);
						ht.put(new Integer(jid),v);
					}
				}
				}catch(Exception exp) {
					System.out.println("Error while getting information of jobs:"+exp.toString());
				addErrorEvent("Error while getting information of jobs:"+exp.toString());
				}
			}	
			
		}catch(Exception e) {
			System.out.println("Error while getting information of jobs:"+e.toString());
			addErrorEvent("Error while getting information of jobs:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
	try{
		Cluster_JQS_JobStat rs = new Cluster_JQS_JobStat();
		Hashtable ht = rs.getHashtable();
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");


		System.out.println("---------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}catch(Exception ee) {};
	}

	public String getDesc()
	{
		return "Job Statistics";
	
	}
}
