/*
 * @(#) Cluster_JQS_QueueStat.java 99/2/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 * Define the JQS queue lists.
 *
 * @author Jimmy Liang
 * @version 1.00 2/9/99
 */

public class Cluster_JQS_QueueStat extends ResourceTable
{
	String[] entryNames = {"Queue Name", "Queue Type", "Quan","Load", "State"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.FLOAT,Resource.STRING};
		
	int[] entryMaxLen = {21,12,6,9,6};

	public Cluster_JQS_QueueStat() 
	{
		setUpdateTime(60*1000);
		setMinTime(30*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Vector getRange()
	{
		return Resource.qservers;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();

		try {
			Process p = Util.runCommand("/usr/local/DQS/bin/qstat32 -f");
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}
			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;

			while ((line = d.readLine())!=null)
			{
				try {
				StringTokenizer st = new StringTokenizer(line);
				if (st.countTokens()!=6) continue;
				String qname = st.nextToken().trim();
				String qtype = st.nextToken().trim();
				String quan = st.nextToken().trim();
				Float load = new Float(st.nextToken().trim());
				String state = st.nextToken().trim();
				
				Vector v = new Vector();
				v.addElement(qname);
				v.addElement(qtype);
				v.addElement(quan);
				v.addElement(load);
				v.addElement(state);				

				ht.put(qname,v);
				}catch(Exception exp) {
					System.out.println("Error while getting information of queues:"+exp.toString());
				addErrorEvent("Error while getting information of queues:"+exp.toString());
				}
			}	
			
		}catch(Exception e) {
			System.out.println("Error while getting information of queues:"+e.toString());
			addErrorEvent("Error while getting information of queues:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
try {
		Cluster_JQS_QueueStat rs = new Cluster_JQS_QueueStat();
		Hashtable ht = rs.getHashtable();
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");

		System.out.println("---------");
		System.out.println(rs.errorToString());
}catch(Exception e){System.out.println(e);}
		System.exit(0);
	}

	public String getDesc()
	{
		return "Queue Statistics";
	}

}
