/*
 * @(#) Cluster_Workstation_ArpTable.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of Cluster-Workstation-ArpTable
 *
 * @author Jimmy Liang
 * @version 1.00 04/23/99
 */

public class Cluster_Workstation_ArpTable extends ResourceTable
{
	String[] entryNames = {"IP Address","HW type","Flags","HW address","Mask","Iface"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING};
	int[] entryMaxLen = {15,6,6,25,6,8};

	String fn = "/proc/net/arp";

	static int UPDATETIME=10*60*1000;

	public Cluster_Workstation_ArpTable()
	{
		setUpdateTime(UPDATETIME);
		setMinTime(5*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		BufferedReader reader = null;

		try {
			FileInputStream in = new FileInputStream(fn);
			reader = new BufferedReader(new InputStreamReader(in));
		}catch(Exception ex) {
			System.out.println("Error while reading file "+fn+ex.toString());
			throw new java.rmi.ServerRuntimeException("Error while reading file "+fn, ex); 
		}

		if (reader==null) return null;

		String line = null;

		try {
		while (true)
		{
			line = reader.readLine();
			if (line==null) break;

			if (line.startsWith("#")) continue;
			if (line.indexOf("address")!=-1) continue;

			StringTokenizer st = new StringTokenizer(line);
			int count = st.countTokens();
			if (count!=6) continue;

			String ip = st.nextToken();
			String type = st.nextToken();
			String flag = st.nextToken();
			String address = st.nextToken();
			String mask = st.nextToken();
			String device = st.nextToken();

			Vector vt = new Vector();
			vt.addElement(ip);
			vt.addElement(type);
			vt.addElement(flag);
			vt.addElement(address);
			vt.addElement(mask);
			vt.addElement(device);
			ht.put(ip,vt);
		}
		}catch(Exception e2) {
			System.out.println("Error while gotting info:"+e2);
			e2.printStackTrace();
		}
		try {
			reader.close();
		}catch(Exception ee){};
		return ht; 	
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_ArpTable rs = new Cluster_Workstation_ArpTable();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		System.out.println(ht);
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "ARP Table";
	}
}
