/*
 * @(#) Cluster_Workstation_CPUTemp.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.File;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of Cluster-Workstation-CPUTemp
 *
 * @author Jimmy Liang
 * @version 1.00 04/23/99
 */

public class Cluster_Workstation_CPUTemp extends ResourceTable
{
	String[] entryNames = {"CPU Name","CPU Temperature"};
	int[] entryTypes = {Resource.STRING,Resource.SHORT};
	int[] entryMaxLen = {5,5};

	String fn = "/proc/sys/dev/lm78/status";

	static int UPDATETIME=60*1000;

	public Cluster_Workstation_CPUTemp()
	{
		setUpdateTime(UPDATETIME);
		setMinTime(15*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		Vector temp_file_names = new Vector();

		try {
			File f = new File(fn);
			String[] files = f.list();
			if (files==null) {
				System.out.println("Error while access "+fn);
				addErrorEvent("Error while access "+fn);
				return null;
			}
			for (int i=0;i<files.length;i++)
			{
				if (files[i].startsWith("temp")&&files[i].length()==5)
					temp_file_names.addElement(files[i]);
			}
				
		}catch(Exception ex) {
			System.out.println("Error while access"+fn+ex.toString());
			throw new java.rmi.ServerRuntimeException("Error while reading file "+fn, ex); 
		}

		if (temp_file_names.size()==0) return ht;

		FileInputStream in = null;
		BufferedReader reader =  null;

		for (int i=0;i<temp_file_names.size();i++)
		{
			try {
			String file = (String) temp_file_names.elementAt(i);

			try {
				in = new FileInputStream(new File(fn,file));
				reader = new BufferedReader(new InputStreamReader(in));
			}catch(Exception ee) {
				System.out.println("Error while access"+fn+"/"+file+ee.toString());
				throw new java.rmi.ServerRuntimeException("Error while reading file "+fn+"/"+file, ee); 
			}
			
			String line = null;

			line = reader.readLine();
			if (line==null) {
				System.out.println("Error while read file :"+file);
				addErrorEvent("Error while read file :"+file);
				continue;
			}

			int temperature = Integer.parseInt(line.trim());

			Vector vt = new Vector();

			vt.addElement(file);
			vt.addElement(new Integer(temperature));
			ht.put(file,vt);

			in.close();
			reader.close();
			}catch(Exception e2) {
				System.out.println("Error while gotting info:"+e2);
				addErrorEvent("Error while gotting info:"+e2);
				try {
					in.close();
					reader.close();
				}catch(Exception ee){};
			}
		}
		return ht; 	
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_CPUTemp rs = new Cluster_Workstation_CPUTemp();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		System.out.println(ht);
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "CPU Temperature";
	}

}
