/*
 * @(#) Cluster_Workstation_DeviceInfo.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of Cluster-Workstation-DeviceInfo
 *
 * @author Jimmy Liang
 * @version 1.00 04/23/99
 */

public class Cluster_Workstation_DeviceInfo extends ResourceTable
{
	String[] entryNames = {"Device Name","Type","Major No.l"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.SHORT};
	int[] entryMaxLen = {20,15,6};

	String fn = "/proc/devices";

	static int UPDATETIME=24*60*60*1000;

	public Cluster_Workstation_DeviceInfo()
	{
		setUpdateTime(UPDATETIME);
		setMinTime(2*60*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		BufferedReader reader = null;

		try {
			FileInputStream in = new FileInputStream(fn);
			reader = new BufferedReader(new InputStreamReader(in));
		}catch(Exception ex) {
			System.out.println("Error while reading file "+fn+ex.toString());
			throw new java.rmi.ServerRuntimeException("Error while reading file "+fn, ex); 
		}

		if (reader==null) return null;

		String line = null;
		String type = null; 

		try {
		while (true)
		{
			line = reader.readLine();
			if (line==null) break;

			if (line.startsWith("Character"))
			{
				type = "Character";
				continue;
			}

			if (line.startsWith("Block"))
			{
				type = "Block";
				continue;
			}
			
			if (type==null) continue;

			StringTokenizer st = new StringTokenizer(line);
			if (st.countTokens()!=2) continue;
			Integer id = new Integer(st.nextToken().trim());
			String dname = st.nextToken();
			Vector vt = new Vector();
			vt.addElement(dname);
			vt.addElement(type);
			vt.addElement(id);
			ht.put(dname,vt);
		}
		}catch(Exception e2) {
			System.out.println("Error while gotting info:"+e2);
			e2.printStackTrace();
		}
		try {
			reader.close();
		}catch(Exception ee){};
		return ht; 	
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_DeviceInfo rs = new Cluster_Workstation_DeviceInfo();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		System.out.println(ht);
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "Device Infomation";
	}
}
