/*
 * @(#) Cluster_Workstation_DiskInfo.java 99/4/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 * Define the format of Cluste_Workstation_Disk partition info
 *
 * @author Jimmy Liang
 * @version 1.00 4/9/99
 */

public class Cluster_Workstation_DiskInfo extends ResourceTable
{
	String[] entryNames = {"Device Name", "Boot", "Begin","Start", "End","Blocks","Incrementable","Id","System"};
	int[] entryTypes = {Resource.STRING,Resource.BOOLEAN,Resource.LONG,Resource.LONG,Resource.LONG,Resource.LONG,Resource.BOOLEAN,Resource.SHORT,Resource.STRING};
		
	int[] entryMaxLen = {15,6,10,10,10,10,6,6,30};

	public Cluster_Workstation_DiskInfo()
	{
		setUpdateTime(24*60*1000);
		setMinTime(2*60*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();

		try {
			Process p = Util.runCommand("/sbin/fdisk -l");
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}

			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;
			boolean flag = false;
			boolean existBegin = false;

			while ((line = d.readLine())!=null)
			{
				try {
				if (!flag)
				{
					if (line.indexOf("Device")!=-1) 
					{
						flag = true;
						if (line.indexOf("Begin")!=-1)
							existBegin = true;
					}
					continue;
				}

				StringTokenizer st = new StringTokenizer(line);
				int count = st.countTokens();
				int nn = 0;
				if (count<7) continue;

				String device = st.nextToken();
				nn++;
				
				String temp = st.nextToken();
				nn++;
				boolean boot = false;
				if (temp.equals("*"))
				{
					boot = true;
					temp = st.nextToken();
					nn++;
				}
				long begin = 0;
				long start = 0;
				if (existBegin)
					begin = Long.parseLong(temp);
				else
					start = Long.parseLong(temp);

				if (existBegin)
				{
					start = Long.parseLong(st.nextToken());
					nn++;
				}
				else {
					begin = start;
				}
				long end = Long.parseLong(st.nextToken());
				nn++;
				
				temp = st.nextToken();
				nn++;
				boolean incre = false;
				if (temp.indexOf("+")!=-1)
				{
					incre = true;
					temp = temp.substring(0,temp.length()-1);
				}
				long block = Long.parseLong(temp);

				int id = Integer.parseInt(st.nextToken());
				nn++;
				
				String system = "";
				for (;nn<count;nn++)
					system = system+" "+st.nextToken();
		
				Vector v = new Vector();
				v.addElement(device);
				v.addElement(new Boolean(boot));
				v.addElement(new Long(begin));
				v.addElement(new Long(start));
				v.addElement(new Long(end));
				v.addElement(new Long(block));			
				v.addElement(new Boolean(incre));
				v.addElement(new Integer(id));
				v.addElement(system);

				ht.put(device,v);
				}catch(Exception exp) {
				System.out.println("Error while getting information of Disk Partition Infomration"+exp.toString());
				addErrorEvent("Error while getting information of Disk Partition Information:"+exp.toString());
				}
			}	

			in.close();
			d.close();
			
		}catch(Exception e) {
			System.out.println("Error while getting information of NIC:"+e.toString());
			addErrorEvent("Error while getting information of NIC:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_DiskInfo rs = new Cluster_Workstation_DiskInfo();
		Hashtable ht = null;
		try{
		ht = rs.getHashtable();
		}catch(Exception ee){
			System.out.println(ee);
			System.exit(-1);
		}
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");

		System.out.println("---------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}

	public String getDesc()
	{
		return "Disk Information";
	}


}
