/*
 * @(#) Cluster_Workstation_FsTable.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of Cluster-Workstation-FsTable
 *
 * @author Jimmy Liang
 * @version 1.00 04/23/99
 */

public class Cluster_Workstation_FsTable extends ResourceTable
{
	String[] entryNames = {"fs_spec","fs_file","fs_vfstype","fs_mntops","fs_freq","fs_passno"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.SHORT,Resource.SHORT};
	int[] entryMaxLen = {20,20,12,12,6,6};

	String fn = "/etc/fstab";

	static int UPDATETIME=60*60*1000;

	public Cluster_Workstation_FsTable()
	{
		setUpdateTime(UPDATETIME);
		setMinTime(30*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		BufferedReader reader = null;

		try {
			FileInputStream in = new FileInputStream(fn);
			reader = new BufferedReader(new InputStreamReader(in));
		}catch(Exception ex) {
			System.out.println("Error while reading file "+fn+ex.toString());
			throw new java.rmi.ServerRuntimeException("Error while reading file "+fn, ex); 
		}

		if (reader==null) return null;

		String line = null;

		try {
		while (true)
		{
			line = reader.readLine();
			if (line==null) break;

			if (line.startsWith("#")) continue;

			StringTokenizer st = new StringTokenizer(line);
			int count = st.countTokens();
			if (count<4) continue;

			String spec = st.nextToken();
			String file = st.nextToken();
			String fstype = st.nextToken();
			String mntopt = st.nextToken();
			int freq = 0;
			int passno = 0;

			if (count==6)
			{
				freq = Integer.parseInt(st.nextToken());
				passno = Integer.parseInt(st.nextToken());
			}

			Vector vt = new Vector();
			vt.addElement(spec);
			vt.addElement(file);
			vt.addElement(fstype);
			vt.addElement(mntopt);
			vt.addElement(new Integer(freq));
			vt.addElement(new Integer(passno));
			ht.put(spec,vt);
		}
		}catch(Exception e2) {
			System.out.println("Error while gotting info:"+e2);
			e2.printStackTrace();
		}
		try {
			reader.close();
		}catch(Exception ee){};
		return ht; 	
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_FsTable rs = new Cluster_Workstation_FsTable();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		System.out.println(ht);
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "Filesystem Table";
	}

}
