/*
 * @(#) Cluster_Workstation_FsUtil.java 99/5/19
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 *
 * The super class of Cluste_Workstation local filesystem utillities
 *
 * @author Jimmy Liang
 * @version 1.00 5/19/99
 */

public class Cluster_Workstation_FsUtil extends ResourceTable
{
	String[] entryNames = {"Filesystem", "Size", "Used","Availiable", "Capacity","Mounted on"};
	int[] entryTypes = {Resource.STRING,Resource.LONG,Resource.LONG,Resource.LONG,Resource.DOUBLE,Resource.STRING};
		
	int[] entryMaxLen = {10,15,15,15,5,10};

	static String cmd = "/bin/df -k -t ext2";;

	public Cluster_Workstation_FsUtil()
	{
		setUpdateTime(40*1000);
		setMinTime(20*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();
		if (cmd == null) return null;

		try {
			Process p = Util.runCommand(cmd);
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}

			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;
			boolean header = true;
			int count = 0;
			Vector vt = null;

			while ((line = d.readLine())!=null)
			{
				try {
				if (header) 
				{
					header = false;
					continue;
				}

				StringTokenizer st = new StringTokenizer(line);
				while (st.hasMoreTokens())
				{
					switch(count)
					{
						case 0:
							vt = new Vector();
							vt.addElement(st.nextToken());
							count++;
							break;
						case 1:
						case 2:
						case 3:
							try {
							long lv = Long.parseLong(st.nextToken());
							vt.addElement(new Long(lv));
							}catch(Exception ex)
							{
								vt.addElement(new Long(0));
							}
							count++;
							break;
						case 4:
							vt.addElement(st.nextToken());
							count++;
							break;
						case 5:
							vt.addElement(st.nextToken());
							count = 0;
							ht.put(vt.elementAt(0),vt);
							break;
					}
				}
				}catch(Exception exp) {
				System.out.println("Error while getting information of current filesystem utilities"+exp.toString());
				addErrorEvent("Error while getting information of current filesytem utilities:"+exp.toString());
				//exp.printStackTrace();
				}
			}	
			in.close();
			d.close();
			
		}catch(Exception e) {
			System.out.println("Error while getting utilities of filesystem:"+e.toString());
			addErrorEvent("Error while getting utilities of filesystem:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public  static void main(String[] args)
	{
		Cluster_Workstation_FsUtil rs = new Cluster_Workstation_FsUtil();
		Hashtable ht = null;
		try {
		ht = rs.getHashtable();
		}catch(Exception ee){
			System.out.println(ee);
			System.exit(-1);
		}
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");

		System.out.println("--------------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}

	public String getDesc()
	{
		return "Process Information";
	}

}
