/*
 * @(#) Cluster_Workstation_KernelSymbols.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of Cluster-Workstation-Kernel Symbols
 *
 * @author Jimmy Liang
 * @version 1.00 04/23/99
 */

public class Cluster_Workstation_KernelSymbols extends ResourceTable
{
	String[] entryNames = {"Address","Symbol","Defined by"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING};
	int[] entryMaxLen = {20,20,30};

	String fn = "/proc/ksyms";

	static int UPDATETIME=24*60*60*1000;

	public Cluster_Workstation_KernelSymbols()
	{
		setUpdateTime(UPDATETIME);
		setMinTime(2*60*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		BufferedReader reader = null;

		try {
			FileInputStream in = new FileInputStream(fn);
			reader = new BufferedReader(new InputStreamReader(in));
		}catch(Exception ex) {
			System.out.println("Error while reading file "+fn+ex.toString());
			throw new java.rmi.ServerRuntimeException("Error while reading file "+fn, ex); 
		}

		if (reader==null) return null;

		String line = null;

		try {
		while (true)
		{
			line = reader.readLine();
			if (line==null) break;

			if (line.startsWith("#")) continue;

			StringTokenizer st = new StringTokenizer(line);
			int count = st.countTokens();
			if (count<2) continue;

			String addr = st.nextToken();
			String symb = st.nextToken();
			String defined_by = "";
			for (int i=2;i<count;i++)
				defined_by=defined_by+st.nextToken();

			Vector vt = new Vector();
			vt.addElement(addr);
			vt.addElement(symb);
			vt.addElement(defined_by);
			ht.put(addr,vt);
		}
		}catch(Exception e2) {
			System.out.println("Error while gotting info:"+e2);
			e2.printStackTrace();
		}
		try {
			reader.close();
		}catch(Exception ee){};
		return ht; 	
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_KernelSymbols rs = new Cluster_Workstation_KernelSymbols();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		System.out.println(ht);
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "Kernel Symbols";
	}

}
