/*
 * @(#) Cluster_Workstation_LoginInfo.java 99/4/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 *
 * The super class of Cluste_Workstation who is logged on and they are doing.
 *
 * @author Jimmy Liang
 * @version 1.00 4/9/99
 */

public class Cluster_Workstation_LoginInfo extends ResourceTable
{
	String[] entryNames = {"User", "TTY", "From","Login Time", "Idle","JCPU","PCPU","What"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING};
		
	int[] entryMaxLen = {15,8,18,15,12,15,15,30};

	static String cmd = "/usr/bin/w -h";;

	public Cluster_Workstation_LoginInfo()
	{
		setUpdateTime(60*1000);
		setMinTime(30*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[1];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();
		if (cmd == null) return null;

		try {
			Process p = Util.runCommand(cmd);
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}

			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;

			while ((line = d.readLine())!=null)
			{
				try {
				StringTokenizer st = new StringTokenizer(line);
				int count = st.countTokens();
				if (count<7) continue;

				String user = st.nextToken();
				String tty = st.nextToken();
				
				int inc = 0;
				String from = "";
				String time = "";
				String temp = st.nextToken();
				char ch = temp.charAt(0);
				if (temp.endsWith("am")||temp.endsWith("pm")||(ch>='A'&&ch<='Z'))
				{
					inc--;
					time = temp;
				}
				else 
				{
					from = temp;
					time = st.nextToken();
				}
				while (true) {
					if ((time.indexOf("am")!=-1)||(time.indexOf("pm")!=-1))
						break;
					time = time+" "+st.nextToken();
					inc++;
				}
					
				String idle = st.nextToken();
				String jcpu = st.nextToken();
				String pcpu = st.nextToken();
				String what = "";
				for (int ii=(7+inc);ii<count;ii++)
					what =  what+ " "+st.nextToken();

				Vector v = new Vector();
				v.addElement(user);
				v.addElement(tty);
				v.addElement(from);
				v.addElement(time);
				v.addElement(idle);
				v.addElement(jcpu);
				v.addElement(pcpu);
				v.addElement(what);

				ht.put(tty,v);
				}catch(Exception exp) {
				System.out.println("Error while getting information of connection table"+exp.toString());
				addErrorEvent("Error while getting information of connection table:"+exp.toString());
				}
			}	
			in.close();
			d.close();
			
		}catch(Exception e) {
			System.out.println("Error while getting information of Login Information:"+e.toString());
			addErrorEvent("Error while getting information of Login Information:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public  static void main(String[] args)
	{
		Cluster_Workstation_LoginInfo rs = new Cluster_Workstation_LoginInfo();
		Hashtable ht = null;
		try {
		ht = rs.getHashtable();
		}catch(Exception ee){
			System.out.println(ee);
			System.exit(-1);
		}
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");

		System.out.println("--------------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}

	public String getDesc()
	{
		return "Login Information";
	}

}
