/*
 * @(#) Cluster_Workstation_Network.java 99/4/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 *
 * The super class of Cluste_Workstation connection table, include raw, ip, 
 * tcp, udp.
 *
 * @author Jimmy Liang
 * @version 1.00 4/9/99
 */

public class Cluster_Workstation_Network_ContTable extends ResourceTable
{
	String[] entryNames = {"Connection ID", "Protocol", "Recv_Q","Send_Q", "Local addr.","Foreign addr.","State"};
	int[] entryTypes = {Resource.SHORT,Resource.STRING,Resource.SHORT,Resource.SHORT,Resource.STRING,Resource.STRING,Resource.STRING};
		
	int[] entryMaxLen = {5,8,6,6,25,25,15};

	static String cmd = null;

	public Cluster_Workstation_Network_ContTable()
	{
		setUpdateTime(60*1000);
		setMinTime(30*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();
		if (cmd == null) return null;

		try {
			Process p = Util.runCommand(cmd);
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}

			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;
			int id = 1;
			boolean flag = false;

			while ((line = d.readLine())!=null)
			{
				try {
				if (!flag)
				{
					if (line.indexOf("Proto")!=-1)
						flag  = true;
					continue;
				}

				StringTokenizer st = new StringTokenizer(line);
				int count = st.countTokens();
				if (count<5) continue;

				String proto = st.nextToken();
				int rq = Integer.parseInt(st.nextToken());
				int sq = Integer.parseInt(st.nextToken());
				String la = st.nextToken();
				String fa = st.nextToken();
				String state = "";
				if (count>5)
					state = st.nextToken();

				Vector v = new Vector();
				v.addElement(new Integer(id));
				v.addElement(proto);
				v.addElement(new Integer(rq));
				v.addElement(new Integer(sq));
				v.addElement(la);
				v.addElement(fa);
				v.addElement(state);

				ht.put(new Integer(id),v);
				id++;
				}catch(Exception exp) {
				System.out.println("Error while getting information of connection table"+exp.toString());
				addErrorEvent("Error while getting information of connection table:"+exp.toString());
				}
			}	
			in.close();
			d.close();
			
		}catch(Exception e) {
			System.out.println("Error while getting information of NIC:"+e.toString());
			addErrorEvent("Error while getting information of NIC:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}


	public String getDesc()
	{
		return "Connection Table";
	}

}
