/*
 * @(#) Cluster_Workstation_ProcessInfo.java 99/4/9
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.DataInputStream;

/**
 *
 * The super class of Cluste_Workstation processes information
 *
 * @author Jimmy Liang
 * @version 1.00 4/9/99
 */

public class Cluster_Workstation_ProcessInfo extends ResourceTable
{
	String[] entryNames = {"PID", "User", "%CPU","%MEM", "Size","RSS","TTY","Stat","Start","Time","Command"};
	int[] entryTypes = {Resource.LONG,Resource.STRING,Resource.FLOAT,Resource.FLOAT,Resource.LONG,Resource.LONG,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING};
		
	int[] entryMaxLen = {10,10,8,8,8,8,8,6,10,10,20};

	static String cmd = "/bin/ps -auxh";;

	public Cluster_Workstation_ProcessInfo()
	{
		setUpdateTime(30*1000);
		setMinTime(15*1000);
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public boolean isValueFromServer() {
		return false;
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException
	{
		Hashtable ht = new Hashtable();
		if (cmd == null) return null;

		try {
			Process p = Util.runCommand(cmd);
			try {
				Thread.sleep(500);
			}catch(Exception e0) {};
			int i=0;
			for (;i<6;i++)
			{
				try {
				p.exitValue();
				}catch(Exception e1) {
					try {
					Thread.sleep(1000);
					}catch(Exception e2){};
					continue;
				}
				break;
			}

			if (i>=6) {
				System.out.println("Time out");	
				addErrorEvent("Time out");
				return null;
			}

			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("execute error:"+errMessage);
				addErrorEvent("execute error:"+errMessage);
				return null;
			}

			DataInputStream in = new DataInputStream(p.getInputStream());
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;

			while ((line = d.readLine())!=null)
			{
				try {
				StringTokenizer st = new StringTokenizer(line);
				int count = st.countTokens();
				if (count<11) continue;

				String user = st.nextToken();
				long pid = Long.parseLong(st.nextToken());
				Float cpu = Float.valueOf(st.nextToken());
				Float mem = Float.valueOf(st.nextToken());
				long size = Long.parseLong(st.nextToken());
				long rss = Long.parseLong(st.nextToken());
				String tty = st.nextToken();
				String stat = st.nextToken();

				String start = "";
				int inc = 0;
				String temp = st.nextToken();
				if (temp.equals("<")||temp.equals(">"))
				{
					stat = stat+" "+temp;
					inc++;
					temp = st.nextToken();
				}
				char ch = temp.charAt(0);
				if (ch>='0'&&ch<='9')
					start = temp;
				else
				{
					start = temp+" "+st.nextToken();
					inc++;
				}				

				String time = st.nextToken();
				String command = "";
				for (int ii=(10+inc);ii<count;ii++)
					command =  command+ " "+st.nextToken();

				Vector v = new Vector();
				v.addElement(new Long(pid));
				v.addElement(user);
				v.addElement(cpu);
				v.addElement(mem);
				v.addElement(new Long(size));
				v.addElement(new Long(rss));
				v.addElement(tty);
				v.addElement(stat);
				v.addElement(start);
				v.addElement(time);
				v.addElement(command);

				ht.put(new Long(pid),v);
				}catch(Exception exp) {
				System.out.println("Error while getting information of current processes"+exp.toString());
				addErrorEvent("Error while getting information of current processes:"+exp.toString());
				//exp.printStackTrace();
				}
			}	
			in.close();
			d.close();
			
		}catch(Exception e) {
			System.out.println("Error while getting information of Process Information:"+e.toString());
			addErrorEvent("Error while getting information of Process Information:"+e.toString());
			return null;
		}
		return ht;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public  static void main(String[] args)
	{
		Cluster_Workstation_ProcessInfo rs = new Cluster_Workstation_ProcessInfo();
		Hashtable ht = null;
		try {
		ht = rs.getHashtable();
		}catch(Exception ee){
			System.out.println(ee);
			System.exit(-1);
		}
		if (ht!=null)
			System.out.println(ht);
		else
			System.out.println("");

		System.out.println("--------------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}

	public String getDesc()
	{
		return "Process Information";
	}

}
