/*
 * @(#) Cluster_Workstation_UserInfo.java 99/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;

/**
 * Define the resource format of Cluster-Workstation-AccoutInfo
 *
 * @author Jimmy Liang
 * @version 1.00 04/23/99
 */

public class Cluster_Workstation_UserInfo extends ResourceTable
{
	String[] entryNames = {"Login Name","UID","GID","Description","Home dir","Init program"};
	int[] entryTypes = {Resource.STRING,Resource.SHORT,Resource.SHORT,Resource.STRING,Resource.STRING,Resource.STRING};
	int[] entryMaxLen = {20,6,6,20,20,20};

	String fn = "/etc/passwd";

	static int UPDATETIME=60*60*1000;

	public Cluster_Workstation_UserInfo()
	{
		setUpdateTime(UPDATETIME);
		setMinTime(30*1000);
	}

	public Hashtable getHashtable() throws java.rmi.ServerRuntimeException 
	{
		Hashtable ht = new Hashtable();
		BufferedReader reader = null;

		try {
			FileInputStream in = new FileInputStream(fn);
			reader = new BufferedReader(new InputStreamReader(in));
		}catch(Exception ex) {
			System.out.println("Error while reading file "+fn+ex.toString());
			throw new java.rmi.ServerRuntimeException("Error while reading file "+fn, ex); 
		}

		if (reader==null) return null;

		String line = null;

		try {
		while (true)
		{
			line = reader.readLine();
			if (line==null) break;

			StringTokenizer st = new StringTokenizer(line,":");
			int count = st.countTokens();
			int traceCount = 0;
			int nextCount = 0;

			traceCount = line.indexOf(":",traceCount);
			String ln = st.nextToken();

			traceCount++;
			nextCount = line.indexOf(":",traceCount);
			if (nextCount!=traceCount)
				st.nextToken();
			traceCount = nextCount;

			int uid = Integer.parseInt(st.nextToken());
			traceCount = line.indexOf(":",++traceCount);
			int gid = Integer.parseInt(st.nextToken());
			traceCount = line.indexOf(":",++traceCount);

			String desc = "";
			nextCount = line.indexOf(":",++traceCount);
			if (nextCount!=traceCount)
				desc = st.nextToken();
			traceCount = nextCount;

			String hd = "";
			nextCount = line.indexOf(":",++traceCount);
			if (nextCount!=traceCount)
				hd = st.nextToken();
			traceCount = nextCount;

			String ip = "";
			if (traceCount<(line.length()-1))
				ip = st.nextToken();

			Vector vt = new Vector();
			vt.addElement(ln);
			vt.addElement(new Integer(uid));
			vt.addElement(new Integer(gid));
			vt.addElement(desc);
			vt.addElement(hd);
			vt.addElement(ip);
			ht.put(ln,vt);
		}
		}catch(Exception e2) {
			System.out.println("Error while gotting info:"+e2);
			e2.printStackTrace();
		}
		try {
			reader.close();
		}catch(Exception ee){};
		return ht; 	
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.MULTITABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}

	public static void main(String[] args) {
		Cluster_Workstation_UserInfo rs = new Cluster_Workstation_UserInfo();
		try {
		Hashtable ht = rs.getHashtable();
		if (ht==null) 
		{
			System.out.println("null");
			System.exit(-1);
		}
		System.out.println(ht);
		}catch(Exception e) {System.out.println(e);}
		System.exit(-1);
	}

	public String getDesc()
	{
		return "User Information";
	}
}
