/*
 * @(#) Cluster_Workstation_Version.java 98/4/23
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Define the resource format of Cluster-Workstation-Version
 *
 * @author Jimmy Liang
 * @version 1.00 12/23/98
 */

public class Cluster_Workstation_Version extends ResourceTable
{
	String[] entryNames = {"WorkstationName","OS Name","OS release","OS version","Machine Type"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING,Resource.STRING};
	int[] entryMaxLen = {20,10,10,25,10};
		
	static int UPDATETIME=60*60*1000;

	public Cluster_Workstation_Version() {
		setUpdateTime(UPDATETIME);
		setMinTime(10*60*1000);
	}

	public Vector getVector() throws java.rmi.ServerRuntimeException
	{
		DataInputStream in = null;
		BufferedReader d = null;

		try {
		Process p = Util.runCommand("/bin/uname -a"); 
		try {
			Thread.sleep(200);
		}catch(Exception e0) {};
		int i=0;
		for (;i<6;i++)
		{
			try{
			p.exitValue();
			}catch(Exception e1){
				try{
				Thread.sleep(1000);
				}catch(Exception e2){};
				continue;
			}
			break;
		}
		
		if (i>=6) {
			System.out.println("Time out");
			addErrorEvent("Time out");
			return null;
		}
			
		String errMessage = Util.getProcessErrMsg(p);
		if (errMessage!=null) {
			System.out.println("process run error:"+errMessage);
			addErrorEvent("execute error:"+errMessage);
			return null;
		}

		in = new DataInputStream(p.getInputStream());	
		d = new BufferedReader(new InputStreamReader(in));

		String line = d.readLine();
		Vector v = new Vector();

		if (line==null) {
			addErrorEvent("Parse Error:");
			return null;
		}

		StringTokenizer st = new StringTokenizer(line);
		if (st.countTokens()<11) {
			addErrorEvent("Parse Error:"+line);
			return null;
		}

		String osn = st.nextToken();
		String hn = st.nextToken();
		String or = st.nextToken();
		String ov = "";
		for (int ii=3;ii<10;ii++)
			ov = ov+" "+st.nextToken();
		String mt = st.nextToken();

                v.addElement(hn);
		v.addElement(osn);
		v.addElement(or);
                v.addElement(ov);
                v.addElement(mt);
		in.close();
		d.close();	
                return v;
		}catch(Exception ee)
		{
			System.out.println("Retrieve Version Information error:"+ee.toString());
			addErrorEvent("Retrieve Version information error:"+ee.toString());
			try {
			if (in!=null) in.close();
			if (d!=null) d.close();
			}catch(Exception exp){};
			return null;
		}
        }

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.SIGLETABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}
	
	public static void main(String[] args) {
		Cluster_Workstation_Version rs = new Cluster_Workstation_Version();
		Vector vt = null;

		try {
		vt = rs.getVector();
		}catch(Exception exp){
			System.out.println(exp);
		}

		if (vt!=null)
			System.out.println(vt);
		else
			System.out.println("");

		System.out.println("----------------");
		System.out.println(rs.errorToString());
		System.exit(0);
	}

	public String getDesc()
	{
		return "OS Version";
	}
}
