
/*
 * @(#) RMIThread.java 
Modified by Wang Lin
 */

package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.Serializable;
import java.rmi.*;
import java.rmi.server.RMIClassLoader;
import java.io.DataInputStream;
import java.net.InetAddress;

import CLUSTERPROBE.message.EventHandler;
import CLUSTERPROBE.rmi.NodeRMIInterface;

/**
 * define the thread to collect config info.
 */

public class RMIThread extends Thread
{

Vector vectorResult;
Hashtable hashtableResult;
String host;
int type;
Resource rs;


public RMIThread(String host,Resource rs,int type)  
{
	this.host = host;
	this.type = type;
	this.rs = rs;
}

public void run()
{
	boolean DebugFlag = true;
	if (rs==null) return;

	try {
		if (DebugFlag)
			System.out.println("In RMIThread...");
		NodeRMIInterface r = Util.getRMIInterface(host);
		if (DebugFlag)
			System.out.println("get RMI Interface of "+host+ " .");
		if (type==Util.GETVECTOR)
			vectorResult = r.resource_GetVector(rs.getResourceName());
		else
			hashtableResult = r.resource_GetHashtable(rs.getResourceName());	
	
	}catch(Exception cp)
	{
		Util.removeRMIInterface(host);
		if (cp instanceof java.rmi.ServerRuntimeException)
			rs.addErrorEvent(cp.toString());
		else {
			if (type==Util.GETVECTOR)
				vectorResult = rs.getVectorExceptionProcess(host,cp);
			else
				hashtableResult = rs.getHashtableExceptionProcess(host,cp);
		}
	}	
	if (DebugFlag) System.out.println("end of RMIThread");
}
public void RMIDo()
{
	boolean DebugFlag = true;
	if (rs==null) return;

	try {
		if (DebugFlag)
			System.out.println("In RMIDo...");
		NodeRMIInterface r = Util.getRMIInterface(host);
	    if (DebugFlag)
			System.out.println("get RMI Interface of "+host+ " .");
		if (type==Util.GETVECTOR)
			vectorResult = r.resource_GetVector(rs.getResourceName());
		else
			hashtableResult = r.resource_GetHashtable(rs.getResourceName());	
	}catch(Exception cp){
		Util.removeRMIInterface(host);
		if (cp instanceof java.rmi.ServerRuntimeException)
			rs.addErrorEvent(cp.toString());
		else {
			if (type==Util.GETVECTOR)
				vectorResult = rs.getVectorExceptionProcess(host,cp);
			else
				hashtableResult = rs.getHashtableExceptionProcess(host,cp);
		}
	}	
	if (DebugFlag) System.out.println("end of RMIDo");
}
public Vector getVector()
{
	return vectorResult;
}

public Hashtable getHashtable()
{
	return hashtableResult;
}

}
