/*
 * @(#) NodeRMIImpl.java 01/1/3
 */

package CLUSTERPROBE.rmi;
 
import java.io.*;
import java.rmi.*;
import java.util.*;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.server.RemoteServer;
import java.net.*;
import java.lang.*;

import CLUSTERPROBE.resources.*;
import CLUSTERPROBE.message.*;
import CLUSTERPROBE.monitor.MonitorThread;
import CLUSTERPROBE.manipulate.*;

/**
 * Implement the rmi interfaces defined by class NodeRMIInterface. Act as 
 * a deamon on each participants of the cluster.
 */

public class NodeRMIImpl extends UnicastRemoteObject implements NodeRMIInterface
{
	public static Hashtable monTable = new Hashtable();	

	public NodeRMIImpl() throws RemoteException
	{
		super();
	}
	
	public Object resource_GetObject(String rn) throws RemoteException
	{
		Resource rs = getResource(rn);
		if (rs==null) return null;
		return rs.getObject();
	}

	public void test() throws RemoteException
	{};

	public Vector resource_GetVector(String rn) throws RemoteException
	{
		Resource rs = getResource(rn);
		if (rs==null) return null;
		return rs.getVector();
	}

	public Hashtable resource_GetHashtable(String rn) throws RemoteException
	{
		Resource rs = getResource(rn);
		if (rs==null) return null;
		return rs.getHashtable();
	}
	
	public static Resource getResource(String rn) {
		Resource rs;
		try {
		if  (!Util.contains(rn))
		{
			rs = (Resource) Util.instanceClass(rn);
			Util.addResource(rs);
		}
		else
			rs = Util.getResource(rn);

		}catch(Exception e) {
			System.out.println("looking for specify resource errror:"+e.toString());
			return null;
		}
		return rs;
	}


	public void monitor_Register(MonitorRegistryEvent evt) throws RemoteException
	{
		if (monTable.containsKey(evt.getResourceName()))
		{
			MonitorThread t = (MonitorThread) monTable.get(evt.getResourceName());
			if (!t.isAlive())	
			{
				monTable.remove(evt.getResourceName());	
				t = new MonitorThread(evt.getResourceName());
				monTable.put(evt.getResourceName(),t);
				t.addElement(evt);
				System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
				t.start();
			}
			else
				t.addElement(evt);
		}
		else {
			MonitorThread t0 = new MonitorThread(evt.getResourceName());

			monTable.put(evt.getResourceName(),t0);
			t0.addElement(evt);
			System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
			t0.start();
		}
	}
			
	public void monitor_Unregister(MonitorRegistryEvent evt) throws RemoteException
	{
		if (monTable.containsKey(evt.getResourceName()))
		{
			MonitorThread t = (MonitorThread) monTable.get(evt.getResourceName());
			if (!t.isAlive())
				monTable.remove(evt.getResourceName());
			else {
				t.removeElement(evt);
				if (t.size()==0)
				{
					monTable.remove(evt.getResourceName());
					t.stop();
				}
			}
		}
	}

	public void monitor_Update(MonitorRegistryEvent evt) throws RemoteException
	{
		if (monTable.containsKey(evt.getResourceName()))
		{
			MonitorThread t = (MonitorThread) monTable.get(evt.getResourceName());
			if (!t.isAlive()) {
				monTable.remove(evt.getResourceName());
				t = new MonitorThread(evt.getResourceName());
				monTable.put(evt.getResourceName(),t);
				t.addElement(evt);
				System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
				t.start();
			}
			else
			{
				t.updateElement(evt);
			}
		}
		else
		{
			MonitorThread t0 = new MonitorThread(evt.getResourceName());

			monTable.put(evt.getResourceName(),t0);
			t0.addElement(evt);
			System.out.println("...........................Start a Monitor Thread on:"+evt.getResourceName());
			t0.start();
		}
	}
    public static int startNode()
	{
		int pid=-1;
		boolean DebugFlag = false;
		System.setSecurityManager(new CLUSTERPROBE.resources.MySecurityManager());
		try {
			String localName = InetAddress.getLocalHost().getHostAddress();
			String name = "rmi://"+localName+":3000/agent";
			System.out.println("Registering agent as \" "+name+" \"");
			NodeRMIImpl obj = new NodeRMIImpl();
			System.out.println("Create agent, binding....");
			Naming.rebind(name,obj);
			System.out.println("Remote agent ready...");
			Process proc = Runtime.getRuntime().exec("/usr/local/ClusterProbe/CLUSTERPROBE/rmi/getppid");
			String atemp = "    ";
			atemp="";
			int outs;
				String filename = "/usr/local/ClusterProbe/CLUSTERPROBE/ha/process_shm";
				RandomAccessFile raf = new RandomAccessFile(filename,"rw");
			
			outs = proc.getInputStream().read();
			while (outs!=-1)
			{
				//System.out.println(char(outs));
				raf.writeByte(outs);
				//if(DebugFlag) System.out.println((char)outs);
			     atemp = atemp+(char)outs;
				 outs = proc.getInputStream().read();
			}
			System.out.println("..*****..:"+"  pidi is:"+atemp);
			pid = Integer.parseInt(atemp);
			raf.close();
		}catch(Exception e) {
			System.out.println("Caught exception while registering: "+e.toString());
		}	
		return pid;
	}
	
	public static void main(String argv[]) 
	{
		int pid = startNode();

		/*boolean DebugFlag = true;
		String command="";
		HaThread hathread = new HaThread();
		hathread.run();
		while(true)
		{
			if(!hathread.getest())
			{
				startNode();
				System.out.println("ReRegistry node agent");
			}
		}*/
	}

	public void manipulate(ManipulateEvent evt, Manipulation m) throws RemoteException
	{
		ManThread t = new ManThread(evt, m);
		System.out.println("...........................Start a Man Thread.");
		t.start();
	}	
		
}
class ManThread extends Thread
{
	Manipulation m = null;
	ManipulateEvent evt = null;
	static  InputStream evIn = null;
	static OutputStream evOut = null;
	int port = 7003;
	String server = "c414b1";

	public ManThread(ManipulateEvent evt, Manipulation m)
	{
		if (evOut==null ||evIn==null)
			initSocket();
		else {
			try {
			ObjectOutputStream out = new ObjectOutputStream(evOut);
			out.writeObject("test");
			out.flush();
			}catch(Exception e){
				initSocket();
			}
		}
		this.evt = evt;
		this.m = m;
	}

	public void initSocket()
	{
		try  {
		server = RemoteServer.getClientHost();
		Socket serverSocket = new Socket(server,port);
		evIn = serverSocket.getInputStream();
		evOut = serverSocket.getOutputStream();
		}catch(Exception e) {};
	}

	public void run() 
	{
		String localHost = getHostName();
		if (m==null)
		{
			ManipulateErrorEvent errEvent = new ManipulateErrorEvent(evt.getName(),ManipulateErrorEvent.RESPONSE,evt.getTime(),Calendar.getInstance().getTime().getTime(),"The operation you submited is invalid");
			errEvent.setErrorSource(localHost);
			try{
			ObjectOutputStream out = new ObjectOutputStream(evOut);
			out.writeObject(errEvent);
			}catch(Exception exp){};
			return;
		}

		m.operate(evt.getArguments(), evt.getPasswd());
		long timeout = m.getTimeout();
		long time = 0;

		while (true)
		{
			if (!m.isAlive())
				break;
			try {
			Thread.sleep(300);
			time+=300;
			}catch(Exception e0){};
			if (time>timeout)
				break;
		}
		
		if (time>timeout) {
			ManipulateErrorEvent errEvent = new ManipulateErrorEvent(evt.getName(),ManipulateErrorEvent.RESPONSE,evt.getTime(),Calendar.getInstance().getTime().getTime(),"The operation timeout");
			errEvent.setErrorSource(localHost);
			try{
			ObjectOutputStream out = new ObjectOutputStream(evOut);
			out.writeObject(errEvent);
			}catch(Exception exp){};
			return;
		}

		Object result = m.getResult();
		long nowTime = Calendar.getInstance().getTime().getTime();;
		if (result instanceof Vector)
		{
			Vector rv = (Vector) result;
			for (int i=0;i<rv.size();i++)
			{
				Object obj = rv.elementAt(i);
				ManipulateResultEvent resultEvent = new ManipulateResultEvent(localHost,evt.getName(),evt.getTime(),nowTime,obj,m.isSuccess());
				if (i!=(rv.size()-1))
					resultEvent.setEnd(false);
				try{
				ObjectOutputStream out = new ObjectOutputStream(evOut);
				out.writeObject(resultEvent);
				}catch(Exception exp){};
			}
		}
		else
		{
			ManipulateResultEvent resultEvent = new ManipulateResultEvent(localHost,evt.getName(),evt.getTime(),nowTime,m.getResult(),m.isSuccess());
			try{
			ObjectOutputStream out = new ObjectOutputStream(evOut);
			out.writeObject(resultEvent);
			}catch(Exception exp){};
		}
		System.out.println("Out of ManThread.run()");
	}

	public String getHostName()
	{
		try {
		String name = InetAddress.getLocalHost().getHostName();
		return name;
		}catch(Exception e){};
		return "";
	}


}

				
				
