/*
 * @(#) NodeRMIInterface.java 99/1/15
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.rmi;
 
import java.rmi.*;
import java.util.*;
import java.rmi.server.UnicastRemoteObject;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.manipulate.*;

/**
 * Define the rmi interfaces can be called from remote server.
 *
 * @author Jimmy Liang
 * @version 1.00 1/15/99
 */

public interface NodeRMIInterface extends Remote
{
	public Object resource_GetObject(String rn) throws RemoteException;
	public Vector resource_GetVector(String rn) throws RemoteException;
	public Hashtable resource_GetHashtable(String rn) throws RemoteException;
	
	public void monitor_Register(MonitorRegistryEvent evt) throws RemoteException;
	public void monitor_Unregister(MonitorRegistryEvent evt) throws RemoteException;
	public void monitor_Update(MonitorRegistryEvent evt) throws RemoteException;
	public void manipulate(ManipulateEvent evt, Manipulation m) throws RemoteException;
	public void test()  throws RemoteException;
}
