/*
 * @(#) NodeRMIImpl.java 99/1/15
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.rmi;
 
import java.rmi.*;
import java.util.*;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.server.RemoteServer;
import java.net.*;
import java.io.*;

/**
 * Implement the rmi interfaces defined by class NodeRMIInterface. Act as 
 * a deamon on each participants of the cluster.
 *
 * @author Jimmy Liang
 * @version 1.00 1/15/99
 */

public class ServerRMIImpl extends UnicastRemoteObject implements ServerRMIInterface
{
	public ServerRMIImpl() throws RemoteException
	{
		super();
	}
	
	public Object loadObject(String rn) throws RemoteException
	{
		try {
			Class cl = Class.forName(rn);
			return cl.newInstance();
		}catch(Exception e){
			return null;
		} 
	}

	public static void main(String args[])
	{
		System.setSecurityManager(new CLUSTERPROBE.resources.MySecurityManager());
		try {
			String localName = InetAddress.getLocalHost().getHostAddress();
			String name = "rmi://"+localName+":3000/server";
			System.out.println("Registering agent as \" "+name+" \"");
			ServerRMIImpl obj = new ServerRMIImpl();
			System.out.println("Create server, binding....");
			Naming.rebind(name,obj);
			System.out.println("Server ready...");
		}catch(Exception e) {
			System.out.println("Caught exception while registering: "+e.toString());	
		}
	}
}
