 /*
 * @(#)Exec.java 99/4/16
 *
 * Copyright 1997, 1998 by SRG, Dept. of Computer Science, Hong Kong Univ.
 * Pokfulam RD, Hong Kong, China
 * All rights reserved.
 * 
 * This software is the condifential and prprietary information of SRG. 
 * You shall not disclose such confidential information and shall use it
 * only in accordance with the terms of the license agreement you got this
 * software.
 */

package CLUSTERPROBE.security;

import java.io.*;
import CLUSTERPROBE.log.*;

/**
 * Exec binary/script command with specify user.
 *
 * @author Jimmy Liang
 * @version 1.00 4/16/99
 */

public class Exec 
{
	public static String HELPER = null;

	public static StreamGroup exec(String command, Password pw)
	{
		DataOutputStream od = null;
		BufferedReader id = null;
		BufferedReader ed = null;

		Runtime r = Runtime.getRuntime();

		Process p = null;

		if (HELPER==null) 
		{
			System.out.println("Helper is null!");
			Log.log(Log.ERRFILE, "Helper is null!");
			return null;
		}

		try {
			String comm=HELPER+" "+" "+Log.LOGFILE+" "+Log.ERRFILE;
			p = r.exec(comm);
		//p = r.exec(HELPER+" "+" "+Log.LOGFILE+" "+Log.ERRFILE);
		System.out.println("in Exec.java, after r.exec");
		Thread.sleep(50);
		id = new BufferedReader(new InputStreamReader(p.getInputStream()));
		ed = new BufferedReader(new InputStreamReader(p.getErrorStream()));
		od = new DataOutputStream(p.getOutputStream());
		
		if (writeDatumToStdout(command,pw,od,id)!=0)
		{
			System.out.println("writeDatumToStdout() failed.");
			Log.log(Log.ERRFILE, "(writeDatumToStdout() failed - terminating helper:" + command);
			p.destroy();
			return null;
		}	
		System.out.println("writeDatumToStdout() successful.");
		return new StreamGroup(p,id,ed,od);

		}catch(Exception e) {
			System.out.println("Exception:"+e);
			Log.log(Log.ERRFILE, "Error executing >"+ HELPER+"<"+e.toString());	
			if (p!=null)
				p.destroy();
			return null;
		}

	}	
			
	private static int writeDatumToStdout(String command, Password pw, DataOutputStream od, BufferedReader id)
	{

		String str,str2;

		try {
		od.writeBytes(String.valueOf(command)+"\n");
		od.flush();
		str = id.readLine();
		str2 = ">"+command+"<";
		if (!str.equals(str))
		{
			Log.log(Log.ERRFILE,"ERROR command "+str2+"!="+str);
			return (-1);
		}		

		String uname = pw.getUname();
		if (uname==null) uname = "guest";
		od.writeBytes(String.valueOf(uname)+"\n");
		od.flush();
		str = id.readLine();
		str2 = ">"+uname+"<";
		if (!str.equals(str))
		{
			Log.log(Log.ERRFILE,"ERROR uname "+str2+"!="+str);
			return (-1);
		}		
		
		String passwd = pw.getPasswd();
		if (passwd==null) passwd = "guest";
		od.writeBytes(String.valueOf(passwd)+"\n");
		od.flush();
		str = id.readLine();
		str2 = ">"+passwd+"<";
		if (!str.equals(str))
		{
			Log.log(Log.ERRFILE,"ERROR password "+str2+"!="+str);
			return (-1);
		}		
					
		String cwd = pw.getCWD();
		if (cwd==null) cwd = ".";
		od.writeBytes(String.valueOf(cwd)+"\n");
		od.flush();
		str = id.readLine();
		str2 = ">"+cwd+"<";
		if (!str.equals(str))
		{
			Log.log(Log.ERRFILE,"ERROR cwd "+str2+"!="+str);
			return (-1);
		}		
		
		}catch(Exception ex) {
			Log.log(Log.ERRFILE,"Error writing stdout pipe to >"+HELPER+"<"+ex.toString());
		}
		
		return (0);
	}

	public static void main(String[] args)
	{
		String command = "/bin/ls";
		Password pw = new Password();

		if (args.length>0) 
			command = args[0];
		
		if (args.length>2) {
			pw.setUname(args[1]);
			pw.setPasswd(args[2]);	
		}
		else {
			pw.setUname("zyliang");
			pw.setPasswd("33j82i334m");
		}

		if (args.length>3) 
			pw.setCWD(args[3]);
		else
			pw.setCWD("/tmp");

		Exec.HELPER = "/usr/sbin/helper";
		StreamGroup group = Exec.exec(command,pw);
		if (group==null) 
		{
			System.out.println("group==null");
			System.exit(-1);
		}
		
		try {
			group.p.waitFor();

			int exit_value = group.p.exitValue();

			if (exit_value==0)
			{
				System.out.println("Executing "+command+" successful, the output is :");
				while (true)
				{
					String line = group.id.readLine();
					if (line==null) break;
					System.out.println(line);
				}
			} 
			else
			{
				System.out.println("Executing "+command+" fail, the error is :");
				while (true)
				{
					String line = group.ed.readLine();
					if (line==null) break;
					System.out.println(line);
				}
				
			}
		}catch(Exception e){
			System.out.println(e);
			e.printStackTrace();
		}
		System.exit(0);	
	}
			
}	
