/*
 * Copyright 1998
 *
 * SUPER COMPUTER COMPUTATIONS RESEARCH INSTITUTE
 *            FLORIDA STATE UNIVERSITY
 *
 *
 * DISCLAIMER OF WARRANTY AND LIMITATION OF LIABILITY.
 * THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 * KIND, WHETHER EXPRESS OR IMPLIED. WITHOUT LIMITATION,
 * FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE DISCLAIMS ALL IMPLIED  WARRANTIES WITH RESPECT TO THE
 * SOFTWARE, ITS MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 * YOU ASSUME ALL RISK IN USING THE SOFTWARE.  IN NO EVENT
 * WILL FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE BE LIABLE FOR INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES, INCLUDING, WITHOUT LIMITATION, LOSS OF INCOME, LOSS OF USE OR
 * LOSS OF INFORMATION.  IN NO EVENT WILL FLORIDA STATE UNIVERSITY BE
 * LIABLE FOR ANY DAMAGES, EVEN IF FLORIDA STATE UNIVERSITY &
 * SUPERCOMPUTER  COMPUTATIONS RESEARCH  INSTITUTE SHALL HAVE BEEN
 * INFORMED OF THE POSSIBILITY OF SUCH DAMAGES OR FOR ANY  CLAIM BY
 * ANY OTHER PARTY.
 *
 * This software is freely distributed for non-resale
 * purposes only.  Resale of this product or any products
 * derived from this product without the explicit written
 * permission of the author, SCRI and FSU shall be deemed
 * a breach of this copyright.
 *
 * $Log: helper.c,v $
 * Revision 1.5  1998/08/31 18:20:22  green
 * instantiate a new environ
 *
 * Revision 1.4  1998/08/31 17:47:58  green
 * didn't allow for changing uid with jobErrFile or debugFile - hacked a fix
 *
 * Revision 1.3  1998/08/26 17:34:50  green
 * changed jqs_setenv() to native setenv()
 * set environs for BATCH, JQS_JID, USER, HOME, CWD
 *
 * Revision 1.2  1998/08/24 19:59:31  green
 * changed error logging
 *
 * Revision 1.1.1.1  1998/08/20 12:54:06  green
 * Initial JQS Import
 *
 *
 */


#include <string.h>
#include <stdio.h>
#include <errno.h>                                                  
#include <sys/types.h>
#include <sys/wait.h>
#include <pwd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>

/********************************************************************/
main(argc, argv,envp)
     int argc;
     char **argv;
     char **envp;
{
  
  /********************************************************************/
  if (validPasswd(argv[1],argv[2]))
    exit(-1);
  exit(0);
}  

/************************************************************/
int validPasswd(char *uname, char *passwd) {
  
  char *etcEncryptedPasswd,*myEncryptedPasswd;
  struct passwd *pw;
  char salt[3];
  
fprintf(stderr,"%s %s\n",uname,passwd);

  if (!uname) {
    fprintf(stderr,"error: a null uname");
    return(-1);
  }
  
  if (!passwd) {
    fprintf(stderr,"error: a null passwd");
    return(-1);
  }
  
  pw=getpwnam(uname);
  if (!pw) {
    fprintf(stderr,"error: getpwnam(%s) failed",
            uname);
    return(-1);
  }
  
  if (!pw->pw_passwd) {
    fprintf(stderr,"error: pw->pw_passwd is null");
    return(-1);
  }
  
  if(strlen(pw->pw_passwd) <2) {
    fprintf(stderr,"error: strlen(pw->pw_passwd) < 2");
    return(-1);
  }
  
  bzero(salt,sizeof(salt));
  salt[0]=pw->pw_passwd[0];
  salt[1]=pw->pw_passwd[1];
  
  myEncryptedPasswd=(char *) crypt(passwd,salt);
  
  if (!myEncryptedPasswd) {
    fprintf(stderr,"error: crypt() returned null");
    return(-1);
  }
  
  
  bzero(passwd,strlen(passwd));
  
  if (!strcmp(pw->pw_passwd,myEncryptedPasswd)) {
    fprintf(stderr,"OK\n");
    return(0);
  }
   
  fprintf(stderr,"error: password is not correct!\n"); 
  return(-1);
  
}
