/*
 * Copyright 1998
 *
 * SUPER COMPUTER COMPUTATIONS RESEARCH INSTITUTE
 *            FLORIDA STATE UNIVERSITY
 *
 *
 * DISCLAIMER OF WARRANTY AND LIMITATION OF LIABILITY.
 * THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 * KIND, WHETHER EXPRESS OR IMPLIED. WITHOUT LIMITATION,
 * FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE DISCLAIMS ALL IMPLIED  WARRANTIES WITH RESPECT TO THE
 * SOFTWARE, ITS MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 * YOU ASSUME ALL RISK IN USING THE SOFTWARE.  IN NO EVENT
 * WILL FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE BE LIABLE FOR INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES, INCLUDING, WITHOUT LIMITATION, LOSS OF INCOME, LOSS OF USE OR
 * LOSS OF INFORMATION.  IN NO EVENT WILL FLORIDA STATE UNIVERSITY BE
 * LIABLE FOR ANY DAMAGES, EVEN IF FLORIDA STATE UNIVERSITY &
 * SUPERCOMPUTER  COMPUTATIONS RESEARCH  INSTITUTE SHALL HAVE BEEN
 * INFORMED OF THE POSSIBILITY OF SUCH DAMAGES OR FOR ANY  CLAIM BY
 * ANY OTHER PARTY.
 *
 * This software is freely distributed for non-resale
 * purposes only.  Resale of this product or any products
 * derived from this product without the explicit written
 * permission of the author, SCRI and FSU shall be deemed
 * a breach of this copyright.
 *
 * $Log: def.h,v $
 * Revision 1.1.1.1  1998/08/20 12:54:06  green
 * Initial JQS Import
 *
 *
 */

/* under UNIX, no jobs */

#define MIN_GID 100
#define MIN_UID 100

/****************************************************************************/
/* don't modify anything below here unless you know what you are doing...   */
 
#define MAX_STRING  2048
typedef char string[MAX_STRING];

struct jobel {
  string job_owner;
  string cwd;
  string passwd;
  string exec_script_file_name;
};
typedef struct jobel job_type;

char **envnew;
extern char **environ;
int child;
string tstr;
job_type job;

/****************************************************************************/
/* SCRI_COMPILE_DEBUG inserts debugging macros
 * LEAVE THEM IN!(or don't call if ya need help)
 */

#define SCRI_COMPILE_DEBUG    1
#define DAEMONIZED            1

#define MAX_STRING         2048

#define LOG_DEBUG             1
#define LOG_ERR              -1
#define LOG_INFO             -2

extern void scri_indent();
extern void scri_log();
extern void scri_do_log();
extern void scri_syslog();

string       logFile;
string       errFile;
string       jobErrFile;
string       debugFile;
string       scri_hostname;
string       scri_program_name;
int          DEBUG_ON=0;
int          DEBUG_INDENT=0;
int          DEBUG_TRACEID=0;
int          loglevel=0;

char dbuffer[4096];
int dbl;

/*********************************************************/
/* Logging macros from hell                              */
/*********************************************************/

#define ERROR(x)    sprintf x;scri_log(LOG_ERR,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__)
#define INFO(x)     sprintf x;scri_log(LOG_INFO,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__)

#ifdef SCRI_COMPILE_DEBUG 


#define DENTER_MAIN(x) \
   int SCRI_OINDENT;\
   string SCRI_FUNC,SCRI_EVENT; \
   SCRI_FUNC[0]=0;\
   gethostname(scri_hostname,sizeof(scri_hostname));\
   strcpy(scri_program_name,argv[0]);\
   sprintf(logFile,"%s",argv[1]);\
   sprintf(errFile,"%s",argv[2]);\

#define DENTER(x)\
   int  LOG_LEVEL=LOG_DEBUG,SCRI_OINDENT; \
   string SCRI_FUNC,SCRI_EVENT; \
   SCRI_FUNC[0]=0;\
   if (DEBUG_ON)\
   {\
      strcpy x;\
      strcpy(SCRI_FUNC,SCRI_EVENT);\
      SCRI_OINDENT=DEBUG_INDENT;\
      DEBUG_INDENT+=8;\
      sprintf(SCRI_EVENT,"--> %s()",SCRI_FUNC);\
      scri_log(LOG_DEBUG,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__);\
   }

#define DPRINTF(x)\
   if (DEBUG_ON)\
   {\
     sprintf x;\
     scri_log(LOG_DEBUG,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__);\
   } 

#define DTRACE\
   if (DEBUG_ON)\
   {\
     sprintf(SCRI_EVENT,"TRACE");\
     scri_log(LOG_DEBUG,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__);\
   }

#define DEXIT\
   if (DEBUG_ON)\
   {\
     sprintf(SCRI_EVENT,"<-- %s()",SCRI_FUNC);\
     scri_log(LOG_DEBUG,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__);\
     DEBUG_INDENT=SCRI_OINDENT;\
   }

#define DEXITE\
   if (DEBUG_ON)\
   {\
     sprintf(SCRI_EVENT,"<-- %s() *** ERROR ***",SCRI_FUNC);\
     scri_log(LOG_DEBUG,SCRI_EVENT,__FILE__,SCRI_FUNC,__LINE__);\
     DEBUG_INDENT=SCRI_OINDENT;\
   }

#else 
#define DENTER(x) {}
#define DTRACE    {}
#define DTRACEE   {}
#define DPRINTF(x){} 
#define DEXIT     {}
#define DEXITE    {}
#endif


#if defined(_AIX) || defined(SVR3)
#define SCRI_ASSERT(x)  if x ; else {scri_log(LOG_CRIT, # x ,__FILE__,SCRI_FUNC,__LINE__);scri_log(LOG_CRIT,"unrecoverable error - contact systems manager",__FILE__,SCRI_FUNC,__LINE__);abort();}
#else
#define SCRI_ASSERT(x)  if x ; else {scri_log(LOG_CRIT,"unrecoverable error - contact systems manager",__FILE__,SCRI_FUNC,__LINE__);abort();}
#endif



