/*
 * Copyright 1998
 *
 * SUPER COMPUTER COMPUTATIONS RESEARCH INSTITUTE
 *            FLORIDA STATE UNIVERSITY
 *
 *
 * DISCLAIMER OF WARRANTY AND LIMITATION OF LIABILITY.
 * THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 * KIND, WHETHER EXPRESS OR IMPLIED. WITHOUT LIMITATION,
 * FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE DISCLAIMS ALL IMPLIED  WARRANTIES WITH RESPECT TO THE
 * SOFTWARE, ITS MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 * YOU ASSUME ALL RISK IN USING THE SOFTWARE.  IN NO EVENT
 * WILL FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE BE LIABLE FOR INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES, INCLUDING, WITHOUT LIMITATION, LOSS OF INCOME, LOSS OF USE OR
 * LOSS OF INFORMATION.  IN NO EVENT WILL FLORIDA STATE UNIVERSITY BE
 * LIABLE FOR ANY DAMAGES, EVEN IF FLORIDA STATE UNIVERSITY &
 * SUPERCOMPUTER  COMPUTATIONS RESEARCH  INSTITUTE SHALL HAVE BEEN
 * INFORMED OF THE POSSIBILITY OF SUCH DAMAGES OR FOR ANY  CLAIM BY
 * ANY OTHER PARTY.
 *
 * This software is freely distributed for non-resale
 * purposes only.  Resale of this product or any products
 * derived from this product without the explicit written
 * permission of the author, SCRI and FSU shall be deemed
 * a breach of this copyright.
 *
 * $Log: helper.c,v $
 * Revision 1.5  1998/08/31 18:20:22  green
 * instantiate a new environ
 *
 * Revision 1.4  1998/08/31 17:47:58  green
 * didn't allow for changing uid with jobErrFile or debugFile - hacked a fix
 *
 * Revision 1.3  1998/08/26 17:34:50  green
 * changed jqs_setenv() to native setenv()
 * set environs for BATCH, JQS_JID, USER, HOME, CWD
 *
 * Revision 1.2  1998/08/24 19:59:31  green
 * changed error logging
 *
 * Revision 1.1.1.1  1998/08/20 12:54:06  green
 * Initial JQS Import
 *
 *
 */


#include <string.h>
#include <stdio.h>
#include <errno.h>                                                  
#include <sys/types.h>
#include <sys/wait.h>
#include <pwd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>

#include "def.h"

void readInJob();
void setup_sig_handlers();
void reap();

char **envnew;

/********************************************************************/
main(argc, argv,envp)
     int argc;
     char **argv;
     char **envp;
{
  
  /********************************************************************/
  typedef char string[MAX_STRING];
  struct passwd *pw;
  string str,stdout_path,stderr_path,command,passwd;
  int i,pid,in,out,err;
  int exitValue = 0;
  
  DENTER_MAIN((SCRI_EVENT,"helper"));
  
  sleep(1);
  bzero(&job,sizeof(job));
  readInJob(&job);
  if (validPasswd(job.job_owner, job.passwd)) {
    sprintf(tstr,"ERROR: Invalid Passwd - aborting");
    fprintf(stderr,"ERROR: Invalid Passwd - aborting");
    ERROR((SCRI_EVENT,tstr));
    exit(-1);
  }



/*
  if ((child=fork())!=0) {
    
    setup_sig_handlers();
    
    for (;;) {
      
      sleep(1);
      bzero(&command,sizeof(command));
      gets(command);
      sprintf(tstr,"gets() returned >%s<",
	      command);
      fprintf(stderr,"gets() returned >%s<",
	      command);
      fflush(stdout);
      if (!strcmp(command,"DIE")) {
	sprintf(tstr,"Sending killpg(%d,%s) - Exiting",
		child,command);
	fprintf(stderr,"Sending killpg(%d,%s) - Exiting",
		child,command);
	sprintf(tstr,"received killpg(%d,%s) - Exiting",
		child,command);
	fprintf(stderr,"received killpg(%d,%s) - Exiting",
		child,command);
	ERROR((SCRI_EVENT,tstr));
	killpg(child,9);
	sleep(2);
	exit(1);
      }
    }
    
  }    
  */
  /*-----------------------------------------------------------------*/
  /* child */
  
  alarm(0);
  pid = getpid();
  setpgid(pid,pid);
  
  pw = getpwnam(job.job_owner);
  if (pw == (struct passwd *)NULL) {       /* better safe than sorry */
    sprintf(tstr,"getpwnam(%s) Failed - Exiting",
	    job.job_owner);
    fprintf(stderr,"getpwnam(%s) Failed - Exiting",
	    job.job_owner);
    ERROR((SCRI_EVENT,tstr));
    exit(-99);
  }

  set_uid_gid(pw);                                    
  
  envnew = (char **) malloc(sizeof (char *) * (256));
  envnew[0]=NULL;
  environ = envnew;

  setenv("HOME",pw->pw_dir,1);
  setenv("USER",pw->pw_name,1);

  if (chdir(job.cwd)) {
    sprintf(tstr,"chdir(%s) Failed - Exiting",
    	      job.cwd);
    fprintf(stderr,"chdir(%s) Failed - Exiting",
	      job.cwd);
    ERROR((SCRI_EVENT,tstr));
    exit(-99);
  }
  setenv("CWD",job.cwd,1);

  umask(022);

  exitValue = system(job.exec_script_file_name);

  if (exitValue!=0)
  {
  	sprintf(tstr,"execute (%s) fail",job.exec_script_file_name);
  	fprintf(stderr,"execute (%s) fail ",job.exec_script_file_name);
	exit(-1);
  }

  exit(0);
}  

/***********************************************************************/
int set_uid_gid(struct passwd *pw) {
  
  int           status;
  
  DENTER((SCRI_EVENT,"set_uid_gid"));
  if (getuid()) { /* not running as root */
    sprintf(tstr,"WARNING - execd not running as root ");
    fprintf(stderr,"WARNING - execd not running as root ");
    ERROR((SCRI_EVENT,tstr));
    exit(-98);
  }

  if (!pw) { /* a truely bad thing */ 
    sprintf(tstr,"error: a null passwd - exiting");
    fprintf(stderr,"error: a null passwd - exiting");
    ERROR((SCRI_EVENT,tstr));
    exit(-99);
  }

  if (setgid(pw->pw_gid)) {
    sprintf(tstr,"error: setgid(%d) failed - exiting",
            pw->pw_gid);
    fprintf(stderr,"error: setgid(%d) failed - exiting",
            pw->pw_gid);
    ERROR((SCRI_EVENT,tstr));
    exit(-99);
  }

  status=initgroups(pw->pw_name,pw->pw_gid);
 
  /*
    (subject to change with OS releases)
  OS 		return		errno
  AIX		1		1
  ULTRIX	1		1
  OSF/1		1		1
  IRIX		-1		1	(return #groups if successful)
  SUNOS		-1		1
  */
 
#if (defined(SVR3) || defined(sun) || defined(solaris) || defined(SOLARIS23) || defined(SOLARIS24) )
  if (status<0) {
    sprintf(tstr,"error: initgroups(%s,%d) failed - exiting",
            pw->pw_name,pw->pw_gid);
    fprintf(stderr,"error: initgroups(%s,%d) failed - exiting",
            pw->pw_name,pw->pw_gid);
    ERROR((SCRI_EVENT,tstr));
    exit(-99);
  }
#else
  if (status) {
    sprintf(tstr,"error: nitgroups(%s,%d) failed - exiting",
            pw->pw_name,pw->pw_gid);
    fprintf(stderr,"error: nitgroups(%s,%d) failed - exiting",
            pw->pw_name,pw->pw_gid);
    ERROR((SCRI_EVENT,tstr));
    exit(-99);
  }
#endif

    if (setuid(pw->pw_uid))
    {
      sprintf(tstr,"error: setuid(%d) failed - exiting",
	      pw->pw_uid);
      fprintf(stderr,"error: setuid(%d) failed - exiting",
	      pw->pw_uid);
      ERROR((SCRI_EVENT,tstr));
      exit(-99);
    }
  
  return;
  
}

/********************************************************/
void setup_sig_handlers()
     
{
  
  struct sigaction     sigcld_vec,   sigcld_ovec;
  DENTER((SCRI_EVENT,"setup_sig_handler"));
  
  sigcld_vec.sa_handler=reap;
  sigcld_vec.sa_flags=SA_NOCLDSTOP;
  sigfillset(&sigcld_vec.sa_mask);
  sigdelset(&sigcld_vec.sa_mask,SIGQUIT);
  sigdelset(&sigcld_vec.sa_mask,SIGALRM);
  sigdelset(&sigcld_vec.sa_mask,SIGURG);
  sigdelset(&sigcld_vec.sa_mask,SIGIO);
  sigdelset(&sigcld_vec.sa_mask,SIGABRT);
  sigdelset(&sigcld_vec.sa_mask,SIGILL);
  sigcld_vec.sa_flags=0;
  sigaction(SIGCHLD,&sigcld_vec,&sigcld_ovec);
  
}

/********************************************************/
void reap()
     
{
  struct rusage rusage;
  
#if (SVR3) /* DAMN this is irratating */
  union wait status;
#else
  int status;
#endif
  int pid = 1;
  
  while (pid > 0 ) {
    
    bzero(&rusage,sizeof(rusage));
  restart:
#ifndef __hpux
    pid=wait3(&status,WNOHANG,(struct rusage *) &rusage);
#else
    pid=waitpid(-1,&status,WNOHANG);
#endif
    
    if (pid==0) {  /* no stopped or exited children */
      sprintf(tstr,"wait() returned 0 - continuing");
      fprintf(stderr,"wait() returned 0 - continuing");
      continue;
    }
    
    if (pid==-1) { /* no children not previously waited for */
      sprintf(tstr,"wait() returned -1 - continuing");
      fprintf(stderr,"wait() returned -1 - continuing");
      continue;
    }
    
    if (WIFSTOPPED(status)) { /* WIFSTOPPED */
      sprintf(tstr,"WIFSTOPPED - continuing");
      fprintf(stderr,"WIFSTOPPED - continuing");
      continue;
    }
    
    /*
    if (pid==child) { 
      sprintf(tstr,"reaped child %d",
              pid);
      fprintf(stderr,"reaped child %d",
              pid);
      exit(status);
    }
    */
    
  }
  
}

/************************************************************/
int validPasswd(char *uname, char *passwd) {
  
  char *etcEncryptedPasswd,*myEncryptedPasswd;
  struct passwd *pw;
  char salt[3];
  
  DENTER((SCRI_EVENT,"validPasswd")); 
  if (!uname) {
    sprintf(tstr,"error: a null uname");
    fprintf(stderr,"error: a null uname");
    return(-1);
  }
  
  if (!passwd) {
    sprintf(tstr,"error: a null passwd");
    fprintf(stderr,"error: a null passwd");
    return(-1);
  }
  
  pw=getpwnam(uname);
  if (!pw) {
    sprintf(tstr,"error: getpwnam(%s) failed",
            uname);
    fprintf(stderr,"error: getpwnam(%s) failed",
            uname);
    return(-1);
  }
  
  if (!pw->pw_passwd) {
    sprintf(tstr,"error: pw->pw_passwd is null");
    fprintf(stderr,"error: pw->pw_passwd is null");
    return(-1);
  }
  
  if(strlen(pw->pw_passwd) <2) {
    sprintf(tstr,"error: strlen(pw->pw_passwd) < 2");
    fprintf(stderr,"error: strlen(pw->pw_passwd) < 2");
    return(-1);
  }
  
  bzero(salt,sizeof(salt));
  salt[0]=pw->pw_passwd[0];
  salt[1]=pw->pw_passwd[1];
  
  myEncryptedPasswd=(char *) crypt(passwd,salt);
  
  if (!myEncryptedPasswd) {
    sprintf(tstr,"error: crypt() returned null");
    fprintf(stderr,"error: crypt() returned null");
    return(-1);
  }
  
  
  bzero(passwd,strlen(passwd));
  
  if (!strcmp(pw->pw_passwd,myEncryptedPasswd)) {
    return(0);
  }
  
  DEXIT;
  return(-1);
  
}

#include "utility.c"
