/*
 * Copyright 1998
 *
 * SUPER COMPUTER COMPUTATIONS RESEARCH INSTITUTE
 *            FLORIDA STATE UNIVERSITY
 *
 *
 * DISCLAIMER OF WARRANTY AND LIMITATION OF LIABILITY.
 * THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 * KIND, WHETHER EXPRESS OR IMPLIED. WITHOUT LIMITATION,
 * FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE DISCLAIMS ALL IMPLIED  WARRANTIES WITH RESPECT TO THE
 * SOFTWARE, ITS MERCHANTABILITY AND FITNESS FOR ANY PARTICULAR PURPOSE.
 * YOU ASSUME ALL RISK IN USING THE SOFTWARE.  IN NO EVENT
 * WILL FLORIDA STATE UNIVERSITY & SUPERCOMPUTER COMPUTATIONS RESEARCH
 * INSTITUTE BE LIABLE FOR INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES, INCLUDING, WITHOUT LIMITATION, LOSS OF INCOME, LOSS OF USE OR
 * LOSS OF INFORMATION.  IN NO EVENT WILL FLORIDA STATE UNIVERSITY BE
 * LIABLE FOR ANY DAMAGES, EVEN IF FLORIDA STATE UNIVERSITY &
 * SUPERCOMPUTER  COMPUTATIONS RESEARCH  INSTITUTE SHALL HAVE BEEN
 * INFORMED OF THE POSSIBILITY OF SUCH DAMAGES OR FOR ANY  CLAIM BY
 * ANY OTHER PARTY.
 *
 * This software is freely distributed for non-resale
 * purposes only.  Resale of this product or any products
 * derived from this product without the explicit written
 * permission of the author, SCRI and FSU shall be deemed
 * a breach of this copyright.
 *
 * $Log: utility.c,v $
 * Revision 1.4  1998/08/31 17:42:51  green
 * fixed several logging bugs
 *
 * Revision 1.3  1998/08/26 20:10:15  green
 * qacct support
 *
 * Revision 1.2  1998/08/26 16:46:28  green
 * yanked passwd out of fakeJob()
 *
 * Revision 1.1.1.1  1998/08/20 12:54:06  green
 * Initial JQS Import
 *
 *
 */

/********************************************************************/

void readInJob(job_type *job) {
  
  gets(job->exec_script_file_name);
  printf(">%s<\n",job->exec_script_file_name);
  fflush(stdout);

  gets(job->job_owner);
  printf(">%s<\n",job->job_owner);
  fflush(stdout);
  
  gets(job->passwd);
  printf(">%s<\n",job->passwd);
  fflush(stdout);

  gets(job->cwd);
  printf(">%s<\n",job->cwd);
  fflush(stdout);

  return;
}

/************************************************************************/
void scri_indent()
     
{
  
  int i; 
  
  if (DEBUG_INDENT > 80)
    DEBUG_INDENT=80;
  
  for (i=0;i<DEBUG_INDENT;i++)
    strcat(dbuffer," ");
  return;
}

/************************************************************************/
void scri_log(log_level,mesg,file__,func__,line__)
     int log_level;
     char *mesg;
     char *file__;
     char *func__;
     int  line__;
     /*
       DO NOT USE SCRI_ASSERT OR LOGGING MACROS IN THIS ROUTINE!
       THIS MODULE MUST ACT STAND-ALONE!
     */
     
     
{
  struct stat buf;
  int fd,pid;
  string str,str2;
  u_long timenow;
  struct timeval  now;
  struct timezone tzp;
  
  pid = getpid();
  bzero(str,sizeof(str));
  bzero(str2,sizeof(str2));
  bzero(dbuffer,sizeof(dbuffer));
  gettimeofday(&now, &tzp);
  timenow=(u_long)now.tv_sec;
  
  sprintf(str2,"   %s   Line %d   PID %d\n",file__,line__,pid);   
  
  if (log_level>0) { /* it was called by debugging macros */  
    DEBUG_TRACEID++;
    sprintf(str,"%d\t%ld  ",DEBUG_TRACEID,timenow);
    scri_indent();
    strcat(str,dbuffer); 
    strcat(str,mesg);
    strcat(str,str2);
    scri_do_log(log_level,str);
    if (DEBUG_ON && !DAEMONIZED)
      printf(str);
  } else {
    sprintf(str,"%s%s",mesg,str2);
    scri_do_log(log_level,str);
    if (!DAEMONIZED)
      printf(str);
    if (DEBUG_ON)
      scri_do_log(1,str);
  }
  
  return;
  
}

/************************************************************************/
void scri_do_log(log_level,err_str)
     int  log_level;
     char *err_str;
     
{
  
  int         fd;
  char        *log_file;
  struct stat buf;
  
  if (log_level==LOG_ERR) {
    if (stat(errFile,&buf))
      close(creat(errFile,S_IWUSR | S_IRUSR));
    if ((fd=open(errFile,O_WRONLY | O_APPEND)) >=0)
      {
	(int) write(fd,err_str,strlen(err_str));
	close(fd);
      }
    close(creat(jobErrFile,S_IWUSR | S_IRUSR));
    if ((fd=open(jobErrFile,O_WRONLY | O_APPEND)) >=0)
      {
        (int) write(fd,err_str,strlen(err_str));
        close(fd);
      }
    if (stat(debugFile,&buf))
      close(creat(debugFile,S_IWUSR | S_IRUSR));
    if ((fd=open(debugFile,O_WRONLY | O_APPEND)) >=0)
      {
        (int) write(fd,err_str,strlen(err_str));
        close(fd);
      }
  }

  if (log_level==LOG_INFO) {
    if (stat(logFile,&buf))
      close(creat(logFile,S_IWUSR | S_IRUSR));
    if ((fd=open(logFile,O_WRONLY | O_APPEND)) >=0)
      {
        (int) write(fd,err_str,strlen(err_str));
        close(fd);
      }
  }

  if (log_level==LOG_DEBUG) {
    if (stat(debugFile,&buf))
      close(creat(debugFile,S_IWUSR | S_IRUSR));
    if ((fd=open(debugFile,O_WRONLY | O_APPEND)) >=0)
      {
        (int) write(fd,err_str,strlen(err_str));
        close(fd);
      }
  }


  
  return;
  
}

