import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.ResourceTable;
import CLUSTERPROBE.message.ResourceTableData;

public class CICS_MonitorServlet extends HttpServlet
{

String[] objs = {"CLUSTERPROBE.resources.Cluster_Workstation_StatusTable","CLUSTERPROBE.resources.Cluster_Workstation_MemState","CLUSTERPROBE.resources.Cluster_Workstation_CPUState","CLUSTERPROBE.resources.Cluster_Workstation_CPUTemp","CLUSTERPROBE.resources.Cluster_Workstation_Network_ContTable_IP","CLUSTERPROBE.resources.Cluster_Workstation_Network_ContTable_Raw","CLUSTERPROBE.resources.Cluster_Workstation_Network_ContTable_Tcp","CLUSTERPROBE.resources.Cluster_Workstation_Network_ContTable_Udp","CLUSTERPROBE.resources.Cluster_Workstation_Network_ContTable_Unix","CLUSTERPROBE.resources.Cluster_Workstation_Network_Stat_IP","CLUSTERPROBE.resources.Cluster_Workstation_Network_Stat_Icmp","CLUSTERPROBE.resources.Cluster_Workstation_Network_Stat_Tcp","CLUSTERPROBE.resources.Cluster_Workstation_Network_Stat_Udp","CLUSTERPROBE.resources.Cluster_Workstation_LoginInfo","CLUSTERPROBE.resources.Cluster_Workstation_ProcessInfo","CLUSTERPROBE.resources.Cluster_Workstation_FanSpeed","CLUSTERPROBE.resources.Cluster_SystemLog","CLUSTERPROBE.resources.Cluster_Workstation_FsUtil"};

String[] rns = {"CPU Load","Memory","CPU Statistics","CPU Temperature","IP Connection Table","Raw Connection Table","TCP Connection Table","UDP Connection Table","UNIX Connection Table","IP Statistics","ICMP Statistics","TCP Statistics","UPD Statistics","Login Users","Running Processes","Fan Speed","System Log","Filesystem Utility"};

String[] displayTypes = {"Sheet I","Sheet II","Strip Chart I","Strip Chart II","Plain Graph","Stack Graph","Relative Graph","Pie Chart","LED Sign"};

static Hashtable groupToHost = new Hashtable();

// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	//set content type header before accessing the Writer
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();



	Resource rs = null;
	String server = "";
	int port = -1;
	int step = 1;

	try {
	step = Integer.parseInt(request.getParameter("step"));
	}catch(Exception ee){};

	try {
/*
	ResourceBundle pr = new PropertyResourceBundle((InputStream)(new FileInputStream("/home/httpd/html/Jessic.properties")));
	server = pr.getString("server").trim();
	port = Integer.parseInt((pr.getString("port").trim()));
*/
	server = InetAddress.getLocalHost().getHostName();
	port = 7001;
	}catch(Exception ee) {
		out.println("<html><head><title>Error Server</title></head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}

	int rindex = -1;
	try {
	rindex = Integer.parseInt(request.getParameter("rname"));
	String rname = objs[rindex];
	rs = (Resource) Class.forName(rname).newInstance();
	}catch(Exception e0) {};

	if (rindex!=-1)
	{
		if (rs==null)
		{
			out.println("<html><head><title>Error Name</title></head>");
			out.println("<body BACKGROUND=\"http://"+server+"/back1.gif\" nosave><p><br><center><h2>No matched Object</h2></center></body>");
			out.println("</html>");
			out.close();
			return;
		}
 	}

	int[] entryIndex = null;
	try {
	String entries = request.getParameter("entries");
	if (entries!=null) {
		StringTokenizer st = new StringTokenizer(entries,"|");
		entryIndex = new int[st.countTokens()];
		for (int i=0;i<entryIndex.length;i++)
			entryIndex[i] = Integer.parseInt(st.nextToken().trim());
	}
	}catch(Exception e1){};

	int hOpt = -1;
	try {
	hOpt = Integer.parseInt(request.getParameter("hopt"));
	}catch(Exception e2){};

	String hosts = null;
	try {
	hosts = request.getParameter("hosts");
	if (hOpt==1)
		hosts = transGroup(hosts);
	}catch(Exception e3){};

	String slots = null;
	try {
	slots = request.getParameter("slots");
	}catch(Exception e4){};

	int displayType = 0; 
	try {
		displayType = Integer.parseInt(request.getParameter("dtype"));
	}catch(Exception e5){};

	if (step==8)
		out.println("<BASE href=\"http://"+server+"/\">");
	if (step==7&&(displayType==2||displayType==3||displayType==7))
		out.println("<BASE href=\"http://"+server+"/\">");

	out.println("<html>");
	out.println("<head>");
	out.println("<title>Monitor</title>");

	if (step==7&&(displayType==2||displayType==3||displayType==7))
	{
		out.println("<script language=javascript>");
		out.println("var flag = true;");
		out.println("function stop(){");
		//out.println("if (document.forms[0].elements[0].value=\"  Stop  \")");
		out.println("if (flag)");	
		out.println("{");
		out.println("flag = false;");
		out.println("document.monitor.stop();");
		out.println("document.forms[0].elements[0].value=\" Restart\";");
		out.println("}");
		out.println("else");
		out.println("{");
		out.println("flag = true;");
		out.println("location.href = location.href;");
		out.println("}");
		out.println("}");
		out.println("</script>");
	}

	out.println("<script language=javascript>");
	out.println("function relocation(server,step,dir,form)");
	out.println("{");
	out.println("var temp,temp1;");
	out.println("var i;");
	out.println("if (step==1)");
	out.println("{");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor?step=2&rname=\"+form.object.selectedIndex;");
	out.println("}");

	out.println("else if(step==2)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp=\"\";");
	out.println("for(i=0;i<(form.elements.length-2);i++)");
	out.println("if (form.elements[i].checked)");
	out.println("if (temp.length!=0)");
	out.println("temp = temp+\"|\"+i;");
	out.println("else");
	out.println("temp = temp+i;");
	out.println("if(temp.length==0)");
	out.println("alert('You must check at least one entry!');");
	out.println("else {");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,3);");
	out.println("temp1=trim(temp1,3);");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1+\"&entries=\"+temp;");
	out.println("}");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,1);"); 
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1;");
	out.println("}");
	out.println("}");

	out.println("else if (step==3)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,4);"); 
	out.println("temp1=trim(temp1,4);");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1+\"&hopt=\"+form.hopt.selectedIndex;");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,2);"); 
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1;");
	out.println("}");
	out.println("}");
	
	out.println("else if(step==4)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp=\"\";");
	out.println("for(i=0;i<(form.elements.length-2);i++)");
	out.println("{");
	out.println("if (form.elements[i].checked)");
	out.println("if (temp.length!=0)");
	out.println("temp = temp+\"|\"+form.elements[i].name;");
	out.println("else");
	out.println("temp = temp+form.elements[i].name;");
	out.println("}");
	out.println("if(temp.length==0)");
	out.println("alert('You must check at least one host or group!');");
	out.println("else {");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,5);");
	out.println("temp1=trim(temp1,5);");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1+\"&hosts=\"+temp;");
	out.println("}");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,3);"); 
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1;");
	out.println("}");
	out.println("}");

	out.println("else if(step==5)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp= form.elements[0].value+\"|\"+form.elements[1].value;");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,6);");
	out.println("temp1=trim(temp1,6);");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1+\"&slots=\"+temp;");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,4);"); 
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1;");
	out.println("}");
	out.println("}");

	out.println("else if(step==6)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp= \"\"+form.dtype.selectedIndex;");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,7);");
	out.println("temp1=trim(temp1,7);");
	out.println("var winName = \"Monitor\"+(parent.parent.count++);");
	out.println("var win=parent.open(\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1+\"&dtype=\"+temp, winName, \"toolbar=0,location=0,directories=0,status=1,menubar=0,scrollbars=1,resizable=1,copyhistory=1,width=500,height=600\");");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\";");
	out.println("}");
	out.println("else");
	out.println("{");
	out.println("temp1 = location.search;");
	out.println("temp1 = replaceStep(temp1,5);"); 
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1;");
	out.println("}");
	out.println("}");

	out.println("else if(step==7)");
	out.println("{");
	out.println("if (dir)");
	out.println("{");
	out.println("temp1=location.search;");
	out.println("temp1=replaceStep(temp1,8);");
	out.println("location.href=\"http://\"+server+\":8080/servlet/cics_monitor\"+temp1;");
	out.println("}");
	out.println("}");

	out.println("}");

	out.println("function replaceStep(s,step)");
	out.println("{");
	out.println("var index = s.indexOf('=',0);");
	out.println("var ns;");
	out.println("ns = s.substring(0,index+1)+step+s.substring(index+2,s.length);");
	out.println("return ns;");
	out.println("}");

	out.println("function trim(s,step)");
	out.println("{");
	out.println("var index = 0;");
	out.println("var i;");
	out.println("for (i=0;i<(step-1);i++)");
	out.println("index = s.indexOf('&',index+1);");
	out.println("if (index==-1)");
	out.println("return s;");
	out.println("return s.substring(0,index);");
	out.println("}");

	out.println("</script>");
	if (step<7)
	{
		out.println("</head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center>\n");
	}

	switch (step)
	{
	case 1:
		out.println("<form>\n");
		out.println("<br><table cellspacing=4 cellpadding=2 align=center border=2 nowrap>\n");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=1 nowrap><font color=#ffffff size=5><b><i>Select monitored object</i></b></font></td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<font size=+3>");
		out.println("<tr><td bgcolor=#f0f000 align=center nowrap><select name=object size=1 RpGetType=complex RpSetType=complex>");
		for (int i=0;i<rns.length;i++)
		{
			if (i==rindex)
				out.println("<option selected>"+rns[i]);
			else
				out.println("<option>"+rns[i]);
		}
		out.println("</select>\n");
		out.println("</td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=center nowrap><input type=button value=\"Next\" onclick=\'relocation(\""+server+"\","+step+",true,this.form)\'></td></tr>");
		out.println("</font>");
		out.println("</table></form>");
		break;
	case 2:
		String[] eNames = ((ResourceTable)rs).getEntryNames();
		int[] eTypes =((ResourceTable)rs).getEntryType();
		out.println("<form>");
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>Select Monitored Entries</b></i></font></td></tr><tr><td></td></tr><tr>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Entry Name</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Entry Type</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
		out.println("</tr>");
		for (int i=0;i<eNames.length;i++)
		{
			out.println("<tr>");
			out.println("<td nowrap>"+eNames[i]+"</td>");
			switch (eTypes[i])
			{
			case Resource.SHORT:
				out.println("<td nowrap>SHORT</td>");
				break;
			case Resource.LONG:
				out.println("<td nowrap>LONG</td>");
				break;
			case Resource.STRING:
				out.println("<td nowrap>STRING</td>");
				break;
			case Resource.BOOLEAN:
				out.println("<td nowrap>BOOLEAN</td>");
				break;
			case Resource.FLOAT:
				out.println("<td nowrap>FLOAT</td>");
				break;
			case Resource.DOUBLE:
				out.println("<td nowrap>DOUBLE</td>");
				break;
			}
			boolean checked = false;
			if (entryIndex!=null)
			{
				for (int ii=0;ii<entryIndex.length;ii++)
				{
					if (entryIndex[ii]==i) {
						checked = true;
						break;
					}
				}
			}	
			if (checked)
				out.println("<td nowrap><input type=checkbox name=chk"+i+" checked></td>");
			else
				out.println("<td nowrap><input type=checkbox name=chk"+i+"></td>");
			out.println("</tr>");
		}
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=3 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",2,false,this.form)\'>");
		out.println("<input type=button name=next value=Next onClick=\'relocation(\""+server+"\",2,true,this.form)\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;	
	case 3:
		out.println("<form>");
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=1 nowrap><font color=#ffffff size=5><i><b>Select Monitored Hosts</b></i></font></td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#f0f000 align=center nowrap><select name=hopt size=1 RpGetType=complex RpSetType=complex>");
		switch (hOpt)
		{
		case -1:
		case 0:
			out.println("<option selected>Nodes<option>Groups");
			break;
		case 1:
			out.println("<option>Nodes<option selected>Groups");
		}
		out.println("</select></tr></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=1 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",3,false,this.form)\'>");
		out.println("<input type=button name=next value=Next onClick=\'relocation(\""+server+"\",3,true,this.form)\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;
	case 4:
		GetCurrentValueDemo demo = new GetCurrentValueDemo("CLUSTERPROBE.resources.Cluster_NodeLists",server,port);		
		GetCurrentValueDemo demo1 = new GetCurrentValueDemo("CLUSTERPROBE.resources.Cluster_GroupLists",server,port);
		try {
		Thread.sleep(200);
		}catch(Exception eee){};
		int kk = 0;
		for (kk=0;kk<10;kk++)
		{
			if (demo.over&&demo1.over)
				break;
			try {
			Thread.sleep(2000);
			}catch(Exception exp){};
		}	
		if (kk==10) {
			out.println("<br><h2>"+server+" Not reachable!</h2>");
			break;
		}

		if (!demo.success)	
		{
			out.println("<br><h2>Error:"+demo.errMessage+"</h2>");
			break;
		}

		if (!demo1.success)	
		{
			out.println("<br><h2>Error:"+demo1.errMessage+"</h2>");
			break;
		}
	
		Vector dv = null;
		Vector dv1 = null;
		try {
		dv = (Vector)demo.value.elementAt(0);
		dv1 = (Vector)demo1.value.elementAt(0);
		}catch(Exception ed){};
		if (dv==null) {
			out.println("<br><h2>Error: no hosts available!</h2>");
			break;
		}
		if (dv1==null) {
			out.println("<br><h2>Error: no group available!</h2>");
			break;
		}

		Enumeration hostEn = dv.elements();
		Enumeration groupEn = dv1.elements();

		ResourceTable rs0,rs1;
		try {
		rs0 = (ResourceTable)Class.forName("CLUSTERPROBE.resources.Cluster_NodeLists").newInstance();
		rs1 = (ResourceTable)Class.forName("CLUSTERPROBE.resources.Cluster_GroupLists").newInstance();
		}catch(Exception re) {
			out.println("<br><h2>Error:"+re.toString()+"</h2>");
			break;
		}

		out.println("<form>");
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		if (hOpt==0)
		{
			out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>Select hosts</b></i></font></td></tr><tr><td></td></tr><tr>");
			String[] eeNames = rs0.getEntryNames();
			for (int i=0;i<eeNames.length;i++)
				out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>"+eeNames[i]+"</b></font></td>");
			out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
			out.println("</tr>");
			while (hostEn.hasMoreElements())
			{
				ResourceTableData data = (ResourceTableData) hostEn.nextElement();
				Vector vt = data.getRecord();
				if (((Integer)vt.elementAt(4)).intValue()!=0)
					continue;
				out.println("<tr>");
				for (int i=0;i<vt.size();i++)
					out.println("<td nowrap>"+vt.elementAt(i)+"</td>");
				String hostname = (String) vt.elementAt(1);
				if (hosts!=null&&(hosts.indexOf(hostname))!=-1) 
					out.println("<td nowrap><input type=checkbox name=\""+hostname+"\" checked></td>");
				else 
					out.println("<td nowrap><input type=checkbox name=\""+hostname+"\"></td>");
				out.println("</tr>");
			}
		}
		else
		{
			groupToHost = new Hashtable();
			while (hostEn.hasMoreElements())
			{
				ResourceTableData data = (ResourceTableData) hostEn.nextElement();
				Vector vt = data.getRecord();
				if (((Integer)vt.elementAt(4)).intValue()!=0)
					continue;
				String groupname = (String) vt.elementAt(2);
				Vector gv = new Vector();
				if (groupToHost.containsKey(groupname))
					gv = (Vector) groupToHost.get(groupname);
				else
					groupToHost.put(groupname,gv);
				gv.addElement((String)vt.elementAt(1));
			}

			out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>Select groups</b></i></font></td></tr><tr><td></td></tr><tr>");
			String[] eeNames = rs1.getEntryNames();
			for (int i=0;i<eeNames.length;i++)
				out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>"+eeNames[i]+"</b></font></td>");
			out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Selected</b></font></td>");
			out.println("</tr>");
			while (groupEn.hasMoreElements())
			{
				ResourceTableData data = (ResourceTableData) groupEn.nextElement();
				Vector vt = data.getRecord();
				out.println("<tr>");
				for (int i=0;i<vt.size();i++)
					out.println("<td nowrap>"+vt.elementAt(i)+"</td>");
				String hostname = (String) vt.elementAt(0);
				if (hosts!=null&&(hosts.indexOf(hostname))!=-1) 
					out.println("<td nowrap><input type=checkbox name=\""+hostname+"\" checked></td>");
				else 
					out.println("<td nowrap><input type=checkbox name=\""+hostname+"\"></td>");
				out.println("</tr>");
			}
		}
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=3 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",4,false,this.form)\'>");
		out.println("<input type=button name=next value=Next onClick=\'relocation(\""+server+"\",4,true,this.form)\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;
	case 5:
		out.println("<form>");
		out.println("<table cellspacing=4 cellpadding=2 align=center border=2 nowrap>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=3 nowrap><font color=#ffffff size=5><i><b>Monitor Slots</b></i></font></td></tr><tr><td></td></tr><tr>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Minimum Slot</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Check Slot</b></font></td>");
		out.println("<td bgcolor=#f0f000 align=center nowrap><font color=#0000ff><b>Report Slot</b></font></td>");
		out.println("</tr>");
		out.println("<tr>");
		out.println("<td nowrap>"+rs.getMinTime()+"</td>");
		if (slots==null)
		{
			out.println("<td nowrap><input type=text name=cslot size=3 maxlength=3 value=2></td>");
			out.println("<td nowrap><input type=text name=rslot size=3 maxlength=3 value=1></td>");
		}
		else {
			StringTokenizer st1 = new StringTokenizer(slots);
			int cslot= -1;
			int rslot = -1;
			try {
				cslot = Integer.parseInt(st1.nextToken().trim());
				rslot = Integer.parseInt(st1.nextToken().trim());
			}catch(Exception excp){};
			if (cslot!=-1&&rslot!=-1)
			{
				out.println("<td nowrap><input type=text name=cslot size=3 maxlength=3 value="+cslot+"></td>");
				out.println("<td nowrap><input type=text name=rslot size=3 maxlength=3 value="+rslot+"></td>");
			}
			else
			{
				out.println("<td nowrap><input type=text name=cslot size=3 maxlength=3 value=2></td>");
				out.println("<td nowrap><input type=text name=rslot size=3 maxlength=3 value=1></td>");
			}
		}

		out.println("</tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=3 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",5,false,this.form)\'>");
		out.println("<input type=button name=next value=Next onClick=\'relocation(\""+server+"\",5,true,this.form)\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;
	case 6:
		int[] e1Types =((ResourceTable)rs).getEntryType();
		out.println("<form>\n");
		out.println("<br><table cellspacing=4 cellpadding=2 align=center border=2 nowrap>\n");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#000000 align=center colspan=1 nowrap><font color=#ffffff size=5><b><i>Select Display Type</i></b></font></td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td bgcolor=#f0f000 align=center nowrap><select name=dtype size=1 RpGetType=complex RpSetType=complex>");
		for (int i=0;i<2;i++)
		{
			if (i==displayType)
				out.println("<option selected>"+displayTypes[i]);
			else
				out.println("<option>"+displayTypes[i]);
		}

		boolean chartEnable = true;
		for (int i=0;i<entryIndex.length;i++)
			if (e1Types[entryIndex[i]]!=Resource.LONG&&e1Types[entryIndex[i]]!=Resource.SHORT&&e1Types[entryIndex[i]]!=Resource.DOUBLE&&e1Types[entryIndex[i]]!=Resource.FLOAT)
			{
				chartEnable = false;
				break;
			}

		if (chartEnable)
		{
			for (int i=2;i<8;i++)
			{
				if (i==displayType)
					out.println("<option selected>"+displayTypes[i]);
				else
					out.println("<option>"+displayTypes[i]);
			}

			if (entryIndex.length==1)
				if (displayType==8)
					out.println("<option selected>"+displayTypes[8]);
				else
					out.println("<option>"+displayTypes[8]);
		}

		out.println("</select>\n");
		out.println("</td></tr>");
		out.println("<tr><td></td></tr>");
		out.println("<tr><td align=left colsapn=1 nowrap>");
		out.println("<input type=button name=back value=Back onClick=\'relocation(\""+server+"\",6,false,this.form)\'>");
		out.println("<input type=button name=next value=Finished onClick=\'relocation(\""+server+"\",6,true,this.form)\'>");
		out.println("</td></tr>");
		out.println("</table></form>");
		break;
	case 7:
		out.println("</head>");
		switch(displayType)
		{
		case 0:
		case 1:
		case 4:
		case 5:
		case 6:
		case 8:
			out.println("<frameset rows=\"0,*\">");
			String query = request.getQueryString();
			query = replaceStep(query,8);
			out.println("<frame scrolling=yes name=applet_frame src=\"http://"+server+":8080/servlet/cics_monitor?"+query+"\" frameborder=0>");
			out.println("<frame scrolling=yes src=\"http://"+server+"/blank.html\" name=display_frame marginwidth=20 marginheight=20 frameborder=0>");
			out.println("</frameset><noframes><P>Sorry, your browser does not support frame, Please use other browsers which support frame to view the page correctly.</p></noframes>");
			break;
		case 2:
			out.println("<body background=\"http://"+server+"/back1.jpg\" nosave>");
			out.println("<center>");

			StringTokenizer stk = new StringTokenizer(hosts,"|");
			int wtc = stk.countTokens()/5;
			if ((stk.countTokens()%5)!=0)
				wtc++;

//out.println("<center><b><font face=\"Arial,Helvetica\"><font size=15>WorkLoad Tables</font></font></b></center>");
			out.println("<applet name=\"monitor\" code=graph.MonitorStripChart archive=clusterprobe.jar width=680 height="+(wtc*290)+">");
			out.println("<param name=marker value=\"http://"+server+"/marker.txt\">");
			out.println("<param name=resource value=\""+objs[rindex]+"\">");
			out.println("<param name=entry value="+request.getParameter("entries")+">");
			out.println("<param name=hosts value="+hosts+">");
			out.println("<param name=interval value="+slots+">");
			out.println("</applet>");
			out.println("<form><input type=button value=\"  Stop  \" onclick='stop()'></form>");
			out.println("</center>");
			out.println("</body>");
			break;
		case 3:
			out.println("<body background=\"http://"+server+"/back1.jpg\" nosave>");
			out.println("<center>");

			StringTokenizer stk0 = new StringTokenizer(request.getParameter("entries"),"|");
			int wtc0 = stk0.countTokens()/2;
			if ((stk0.countTokens()%2)!=0)
				wtc0++;

			out.println("<applet name=\"monitor\" code=graph.MonitorStripChartA archive=clusterprobe.jar width=500 height="+(wtc0*270)+">");
			out.println("<param name=marker value=\"http://"+server+"/marker.txt\">");
			out.println("<param name=resource value=\""+objs[rindex]+"\">");
			out.println("<param name=entry value="+request.getParameter("entries")+">");
			out.println("<param name=hosts value="+hosts+">");
			out.println("<param name=interval value="+slots+">");
			out.println("</applet>");
			out.println("<form><input type=button value=\"  Stop  \" onclick='stop()'></form>");
			out.println("</center>");
			out.println("</body>");
			break;
		case 7:
			out.println("<body background=\"http://"+server+"/back1.jpg\" nosave>");
			out.println("<center>");

			StringTokenizer stk1 = new StringTokenizer(hosts,"|");
			int wtc1 = stk1.countTokens()/4;
			if ((stk1.countTokens()%4)!=0)
				wtc1++;

//out.println("<center><b><font face=\"Arial,Helvetica\"><font size=15>Memory Statistics</font></font></b></center>");
			out.println("<applet name=\"monitor\" code=graph.MonitorPieChart archive=clusterprobe.jar width=680 height="+(wtc1*180)+">");
			out.println("<param name=resource value=\""+objs[rindex]+"\">");
			out.println("<param name=entry value="+request.getParameter("entries")+">");
			out.println("<param name=hosts value="+hosts+">");
			out.println("<param name=interval value="+slots+">");
			out.println("</applet>");
			out.println("<form><input type=button value=\"  Stop  \" onclick='stop()'></form>");
			out.println("</center>");
			out.println("</body>");
			break;
		}
		out.println("</html>");
		out.close();
		break;
	case 8:
		int minTime =rs.getMinTime();
		ResourceTable rtable = (ResourceTable) rs;
		String[] entryNames = rtable.getEntryNames();

		switch (displayType)
		{
			case 0:
				out.println("<script src=\"http://"+server+"/sheet1.js\" language=javascript></script>");
				break;
			case 1:
				out.println("<script src=\"http://"+server+"/sheet2.js\" language=javascript></script>");
				break;
			case 4:
				out.println("<script src=\"http://"+server+"/graph.js\" language=javascript></script>");
				out.println("<script src=\"http://"+server+"/graphIII.js\" language=javascript></script>");
				break;
			case 5:
				out.println("<script src=\"http://"+server+"/graph.js\" language=javascript></script>");
				out.println("<script src=\"http://"+server+"/graphIV.js\" language=javascript></script>");
				break;
			case 6:
				out.println("<script src=\"http://"+server+"/graph.js\" language=javascript></script>");
				out.println("<script src=\"http://"+server+"/graphV.js\" language=javascript></script>");
				break;
			case 8:
				out.println("<script src=\"http://"+server+"/Iled4.js\" language=javascript></script>");
				out.println("<script src=\"http://"+server+"/led.js\" language=javascript></script>");
				break;
		}

		out.println("<script language=javascript>");
		out.println("var header = new Array();");
		out.println("var stitle = \""+rns[rindex]+"\";"); 
		out.println("var server = \""+server+"\";");

		StringTokenizer stn = new StringTokenizer(slots,"|");
		int cslot= 2;
		int rslot = 1;
		try {
			cslot = Integer.parseInt(stn.nextToken().trim());
			rslot = Integer.parseInt(stn.nextToken().trim());
		}catch(Exception stne){};

		out.println("var timeout = "+(minTime*cslot*rslot)+";");

		
		out.println("header[0] = \""+rtable.getKeyName()+"\";");

		if (entryIndex != null)
			for (int i=0;i<entryIndex.length;i++)
				out.println("header["+(i+1)+"] = \""+entryNames[entryIndex[i]]+"\";");

		if (rtable.getTableType() == ResourceTable.SIGLETABLE)
			out.println("var single = true;");
		else
			out.println("var single = false;");

		out.println("</script>");
		out.println("</head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" onLoad=\"timeONE=window.setTimeout('startclock()',3000)\" nosave>");
		out.println("<center>");
		
		switch (displayType)
		{
		case 0:
		case 1:
		case 4:
		case 5:
		case 6:
		case 8:
			out.println("<applet name=\"monitor\" code=graph.MonitorApplet archive=clusterprobe.jar width=0 height=0>");
			break;
		}

		out.println("<param name=resource value=\""+objs[rindex]+"\">");
		out.println("<param name=entry value="+request.getParameter("entries")+">");
		out.println("<param name=hosts value="+hosts+">");
		out.println("<param name=interval value="+cslot+"|"+rslot+">");
		out.println("</applet>");
		break;
	case 9:
		out.println("</head>");
		String qs = request.getQueryString();
		qs = replaceStep(qs,7);
		out.println("<body background=\"http://"+server+"/back1.jpg\" onLoad='history.go(\"http://"+server+":8080/servlet/cics_monitor?"+qs+"\")'nosave>");
		out.println("<center>");
		break;
	}
	out.println("</center></body></html>");
	out.close();
}

String replaceStep(String s, int step)
{
	if (s==null) return null;
	int index = s.indexOf("=");
	if (index==-1) return s;
	String sss = s.substring(0,index+1)+step+s.substring(index+2,s.length());
	return sss;
}

String transGroup(String h)
{
	if (h==null) return h;
	StringTokenizer st = new StringTokenizer(h,"|");
	String newH = "";
	while (st.hasMoreTokens())
	{
		String gn = st.nextToken();
		Vector vt = (Vector) groupToHost.get(gn);
		if (vt!=null)
		{
			for (int i=0;i<vt.size();i++)
			{
				if (newH.equals(""))
					newH = (String) vt.elementAt(i);
				else
					newH = newH + "|"+ (String)vt.elementAt(i);
			}
		}
		else
		{
			if (newH.equals(""))
				newH = gn;
			else
				newH = newH + "|" + gn;
		}
	}
	return newH;
}
	
}
