import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.demo.*;
import CLUSTERPROBE.resources.Resource;
import CLUSTERPROBE.resources.ResourceTable;
import CLUSTERPROBE.message.ResourceTableData;

// modified by Wanglin , 01/09/07
// Show HA node's Dynamical status
public class CICS_ShowHAnodeStatus extends HttpServlet
{

// Handle the HTTP POST method
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
{
	//set content type header before accessing the Writer
	response.setContentType("text/html");
	PrintWriter out = response.getWriter();

	String server = null;
	int port = 0;
	try{
	server = InetAddress.getLocalHost().getHostName();
	port = 7001;
	}catch(Exception ee){
		out.println("<html><head><title>Error Server</title></head>");
		out.println("<body background=\"http://"+server+"/back1.jpg\" nosave><center><br><h2>No CICS Server</h2></center></body>");
		out.println("</html>");
		out.close();
		return;
	}

	out.println("<BASE href=\"http://"+server+"/srg/html/\">");
 	out.println("<html><META http-equiv='refresh' content='20,URL=/'>");
	out.println("<head>");
	out.println("<title>HA nodes Status</title>");
	out.println("<script src=\"../code/default_status.js\" language=javascript></script>");

	//get status from info server
	GetCurrentValueDemo demo = new GetCurrentValueDemo("CLUSTERPROBE.resources.Cluster_HAnode_StatusTable",server,port);
	try{Thread.sleep(2000);}catch(Exception eee){};
	int kk= 0;
	for (kk=0;kk<10;kk++)
	{
		if (demo.over)
			break;
		try{Thread.sleep(2000);}catch(Exception exp){};
	}
	if (kk==10) {
		out.println("</head>");
		out.println("<body>");
		out.println("<br><center><h2>"+server+" Not reachable!</h2></center>");
		out.println("</body>");
		out.println("</html>");
		out.close();
		return;
	}
	if (!demo.success)
	{
		out.println("</head>");
		out.println("<body>");
		out.println("<br><center><h2>Error:"+demo.errMessage+"</h2></center>");
		out.println("</body>");
		out.println("</html>");
		out.close();
		return;
	}
	Vector dv = null;
	try {
	dv = (Vector)demo.value.elementAt(0);
	}catch(Exception ed){};
	if (dv==null)
	{
		out.println("</head>");
		out.println("<body>");
		out.println("<br><center><h2>Error: can't retrieve status info!</h2></center>");
		out.println("</body>");
		out.println("</html>");
		out.close();
		return;
	}

	out.println("<script language=javascript>");
	Enumeration statusEn = dv.elements();
	while (statusEn.hasMoreElements())
	{
		ResourceTableData data = (ResourceTableData) statusEn.nextElement();
		Vector vt = data.getRecord();
		String hostname = trimHost((String)vt.elementAt(0));
		if (hostname==null) continue;
		int status = ((Integer)vt.elementAt(1)).intValue();
		if (hostname.startsWith("fast"))
			out.println("fast_cl[\""+hostname+"\"]="+status+";");	
		else if (hostname.startsWith("wchip"))
			out.println("wchip_cl[\""+hostname+"\"]="+status+";");	
		else if (hostname.startsWith("ostrich"))
			out.println("wchip_cl[\""+hostname+"\"]="+status+";");	
		else if (hostname.startsWith("real"))
			out.println("wchip_cl[\""+hostname+"\"]="+status+";");	
		else if (hostname.startsWith("dx")||hostname.startsWith("alr"))
			out.println("power_cl[\""+hostname+"\"]="+status+";");	
		else
			out.println("standard_cl[\""+hostname+"\"]="+status+";");	
	}
	out.println("</script>");

	out.println("<script src=\"../code/show_status1.js\" language=javascript></script>");
	out.println("</head>");
	out.println("<body bgcolor=#ffffff>");
	out.println("<center>");
	out.println("<script language=javascript>");
	out.println("showStatus(self);");
	out.println("</script>");
	out.println("</center>");
	out.println("</body>");
	out.println("</html>");
	out.close();
}

String trimHost(String s)
{
	if (s==null) return s;
	StringTokenizer st = new StringTokenizer(s,".");
	if (st.countTokens()==0) return s;
	return st.nextToken();
}

}
