// Author: WangLin 
// Last modified : 01/7/24

//package JESSIC.resources;
package CLUSTERPROBE.resources;
 
import java.util.*;
import java.io.*;
import java.lang.*;

public class Cluster_HAapp_StatusTable extends ResourceTable
{
	boolean debugflag=false;
	String[] entryNames = {"WorkstationName","State","Description"};
	int[] entryTypes = {Resource.STRING,Resource.STRING,Resource.STRING};
	int[] entryMaxLen = {16,400,25};
		
	static String[] desc = {"Ready","Ready","Overload","Ready", "Swap_Closing_Full","Ready","Unreach","Ready", "Ready","Unreach","Ready","Ready", "Ready","Package_Losing","Ready","Ready"};

    static int[] st = {1,1,3,1, 3,1,2,1, 1,2,1,1, 1,3,1,1};
	
	static int count = 0;
	static int loop = 0;
	static int tempCount = 0;

	static int UPDATETIME=1000;
	static float loadLimited = (float)1.0;
	static int swapLimited = 500; 
	static int packetsReceived = 0;
	static int inDiscarded=0;
	static int packetsSent = 0;
	static int outDroped=0;
	static double losingLimited = 0.20;
	static boolean firstTime = true;

	Float[] loads = new Float[3];
	String state = "";
	String description = "READY";

	public Cluster_HAapp_StatusTable() {
		setUpdateTime(UPDATETIME);
		setMinTime(500);
	}

	public Vector getVector() throws java.rmi.ServerRuntimeException
	{
		refresh();

        Vector v = new Vector();
        v.addElement(Util.getHostName());
		v.addElement(state);
		v.addElement(description);
		count++;
        return v;
    }

	public void refresh()
	{
		if (firstTime) firstTime = false;

		state ="";
		description = "READY";

		//refresh information
		getprocess("heartbeat");
		if (description.equals("READY"))
		{	
			getprocess("mon");
		}
		if(description.equals("READY"))
		// if HA Ready, get HA application status on this node
		{
			getAppStatus();
			if (debugflag) System.out.println("getAppStatus()");
			if(debugflag) System.out.println("state:"+state);
		}
	}
	public void getAppStatus()
	{
		// read haresources file to get application list
		String filename="/etc/ha.d/haresources";
		try 
		{
			RandomAccessFile in=new RandomAccessFile(filename,"r");
			Vector app=new Vector();
		
			String line="";
			while((line=in.readLine())!=null)
			{
			
				if(debugflag) System.out.println("Line:"+line);
				if(!line.startsWith("#"))
				{
					StringTokenizer st1=new StringTokenizer(line," ");
					String word=null;
					//System.out.println("st1.countTokens="+st1.countTokens());
					int le=0;
					if(st1.countTokens()>=3)
					{
						word=st1.nextToken();
						word=st1.nextToken();
						while(st1.hasMoreTokens())
							app.addElement(st1.nextToken());
					}
				}
			}
			in.close();
			if(debugflag) System.out.println("end of read haresources");
		
			state="";  
		// run application.monitor one by one , get result, yes=1,no=0
		// state: &app1name=0/1&app2name=0/1&app3name=0/1... max application number is 20
			Enumeration statusEn = app.elements();
			
			while(statusEn.hasMoreElements())
			{
				state=state+"&"+getappsta((String)statusEn.nextElement());
				if(debugflag) System.out.println("state:"+state);
			}
		
		// Description is for HA software status. Ready or NotReady ;
		}catch(Exception e)
		{
			System.out.println("Exception1:"+e);
		}		
	
	}
	public String getappsta(String appname) 
	{
		String result="";
		try 
		{
			String com = "/usr/lib/mon/mon.d/"+appname+".monitor";
			Process p = Util.runCommand(com);
			String errMessage = Util.getProcessErrMsg(p);
			if (errMessage!=null) {
				System.out.println("process run error:"+errMessage);
				return result;
			}

			DataInputStream in = new DataInputStream(p.getInputStream());	
			BufferedReader d = new BufferedReader(new InputStreamReader(in));

			String line = null;
			line=d.readLine();
			if(debugflag) System.out.println("app.monitor:\nline is:"+line);
			if(line==null)
			{
				System.out.println("not result line.");
				p.destroy();
				return result;
			}
			StringTokenizer st1=new StringTokenizer(line," ");
			if(st1.countTokens()!=1)
			{
				p.destroy();
				return result;
			}
			String proc=st1.nextToken();
			if (proc.equals("no")) 
			{
				p.destroy();
				result=appname+"=0";
			}
			else if(proc.equals("yes"))
			{		
				p.destroy();
				result=appname+"=1";
			}
		} catch(Exception e) {
			System.out.println("caused error while call system process:"+e.toString());
		}
		return result;
	}

	public void getprocess(String proname) 
	{
		try {
		String proname1 = "ps -e";
		Process p = Util.runCommand(proname1);
		String errMessage = Util.getProcessErrMsg(p);
		if (errMessage!=null) {
			System.out.println("process run error:"+errMessage);
			return;
		}

		DataInputStream in = new DataInputStream(p.getInputStream());	
		BufferedReader d = new BufferedReader(new InputStreamReader(in));

		String line = null;
		line=d.readLine();
		if(debugflag) System.out.println("run command:"+proname1+"\nline is:"+line);
		if(line==null)
		{
			System.out.println("not result line.");
			description = "NOTREADY";
			p.destroy();
			return;
		}
		do
		{
			StringTokenizer st1=new StringTokenizer(line," ");
			String proc=null;
			while(st1.hasMoreTokens())
				proc=st1.nextToken();
			if (proc.equals(proname)) 
			{
				description = "READY";
				break;
			}
		}while((line=d.readLine())!=null);
		
		if (line==null) 
		{
			description = "NOTREADY";
			p.destroy();
			return;
		}
		
		p.destroy();
		} catch(Exception e) {
			System.out.println("caused error while call system process:"+e.toString());
		}
	}

	public String[] getEntryNames() {
		return entryNames;
	}

	public String getKeyName() {
		return entryNames[0];
	}

	public int[] getEntryType() {
		return entryTypes;
	}

	public int getTableType() {
		return ResourceTable.SIGLETABLE;
	}

	public Vector getRange(String entryName)
	{
		return null;
	}

	public Vector getVectorExceptionProcess(String host, Exception e)
	{
		Vector v = new Vector();
		
		v.addElement(host);

		if (e instanceof java.net.MalformedURLException)
		{
			v.addElement("");
			v.addElement("Malformed URL");
		}

		if (e instanceof java.rmi.UnknownHostException)
		{
			v.addElement("");
			v.addElement("Unkown host");
		}

		if (e instanceof java.rmi.ConnectIOException)
		{
			v.addElement("");
			v.addElement("Unreachable");
		}
		else {
			v.addElement("");
			v.addElement("RMI not ready");
		}
		return v;
	}
	public int getEntryMaxLen(int id)
	{
		return entryMaxLen[id];
	}
	
	public static void main(String[] args) {
		Cluster_HAapp_StatusTable rs = new Cluster_HAapp_StatusTable();
		rs.refresh();
		System.out.println(rs.state+": "+rs.description);
		try {
			Thread.sleep(5000);
		}catch(Exception e){};
		rs.refresh();
		System.out.println(rs.state+": "+rs.description);
	}

	public String getDesc()
	{
		return "HA application Status";
	}
}
