import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;

import CLUSTERPROBE.message.*;
import CLUSTERPROBE.manipulate.*;
import CLUSTERPROBE.security.*;
import CLUSTERPROBE.demo.GetCurrentValueDemo;

public class ManEventHandler implements EventHandler
{
Hashtable ht = new Hashtable();
ManipulateEvent reg = null;
PrintWriter out = null;
int num;
Vector hts = new Vector();

	public ManEventHandler(ManipulateEvent m, PrintWriter out)
	{
		this.out = out;
		reg = m;

		String[] sg = m.getTargets();
		
		num = 0;
		for (int i=0;i<sg.length;i++)
		{
			if (CICS_Manipulate.groupToHost.containsKey(sg[i]))
			{
				Vector vt = (Vector) CICS_Manipulate.groupToHost.get(sg[i]);
				for (int j=0;j<vt.size();j++)
					hts.addElement(vt.elementAt(j));
				num = num + vt.size();
			}
			else
			{
				hts.addElement(sg[i]);
				num++;
			}
		}

		out.println("<table cols=5 width=100%>");
		for (int i=0;i<hts.size();i++)
		{
			if (i==0)
				out.println("<tr>");
			else if ((i%5)==0)
				out.println("</tr><tr>");
			out.println("<td align=left><a href=\"#"+hts.elementAt(i)+"\">"+hts.elementAt(i)+"</a></td>");
		}
		if ((hts.size()%5)!=0)
			out.println("</tr>");
		out.println("</table><br>");
	}

	public boolean isEnd()
	{
		if (num<=0) return true;
		return false;
	}

	public void handleEvent(JessicEvent e)
	{
		int id = e.getId();
		if (id==JessicEvent.MANIPULATERESULT)
		{
			System.out.println("GET event:JessicaEvent.MANIPULATIERESULT");
			ManipulateResultEvent evt = (ManipulateResultEvent) e;
			if (!(reg.getName().equals(evt.getName())))
					return;
			if (reg.getTime()!=evt.getRegisterTime())
					return;

			String source = evt.getOperateSource();
System.out.println(source+" "+evt.isEnd());
			String link = getLink(source);
			if (!ht.containsKey(source))
			{
				if (evt.isEnd())
				{
					System.out.print("\n"+evt.getOperateSource()+":\n"+evt.getResult());
					out.println("<a name=\""+link+"\">");
					if (evt.isSuccess())
					{
						out.println("<br>"+evt.getOperateSource()+" Completed<br>--------------------------------------------------------------<br>"+stringToHtml((String)evt.getResult()));
						out.println("<p><br>");
						num--;
					}
					else
					{
						out.println("<br><font color=red>"+evt.getOperateSource()+" Fail<br>--------------------------------------------------------------</font><br>"+stringToHtml((String)evt.getResult()));
						out.println("<p><br>");
						if (!reg.isForce())
							num = 0;		
						else
							num--;
					}
					out.println("</a>");
				}
				else 
				{
					Vector vt = new Vector(); 
					ht.put(source,vt);
					vt.addElement(evt.getResult());
				} 
			}
			else
			{
				Vector vt = (Vector) ht.get(source);
				vt.addElement(evt.getResult());
				if (evt.isEnd()) 
				{ 
					out.println("<a name=\""+link+"\">");
					for (int kk=0;kk<vt.size();kk++) 
					{ 
						if (kk==0) 
						{
							if (evt.isSuccess())
							{
								out.println("<br>"+evt.getOperateSource()+" Completed<br>----------------------------------------------------------------------<br>");
								num--;
							}
							else
							{
								out.println("<br><font color=red>"+evt.getOperateSource()+" Fail<br>----------------------------------------------------------------------</font><br>");
								if (!reg.isForce())
									num = 0;
								else
									num--;
							}
							out.println(vt.elementAt(kk));
							System.out.print("\n"+evt.getOperateSource()+":\n"+stringToHtml((String)vt.elementAt(kk))); 
						}
						else 
						{
							out.println(vt.elementAt(kk));
							System.out.print(vt.elementAt(kk)); 
						}
					}
					out.println("<p><br>");
					out.println("</a>");
				}
			}
		}
		else if (id==JessicEvent.ERROR)
		{
			System.out.println("GET event:JessicaEvent.ERROR");
			ManipulateErrorEvent err = null;
			try {
			err = (ManipulateErrorEvent) e;
			}catch(Exception exp){return;}
			if (err==null) return;

			if (!(reg.getName().equals(err.getName())))
				return;
			if (reg.getTime()!=err.getRegisterTime())
				return;

			System.out.println(err.getErrorSource());
			System.out.println(err.getErrMessage());
			String link = getLink(err.getErrorSource());
			out.println("<a name=\""+link+"\">");
			out.println("<br><font color=red>"+err.getErrorSource()+" Fail<br>----------------------------------------------</font><br>"+stringToHtml(err.getErrMessage()));
			out.println("<p><br>");
			out.println("</a>");
			num--;
		}

	}

	public String stringToHtml(String s)
	{
		if (s==null) return s;
		while (true)
		{
			int index = s.indexOf("\n");
			if (index==-1) return s;

			if (index!=(s.length()-1))
				s = s.substring(0,index)+"<br>"+s.substring(index+1,s.length());
			else
				s = s.substring(0,index)+"<br>";
		}
	}


	String getLink(String s)
	{
		if (hts==null||s==null) return s;
		Enumeration en = hts.elements();
		while (en.hasMoreElements())
		{
			String ss = (String)en.nextElement();
			if (s.startsWith(ss))
				return ss;
		}
		return s;
	}

}
